searchData={"items":[{"type":"task","title":"mix soft_bank.install","doc":"After configuring your default ecto repo in `:ecto_repos`\n  Run mix SoftBank.install to generates a `setup_softbank_tables` migration,\n  which creates your accounts, entries, and amounts tables, as well as\n  required indexes.","ref":"Mix.Tasks.SoftBank.Install.html"},{"type":"function","title":"Mix.Tasks.SoftBank.Install.run/1","doc":"","ref":"Mix.Tasks.SoftBank.Install.html#run/1"},{"type":"module","title":"SoftBank","doc":"The Main Interface for the Application","ref":"SoftBank.html"},{"type":"function","title":"SoftBank.add_currency/1","doc":"Add a currency to the db and load into the ledger system","ref":"SoftBank.html#add_currency/1"},{"type":"function","title":"SoftBank.balance/1","doc":"","ref":"SoftBank.html#balance/1"},{"type":"function","title":"SoftBank.convert/2","doc":"","ref":"SoftBank.html#convert/2"},{"type":"function","title":"SoftBank.create/1","doc":"Create a new account","ref":"SoftBank.html#create/1"},{"type":"function","title":"SoftBank.deposit/2","doc":"","ref":"SoftBank.html#deposit/2"},{"type":"function","title":"SoftBank.description/0","doc":"","ref":"SoftBank.html#description/0"},{"type":"function","title":"SoftBank.login/1","doc":"Login to the account\nThis will start a genserver to act as an accountant to abstract transactions.","ref":"SoftBank.html#login/1"},{"type":"function","title":"SoftBank.show/1","doc":"","ref":"SoftBank.html#show/1"},{"type":"function","title":"SoftBank.source_url/0","doc":"","ref":"SoftBank.html#source_url/0"},{"type":"function","title":"SoftBank.transfer/3","doc":"","ref":"SoftBank.html#transfer/3"},{"type":"function","title":"SoftBank.version/0","doc":"","ref":"SoftBank.html#version/0"},{"type":"function","title":"SoftBank.withdrawl/2","doc":"","ref":"SoftBank.html#withdrawl/2"},{"type":"module","title":"SoftBank.Account","doc":"An Account represents accounts in the system which are of _asset_,\n_liability_, or _equity_ types, in accordance with the \"accounting equation\".\n\nEach account must be set to one of the following types:\n\n   | TYPE      | NORMAL BALANCE | DESCRIPTION                            |\n   | :-------- | :-------------:| :--------------------------------------|\n   | asset     | Debit          | Resources owned by the Business Entity |\n   | liability | Credit         | Debts owed to outsiders                |\n   | equity    | Credit         | Owners rights to the Assets            |\n\n Each account can also be marked as a _Contra Account_. A contra account will have it's\n normal balance swapped. For example, to remove equity, a \"Drawing\" account may be created\n as a contra equity account as follows:\n\n   `account = %SoftBank.Account{name: \"Drawing\", type: \"asset\", contra: true}`\n\n At all times the balance of all accounts should conform to the \"accounting equation\"\n\n   *Assets = Liabilities + Owner's Equity*\n\n Each account type acts as it's own ledger.\n\nFor more details see:\n\n[Wikipedia - Accounting Equation](http://en.wikipedia.org/wiki/Accounting_equation)\n[Wikipedia - Debits, Credits, and Contra Accounts](http://en.wikipedia.org/wiki/Debits_and_credits)","ref":"SoftBank.Account.html"},{"type":"function","title":"SoftBank.Account.account_balance/3","doc":"Computes the account balance for a given `SoftBank.Account` in a given\nEcto.Repo when provided with a map of dates in the format\n`%{from_date: from_date, to_date: to_date}`.\nReturns Decimal type.","ref":"SoftBank.Account.html#account_balance/3"},{"type":"function","title":"SoftBank.Account.bank_account_number/1","doc":"","ref":"SoftBank.Account.html#bank_account_number/1"},{"type":"function","title":"SoftBank.Account.changeset/2","doc":"Builds a changeset based on the `struct` and `params`.","ref":"SoftBank.Account.html#changeset/2"},{"type":"function","title":"SoftBank.Account.fetch/2","doc":"Fetch the Account from the Repo.","ref":"SoftBank.Account.html#fetch/2"},{"type":"function","title":"SoftBank.Account.new/1","doc":"Create new account with default ledgers","ref":"SoftBank.Account.html#new/1"},{"type":"function","title":"SoftBank.Account.new/2","doc":"","ref":"SoftBank.Account.html#new/2"},{"type":"function","title":"SoftBank.Account.test_balance/1","doc":"Computes a test balance for all accounts in the provided Ecto.Repo.\nReturns Money type.","ref":"SoftBank.Account.html#test_balance/1"},{"type":"type","title":"SoftBank.Account.t/0","doc":"An Account type.","ref":"SoftBank.Account.html#t:t/0"},{"type":"module","title":"SoftBank.Accountant.Supervisor","doc":"","ref":"SoftBank.Accountant.Supervisor.html"},{"type":"function","title":"SoftBank.Accountant.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"SoftBank.Accountant.Supervisor.html#child_spec/1"},{"type":"function","title":"SoftBank.Accountant.Supervisor.init/1","doc":"","ref":"SoftBank.Accountant.Supervisor.html#init/1"},{"type":"function","title":"SoftBank.Accountant.Supervisor.start/0","doc":"","ref":"SoftBank.Accountant.Supervisor.html#start/0"},{"type":"function","title":"SoftBank.Accountant.Supervisor.start_child/2","doc":"","ref":"SoftBank.Accountant.Supervisor.html#start_child/2"},{"type":"function","title":"SoftBank.Accountant.Supervisor.start_link/1","doc":"","ref":"SoftBank.Accountant.Supervisor.html#start_link/1"},{"type":"function","title":"SoftBank.Accountant.Supervisor.stop/1","doc":"","ref":"SoftBank.Accountant.Supervisor.html#stop/1"},{"type":"module","title":"SoftBank.Amount","doc":"An Amount represents the individual debit or credit for a given account and is\npart of a balanced entry.","ref":"SoftBank.Amount.html"},{"type":"function","title":"SoftBank.Amount.changeset/2","doc":"Creates an amount changeset associated with a `SoftBank.Entry` and `SoftBank.Account`.\nA type (\"credit\" or \"debit\"), as well as, an amount greater than 0 must be specified.","ref":"SoftBank.Amount.html#changeset/2"},{"type":"function","title":"SoftBank.Amount.new/2","doc":"","ref":"SoftBank.Amount.html#new/2"},{"type":"function","title":"SoftBank.Amount.note/1","doc":"","ref":"SoftBank.Amount.html#note/1"},{"type":"function","title":"SoftBank.Amount.select_type/2","doc":"","ref":"SoftBank.Amount.html#select_type/2"},{"type":"function","title":"SoftBank.Amount.validate_amount_type/1","doc":"","ref":"SoftBank.Amount.html#validate_amount_type/1"},{"type":"module","title":"SoftBank.Cldr","doc":"Provides the core functions to retrieve and manage\nthe CLDR data that supports formatting and localisation.\n\nIt provides the core functions to access formatted\nCLDR data, set and retrieve a current locale and validate\ncertain core data types such as locales, currencies and\nterritories.","ref":"SoftBank.Cldr.html"},{"type":"function","title":"SoftBank.Cldr.available_locale_name?/1","doc":"","ref":"SoftBank.Cldr.html#available_locale_name?/1"},{"type":"function","title":"SoftBank.Cldr.default_locale/0","doc":"Returns the default `locale`.","ref":"SoftBank.Cldr.html#default_locale/0"},{"type":"function","title":"Example - SoftBank.Cldr.default_locale/0","doc":"iex> SoftBank.Cldr.default_locale()\n    %Cldr.LanguageTag{\n      backend: SoftBank.Cldr,\n      canonical_locale_name: \"en-001\",\n      cldr_locale_name: :\"en-001\",\n      language_subtags: [],\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en-001\",\n      script: :Latn,\n      territory: :\"001\",\n      transform: %{},\n      language_variants: []\n    }","ref":"SoftBank.Cldr.html#default_locale/0-example"},{"type":"function","title":"SoftBank.Cldr.default_territory/0","doc":"Returns the default territory when a locale\ndoes not specify one and none can be inferred.","ref":"SoftBank.Cldr.html#default_territory/0"},{"type":"function","title":"Example - SoftBank.Cldr.default_territory/0","doc":"iex> SoftBank.Cldr.default_territory()\n    :\"001\"","ref":"SoftBank.Cldr.html#default_territory/0-example"},{"type":"function","title":"SoftBank.Cldr.ellipsis/2","doc":"Add locale-specific ellipsis to a string.","ref":"SoftBank.Cldr.html#ellipsis/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.ellipsis/2","doc":"* `string` is any `String.t` or a 2-element list\n  of `String.t` between which the ellipsis is inserted.\n\n* `backend` is any module that includes `use Cldr` and therefore\n  is a `Cldr` backend module.  The default is `Cldr.default_backend!/0`.\n  Note that `Cldr.default_backend!/0` will raise an exception if\n  no `:default_backend` is configured under the `:ex_cldr` key in\n  `config.exs`.\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.html#ellipsis/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.ellipsis/2","doc":"* `:locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n  The default is `Cldr.get_locale/0`.\n\n* `:location` determines where to place the ellipsis. The options are\n  `:after` (the default for a single string argument), `:between`\n  (the default and only valid location for an argument that is a list\n  of two strings) and `:before`.\n\n* `:format` formats based upon whether the ellipsis\n  is inserted between words or sentences. The valid options are\n  `:word` or `:sentence`. The default is `:sentence`.","ref":"SoftBank.Cldr.html#ellipsis/2-options"},{"type":"function","title":"Examples - SoftBank.Cldr.ellipsis/2","doc":"iex> SoftBank.Cldr.ellipsis \"And furthermore\"\n    \"And furthermore…\"\n\n    iex> SoftBank.Cldr.ellipsis [\"And furthermore\", \"there is much to be done\"], locale: :ja\n    \"And furthermore…there is much to be done\"\n\n    iex> SoftBank.Cldr.ellipsis \"And furthermore\", format: :word\n    \"And furthermore …\"\n\n    iex> SoftBank.Cldr.ellipsis [\"And furthermore\", \"there is much to be done\"], locale: :ja, format: :word\n    \"And furthermore … there is much to be done\"","ref":"SoftBank.Cldr.html#ellipsis/2-examples"},{"type":"function","title":"SoftBank.Cldr.get_locale/0","doc":"Return the current locale to be used for `Cldr` functions that\ntake an optional locale parameter for which a locale is not supplied.","ref":"SoftBank.Cldr.html#get_locale/0"},{"type":"function","title":"Example - SoftBank.Cldr.get_locale/0","doc":"iex> SoftBank.Cldr.put_locale(\"pl\")\n    iex> SoftBank.Cldr.get_locale\n    %Cldr.LanguageTag{\n       backend: Elixir.SoftBank.Cldr,\n       canonical_locale_name: \"pl\",\n       cldr_locale_name: :pl,\n       extensions: %{},\n       language: \"pl\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :pl,\n       territory: :PL,\n       requested_locale_name: \"pl\",\n       script: :Latn,\n       transform: %{},\n       language_variants: []\n     }","ref":"SoftBank.Cldr.html#get_locale/0-example"},{"type":"function","title":"SoftBank.Cldr.known_calendars/0","doc":"","ref":"SoftBank.Cldr.html#known_calendars/0"},{"type":"function","title":"SoftBank.Cldr.known_currencies/0","doc":"","ref":"SoftBank.Cldr.html#known_currencies/0"},{"type":"function","title":"SoftBank.Cldr.known_gettext_locale_name/1","doc":"Returns either the Gettext `locale_name` in Cldr format or\n`false` based upon whether the locale name is configured in\n`Gettext`.","ref":"SoftBank.Cldr.html#known_gettext_locale_name/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_gettext_locale_name/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_gettext_locale_names/0`","ref":"SoftBank.Cldr.html#known_gettext_locale_name/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_gettext_locale_name/1","doc":"iex> SoftBank.Cldr.known_gettext_locale_name \"en\"\n    \"en\"\n\n    iex> SoftBank.Cldr.known_gettext_locale_name \"en-SA\"\n    false","ref":"SoftBank.Cldr.html#known_gettext_locale_name/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_gettext_locale_name?/1","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Gettext.","ref":"SoftBank.Cldr.html#known_gettext_locale_name?/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_gettext_locale_name?/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.html#known_gettext_locale_name?/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_gettext_locale_name?/1","doc":"iex> SoftBank.Cldr.known_gettext_locale_name?(\"en\")\n    true\n\n    iex> SoftBank.Cldr.known_gettext_locale_name?(\"!!\")\n    false","ref":"SoftBank.Cldr.html#known_gettext_locale_name?/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_gettext_locale_names/0","doc":"Returns a list of Gettext locale names but in CLDR format with\nunderscore replaced by hyphen in order to facilitate comparisons\nwith `Cldr` locale names.","ref":"SoftBank.Cldr.html#known_gettext_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.known_locale_name/1","doc":"Returns either the `locale_name` or `false` based upon\nwhether the locale name is configured in `Cldr`.\n\nThis is helpful when building a list of `or` expressions\nto return the first known locale name from a list.","ref":"SoftBank.Cldr.html#known_locale_name/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_locale_name/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.html#known_locale_name/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_locale_name/1","doc":"iex> SoftBank.Cldr.known_locale_name :\"en-AU\"\n    :\"en-AU\"\n\n    iex> SoftBank.Cldr.known_locale_name :\"en-SA\"\n    false","ref":"SoftBank.Cldr.html#known_locale_name/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_locale_name?/1","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Cldr.","ref":"SoftBank.Cldr.html#known_locale_name?/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_locale_name?/1","doc":"* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.html#known_locale_name?/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_locale_name?/1","doc":"iex> SoftBank.Cldr.known_locale_name?(:en)\n    true\n\n    iex> SoftBank.Cldr.known_locale_name?(:\"!!\")\n    false","ref":"SoftBank.Cldr.html#known_locale_name?/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_locale_names/0","doc":"Returns a list of the known locale names.\n\nKnown locales are those locales which\nare the subset of all CLDR locales that\nhave been configured for use either\nin this module or in `Gettext`.","ref":"SoftBank.Cldr.html#known_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.known_number_system_types/0","doc":"Returns a list of atoms representing the number systems types known to `Cldr`.","ref":"SoftBank.Cldr.html#known_number_system_types/0"},{"type":"function","title":"Example - SoftBank.Cldr.known_number_system_types/0","doc":"iex> SoftBank.Cldr.known_number_system_types\n    [:default, :finance, :native, :traditional]","ref":"SoftBank.Cldr.html#known_number_system_types/0-example"},{"type":"function","title":"SoftBank.Cldr.known_number_systems/0","doc":"","ref":"SoftBank.Cldr.html#known_number_systems/0"},{"type":"function","title":"SoftBank.Cldr.known_rbnf_locale_name/1","doc":"Returns either the RBNF `locale_name` or `false` based upon\nwhether the locale name is configured in `Cldr`\nand has RBNF rules defined.","ref":"SoftBank.Cldr.html#known_rbnf_locale_name/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_rbnf_locale_name/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.html#known_rbnf_locale_name/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_rbnf_locale_name/1","doc":"iex> SoftBank.Cldr.known_rbnf_locale_name :en\n    :en\n\n    iex> SoftBank.Cldr.known_rbnf_locale_name :\"en-SA\"\n    false","ref":"SoftBank.Cldr.html#known_rbnf_locale_name/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_rbnf_locale_name?/1","doc":"Returns a boolean indicating if the specified locale\nname is configured and available in Cldr and supports\nrules based number formats (RBNF).","ref":"SoftBank.Cldr.html#known_rbnf_locale_name?/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.known_rbnf_locale_name?/1","doc":"* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.html#known_rbnf_locale_name?/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.known_rbnf_locale_name?/1","doc":"iex> SoftBank.Cldr.known_rbnf_locale_name?(:en)\n    true\n\n    iex> SoftBank.Cldr.known_rbnf_locale_name?(:\"!!\")\n    false","ref":"SoftBank.Cldr.html#known_rbnf_locale_name?/1-examples"},{"type":"function","title":"SoftBank.Cldr.known_rbnf_locale_names/0","doc":"Returns a list of locale names which have rules-based number\nformats (RBNF).","ref":"SoftBank.Cldr.html#known_rbnf_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.known_territories/0","doc":"","ref":"SoftBank.Cldr.html#known_territories/0"},{"type":"function","title":"SoftBank.Cldr.normalize_lenient_parse/3","doc":"Normalizes a string by applying transliteration\nof common symbols in numbers, currencies and dates","ref":"SoftBank.Cldr.html#normalize_lenient_parse/3"},{"type":"function","title":"SoftBank.Cldr.put_locale/1","doc":"Set the current locale to be used for `Cldr` functions that\ntake an optional locale parameter for which a locale is not supplied.","ref":"SoftBank.Cldr.html#put_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.put_locale/1","doc":"* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`\n  or a `t:Cldr.LanguageTag` struct returned by `SoftBank.Cldr.Locale.new!/1`\n\nSee [rfc5646](https://tools.ietf.org/html/rfc5646) for the specification\nof a language tag.","ref":"SoftBank.Cldr.html#put_locale/1-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.put_locale/1","doc":"iex> SoftBank.Cldr.put_locale(\"en\")\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: SoftBank.Cldr,\n       canonical_locale_name: \"en\",\n       cldr_locale_name: :en,\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: \"en\",\n       language: \"en\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :en,\n       requested_locale_name: \"en\",\n       script: :Latn,\n       territory: :US,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> SoftBank.Cldr.put_locale(\"invalid-locale!\")\n    {:error, {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"!\\\" starting at position 15\"}}","ref":"SoftBank.Cldr.html#put_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.quote/2","doc":"Add locale-specific quotation marks around a string.","ref":"SoftBank.Cldr.html#quote/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.quote/2","doc":"* `string` is any valid Elixir string\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.html#quote/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.quote/2","doc":"* `locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n  The default is `Cldr.get_locale/0`","ref":"SoftBank.Cldr.html#quote/2-options"},{"type":"function","title":"Examples - SoftBank.Cldr.quote/2","doc":"iex> SoftBank.Cldr.quote \"Quoted String\"\n    \"“Quoted String”\"\n\n    iex> SoftBank.Cldr.quote \"Quoted String\", locale: :ja\n    \"「Quoted String」\"","ref":"SoftBank.Cldr.html#quote/2-examples"},{"type":"function","title":"SoftBank.Cldr.unknown_locale_names/0","doc":"Returns a list of the locales names that are configured,\nbut not known in CLDR.\n\nSince there is a compile-time exception raised if there are\nany unknown locales this function should always\nreturn an empty list.","ref":"SoftBank.Cldr.html#unknown_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.validate_calendar/1","doc":"","ref":"SoftBank.Cldr.html#validate_calendar/1"},{"type":"function","title":"SoftBank.Cldr.validate_currency/1","doc":"","ref":"SoftBank.Cldr.html#validate_currency/1"},{"type":"function","title":"SoftBank.Cldr.validate_locale/1","doc":"Normalise and validate a locale name.","ref":"SoftBank.Cldr.html#validate_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.validate_locale/1","doc":"* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `SoftBank.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.html#validate_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.validate_locale/1","doc":"* `{:ok, language_tag}`\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.html#validate_locale/1-returns"},{"type":"function","title":"Notes - SoftBank.Cldr.validate_locale/1","doc":"See [rfc5646](https://tools.ietf.org/html/rfc5646) for the specification\nof a language tag.","ref":"SoftBank.Cldr.html#validate_locale/1-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.validate_locale/1","doc":"iex> SoftBank.Cldr.validate_locale(:en)\n    {:ok,\n    %Cldr.LanguageTag{\n      backend: SoftBank.Cldr,\n      canonical_locale_name: \"en\",\n      cldr_locale_name: :en,\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en\",\n      script: :Latn,\n      territory: :US,\n      transform: %{},\n      language_variants: []\n    }}\n\n\n    iex> SoftBank.Cldr.validate_locale SoftBank.Cldr.default_locale()\n    {:ok,\n    %Cldr.LanguageTag{\n      backend: SoftBank.Cldr,\n      canonical_locale_name: \"en-001\",\n      cldr_locale_name: :\"en-001\",\n      extensions: %{},\n      gettext_locale_name: \"en\",\n      language: \"en\",\n      locale: %{},\n      private_use: [],\n      rbnf_locale_name: :en,\n      requested_locale_name: \"en-001\",\n      script: :Latn,\n      territory: :\"001\",\n      transform: %{},\n      language_variants: []\n    }}\n\n    iex> SoftBank.Cldr.validate_locale(\"zzz\")\n    {:error, {Cldr.InvalidLanguageError, \"The language \\\"zzz\\\" is invalid\"}}","ref":"SoftBank.Cldr.html#validate_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.validate_number_system/1","doc":"","ref":"SoftBank.Cldr.html#validate_number_system/1"},{"type":"function","title":"SoftBank.Cldr.validate_number_system_type/1","doc":"Normalise and validate a number system type.","ref":"SoftBank.Cldr.html#validate_number_system_type/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.validate_number_system_type/1","doc":"* `number_system_type` is any number system type returned by\n  `Cldr.known_number_system_types/1`","ref":"SoftBank.Cldr.html#validate_number_system_type/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.validate_number_system_type/1","doc":"* `{:ok, normalized_number_system_type}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.html#validate_number_system_type/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.validate_number_system_type/1","doc":"iex> SoftBank.Cldr.validate_number_system_type :default\n    {:ok, :default}\n\n    iex> SoftBank.Cldr.validate_number_system_type :traditional\n    {:ok, :traditional}\n\n    iex> SoftBank.Cldr.validate_number_system_type :latn\n    {\n      :error,\n      {Cldr.UnknownNumberSystemTypeError, \"The number system type :latn is unknown\"}\n    }\n\n    iex> SoftBank.Cldr.validate_number_system_type \"bork\"\n    {\n      :error,\n      {Cldr.UnknownNumberSystemTypeError, \"The number system type \\\"bork\\\" is invalid\"}\n    }","ref":"SoftBank.Cldr.html#validate_number_system_type/1-examples"},{"type":"function","title":"SoftBank.Cldr.validate_territory/1","doc":"","ref":"SoftBank.Cldr.html#validate_territory/1"},{"type":"function","title":"SoftBank.Cldr.with_locale/2","doc":"Execute a function with a locale ensuring that the\ncurrent locale is restored after the function.","ref":"SoftBank.Cldr.html#with_locale/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.with_locale/2","doc":"* `locale` is any valid locale name returned by `Cldr.known_locale_names/1`.\n\n* `fun` is any 0-arity function or function capture.","ref":"SoftBank.Cldr.html#with_locale/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.with_locale/2","doc":"* The value returned by the function `fun/0` or\n\n* `{:error, {exception, reason}}` if the locale is invalid or\n\n* raises an exception if the current locale cannot be\n  identified.","ref":"SoftBank.Cldr.html#with_locale/2-returns"},{"type":"module","title":"SoftBank.Cldr.AcceptLanguage","doc":"Parses HTTP `Accept-Language` header values as defined in\n[rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4).\n\nThe Accept-Language request-header field is similar to Accept, but restricts\nthe set of natural languages that are preferred as a response to the request.\nLanguage tags function are provided in `Cldr.LanguageTag`.\n\nThe format of an `Accept-Language` header is as follows in `ABNF` format:\n\n       Accept-Language = \"Accept-Language\" \":\"\n                         1#( language-range [ \";\" \"q\" \"=\" qvalue ] )\n       language-range  = ( ( 1*8ALPHA *( \"-\" 1*8ALPHA ) ) | \"*\" )\n\nEach language-range MAY be given an associated quality value which represents an\nestimate of the user's preference for the languages specified by that range. The\nquality value defaults to \"q=1\". For example,\n\n       Accept-Language: da, en-gb;q=0.8, en;q=0.7\n\nwould mean: \"I prefer Danish, but will accept British English and other types of English.\"","ref":"SoftBank.Cldr.AcceptLanguage.html"},{"type":"function","title":"SoftBank.Cldr.AcceptLanguage.best_match/1","doc":"Parse an `Accept-Language` string and return the best match for\na configured `Cldr` locale.","ref":"SoftBank.Cldr.AcceptLanguage.html#best_match/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.AcceptLanguage.best_match/1","doc":"* `accept_langauge` is a string representing an accept language header","ref":"SoftBank.Cldr.AcceptLanguage.html#best_match/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.AcceptLanguage.best_match/1","doc":"* `{:ok, language_tag}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.AcceptLanguage.html#best_match/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.AcceptLanguage.best_match/1","doc":"iex> SoftBank.Cldr.AcceptLanguage.best_match(\"da;q=0.1,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: TestBackend.Cldr,\n       canonical_locale_name: \"zh-TW\",\n       cldr_locale_name: :\"zh-Hant\",\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: nil,\n       language: \"zh\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :\"zh-Hant\",\n       requested_locale_name: \"zh-TW\",\n       script: :Hant,\n       territory: :TW,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> SoftBank.Cldr.AcceptLanguage.best_match(\"da;q=0.1,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     %Cldr.LanguageTag{\n       backend: TestBackend.Cldr,\n       canonical_locale_name: \"zh-TW\",\n       cldr_locale_name: :\"zh-Hant\",\n       language_subtags: [],\n       extensions: %{},\n       gettext_locale_name: nil,\n       language: \"zh\",\n       locale: %{},\n       private_use: [],\n       rbnf_locale_name: :\"zh-Hant\",\n       requested_locale_name: \"zh-TW\",\n       script: :Hant,\n       territory: :TW,\n       transform: %{},\n       language_variants: []\n     }}\n\n    iex> SoftBank.Cldr.AcceptLanguage.best_match(\"xx,yy;q=0.3\")\n    {:error,\n     {Cldr.NoMatchingLocale,\n      \"No configured locale could be matched to \\\"xx,yy;q=0.3\\\"\"}}\n\n    iex> SoftBank.Cldr.AcceptLanguage.best_match(\"invalid_tag\")\n    {:error, {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}","ref":"SoftBank.Cldr.AcceptLanguage.html#best_match/1-examples"},{"type":"function","title":"SoftBank.Cldr.AcceptLanguage.parse/1","doc":"Parses an `Accept-Language` header value in its string\nor tokenized form to return a tuple of the form\n`{:ok, [{quality, %Cldr.LanguageTag{}}, ...]}` sorted by quality.","ref":"SoftBank.Cldr.AcceptLanguage.html#parse/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.AcceptLanguage.parse/1","doc":"* `accept-language` is any string in the format defined by\n  [rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4)\n\n* `backend` is any module that includes `use Cldr` and therefore\n  is a `Cldr` backend module","ref":"SoftBank.Cldr.AcceptLanguage.html#parse/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.AcceptLanguage.parse/1","doc":"* `{:ok, [{quality, language_tag}, ...]}` or\n\n* `{:error, {Cldr.AcceptLanguageError, String.t}}`\n\nIf at least one valid language tag is found but errors are also\ndetected on one more more tags, an `{ok, list}` tuple is returned\nwuth an error tuple for each invalid tag added at the end of the list.","ref":"SoftBank.Cldr.AcceptLanguage.html#parse/1-returns"},{"type":"function","title":"Example - SoftBank.Cldr.AcceptLanguage.parse/1","doc":"iex> Cldr.AcceptLanguage.parse(\"da,zh-TW;q=0.3\", TestBackend.Cldr)\n    {:ok,\n     [\n       {1.0,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"da\",\n          cldr_locale_name: :da,\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"da\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :da,\n          requested_locale_name: \"da\",\n          script: :Latn,\n          territory: :DK,\n          transform: %{},\n          language_variants: []\n        }},\n       {0.3,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"zh-TW\",\n          cldr_locale_name: :\"zh-Hant\",\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"zh\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :\"zh-Hant\",\n          requested_locale_name: \"zh-TW\",\n          script: :Hant,\n          territory: :TW,\n          transform: %{},\n          language_variants: []\n        }}\n     ]}\n\n    iex> SoftBank.Cldr.AcceptLanguage.parse(\"invalid_tag\")\n    {:error,\n     {Cldr.LanguageTag.ParseError,\n      \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n\n    iex> SoftBank.Cldr.AcceptLanguage.parse(\"da,zh-TW;q=0.3,invalid_tag\")\n    {:ok,\n     [\n       {1.0,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"da\",\n          cldr_locale_name: :da,\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"da\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :da,\n          requested_locale_name: \"da\",\n          script: :Latn,\n          territory: :DK,\n          transform: %{},\n          language_variants: []\n        }},\n       {0.3,\n        %Cldr.LanguageTag{\n          backend: TestBackend.Cldr,\n          canonical_locale_name: \"zh-TW\",\n          cldr_locale_name: :\"zh-Hant\",\n          language_subtags: [],\n          extensions: %{},\n          gettext_locale_name: nil,\n          language: \"zh\",\n          locale: %{},\n          private_use: [],\n          rbnf_locale_name: :\"zh-Hant\",\n          requested_locale_name: \"zh-TW\",\n          script: :Hant,\n          territory: :TW,\n          transform: %{},\n          language_variants: []\n        }},\n       {:error,\n        {Cldr.LanguageTag.ParseError,\n         \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n     ]}","ref":"SoftBank.Cldr.AcceptLanguage.html#parse/1-example"},{"type":"function","title":"SoftBank.Cldr.AcceptLanguage.parse!/1","doc":"Parses an `Accept-Language` header value in its string\nor tokenized form to produce a list of tuples of the form\n`[{quality, %Cldr.LanguageTag{}}, ...]` sorted by quality\nin descending order.","ref":"SoftBank.Cldr.AcceptLanguage.html#parse!/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.AcceptLanguage.parse!/1","doc":"* `accept-language` is any string in the format defined by [rfc2616](https://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html#sec14.4)","ref":"SoftBank.Cldr.AcceptLanguage.html#parse!/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.AcceptLanguage.parse!/1","doc":"* `{:ok, [{quality, language_tag}, ...]}` or\n\n* raises a `Cldr.AcceptLanguageError` exception\n\nIf at least one valid language tag is found but errors are also\ndetected on one more more tags, an `{ok, list}` tuple is returned\nwuth an error tuple for each invalid tag added at the end of the list.","ref":"SoftBank.Cldr.AcceptLanguage.html#parse!/1-returns"},{"type":"function","title":"Example - SoftBank.Cldr.AcceptLanguage.parse!/1","doc":"iex> SoftBank.Cldr.AcceptLanguage.parse!(\"da,zh-TW;q=0.3\")\n    [\n      {1.0,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"da\",\n         cldr_locale_name: :da,\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"da\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :da,\n         requested_locale_name: \"da\",\n         script: :Latn,\n         territory: :DK,\n         transform: %{},\n         language_variants: []\n       }},\n      {0.3,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"zh-TW\",\n         cldr_locale_name: :\"zh-Hant\",\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"zh\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :\"zh-Hant\",\n         requested_locale_name: \"zh-TW\",\n         script: :Hant,\n         territory: :TW,\n         transform: %{},\n         language_variants: []\n       }}\n    ]\n\n    SoftBank.Cldr.AcceptLanguage.parse! \"invalid_tag\"\n    ** (Cldr.AcceptLanguageError) \"Expected a BCP47 language tag. Could not parse the remaining \"g\" starting at position 11\n        (ex_cldr) lib/cldr/accept_language.ex:304: Cldr.AcceptLanguage.parse!/1\n\n    iex> SoftBank.Cldr.AcceptLanguage.parse!(\"da,zh-TW;q=0.3,invalid_tag\")\n    [\n      {1.0,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"da\",\n         cldr_locale_name: :da,\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"da\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :da,\n         requested_locale_name: \"da\",\n         script: :Latn,\n         territory: :DK,\n         transform: %{},\n         language_variants: []\n       }},\n      {0.3,\n       %Cldr.LanguageTag{\n         backend: TestBackend.Cldr,\n         canonical_locale_name: \"zh-TW\",\n         cldr_locale_name: :\"zh-Hant\",\n         language_subtags: [],\n         extensions: %{},\n         gettext_locale_name: nil,\n         language: \"zh\",\n         locale: %{},\n         private_use: [],\n         rbnf_locale_name: :\"zh-Hant\",\n         requested_locale_name: \"zh-TW\",\n         script: :Hant,\n         territory: :TW,\n         transform: %{},\n         language_variants: []\n       }},\n      {:error,\n       {Cldr.LanguageTag.ParseError,\n        \"Expected a BCP47 language tag. Could not parse the remaining \\\"g\\\" starting at position 11\"}}\n    ]","ref":"SoftBank.Cldr.AcceptLanguage.html#parse!/1-example"},{"type":"module","title":"SoftBank.Cldr.Currency","doc":"","ref":"SoftBank.Cldr.Currency.html"},{"type":"function","title":"SoftBank.Cldr.Currency.currencies_for_locale/3","doc":"Returns a map of the metadata for all currencies for\na given locale.","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currencies_for_locale/3","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`\n\n* `currency_status` is `:all`, `:current`, `:historic`,\n  `unannotated` or `:tender`; or a list of one or more status.\n  The default is `:all`. See `Cldr.Currency.currency_filter/2`.","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale/3-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currencies_for_locale/3","doc":"* `{:ok, currency_map}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale/3-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.currencies_for_locale/3","doc":"MyApp.Cldr.Currency.currencies_for_locale \"en\"\n  => {:ok,\n   %{\n     FJD: %Cldr.Currency{\n       cash_digits: 2,\n       cash_rounding: 0,\n       code: \"FJD\",\n       count: %{one: \"Fijian dollar\", other: \"Fijian dollars\"},\n       digits: 2,\n       from: nil,\n       iso_digits: 2,\n       name: \"Fijian Dollar\",\n       narrow_symbol: \"$\",\n       rounding: 0,\n       symbol: \"FJD\",\n       tender: true,\n       to: nil\n     },\n     SUR: %Cldr.Currency{\n       cash_digits: 2,\n       cash_rounding: 0,\n       code: \"SUR\",\n       count: %{one: \"Soviet rouble\", other: \"Soviet roubles\"},\n       digits: 2,\n       from: nil,\n       iso_digits: nil,\n       name: \"Soviet Rouble\",\n       narrow_symbol: nil,\n       rounding: 0,\n       symbol: \"SUR\",\n       tender: true,\n       to: nil\n     },\n     ...\n    }}","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale/3-example"},{"type":"function","title":"SoftBank.Cldr.Currency.currencies_for_locale!/3","doc":"Returns a map of the metadata for all currencies for\na given locale and raises on error.","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currencies_for_locale!/3","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`\n\n* `currency_status` is `:all`, `:current`, `:historic`,\n  `unannotated` or `:tender`; or a list of one or more status.\n  The default is `:all`. See `Cldr.Currency.currency_filter/2`.","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale!/3-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currencies_for_locale!/3","doc":"* `{:ok, currency_map}` or\n\n* raises an exception","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale!/3-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.currencies_for_locale!/3","doc":"MyApp.Cldr.Currency.currencies_for_locale! \"en\"\n  => %{\n    FJD: %Cldr.Currency{\n      cash_digits: 2,\n      cash_rounding: 0,\n      code: \"FJD\",\n      count: %{one: \"Fijian dollar\", other: \"Fijian dollars\"},\n      digits: 2,\n      from: nil,\n      iso_digits: 2,\n      name: \"Fijian Dollar\",\n      narrow_symbol: \"$\",\n      rounding: 0,\n      symbol: \"FJD\",\n      tender: true,\n      to: nil\n    },\n    SUR: %Cldr.Currency{\n      cash_digits: 2,\n      cash_rounding: 0,\n      code: \"SUR\",\n      count: %{one: \"Soviet rouble\", other: \"Soviet roubles\"},\n      digits: 2,\n      from: nil,\n      iso_digits: nil,\n      name: \"Soviet Rouble\",\n      narrow_symbol: nil,\n      rounding: 0,\n      symbol: \"SUR\",\n      tender: true,\n      to: nil\n    },\n    ...\n   }","ref":"SoftBank.Cldr.Currency.html#currencies_for_locale!/3-example"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_for_code/2","doc":"Returns the currency metadata for the requested currency code.","ref":"SoftBank.Cldr.Currency.html#currency_for_code/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_for_code/2","doc":"* `currency_or_currency_code` is a `binary` or `atom` representation\n   of an ISO 4217 currency code, or a `%Cldr.Currency{}` struct.","ref":"SoftBank.Cldr.Currency.html#currency_for_code/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Currency.currency_for_code/2","doc":"* `:locale` is any valid locale name returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`","ref":"SoftBank.Cldr.Currency.html#currency_for_code/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currency_for_code/2","doc":"* A `{:ok, currency}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Currency.html#currency_for_code/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.currency_for_code/2","doc":"iex> SoftBank.Cldr.Currency.currency_for_code(\"AUD\")\n    {:ok,\n      %Cldr.Currency{\n        cash_digits: 2,\n        cash_rounding: 0,\n        code: \"AUD\",\n        count: %{one: \"Australian dollar\", other: \"Australian dollars\"},\n        digits: 2,\n        iso_digits: 2,\n        name: \"Australian Dollar\",\n        narrow_symbol: \"$\",\n        rounding: 0,\n        symbol: \"A$\",\n        tender: true\n    }}\n\n    iex> SoftBank.Cldr.Currency.currency_for_code(\"THB\")\n    {:ok,\n      %Cldr.Currency{\n        cash_digits: 2,\n        cash_rounding: 0,\n        code: \"THB\",\n        count: %{one: \"Thai baht\", other: \"Thai baht\"},\n        digits: 2,\n        iso_digits: 2,\n        name: \"Thai Baht\",\n        narrow_symbol: \"฿\",\n        rounding: 0,\n        symbol: \"THB\",\n        tender: true\n    }}","ref":"SoftBank.Cldr.Currency.html#currency_for_code/2-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_for_code!/2","doc":"Returns the currency metadata for the requested currency code.","ref":"SoftBank.Cldr.Currency.html#currency_for_code!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_for_code!/2","doc":"* `currency_or_currency_code` is a `binary` or `atom` representation\n   of an ISO 4217 currency code, or a `%Cldr.Currency{}` struct.","ref":"SoftBank.Cldr.Currency.html#currency_for_code!/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Currency.currency_for_code!/2","doc":"* `:locale` is any valid locale name returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`","ref":"SoftBank.Cldr.Currency.html#currency_for_code!/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currency_for_code!/2","doc":"* A `t:Cldr.Current.t/0` or\n\n* raises an exception","ref":"SoftBank.Cldr.Currency.html#currency_for_code!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.currency_for_code!/2","doc":"iex> SoftBank.Cldr.Currency.currency_for_code!(\"AUD\")\n    %Cldr.Currency{\n      cash_digits: 2,\n      cash_rounding: 0,\n      code: \"AUD\",\n      count: %{one: \"Australian dollar\", other: \"Australian dollars\"},\n      digits: 2,\n      iso_digits: 2,\n      name: \"Australian Dollar\",\n      narrow_symbol: \"$\",\n      rounding: 0,\n      symbol: \"A$\",\n      tender: true\n    }\n\n    iex> SoftBank.Cldr.Currency.currency_for_code!(\"THB\")\n    %Cldr.Currency{\n      cash_digits: 2,\n      cash_rounding: 0,\n      code: \"THB\",\n      count: %{one: \"Thai baht\", other: \"Thai baht\"},\n      digits: 2,\n      iso_digits: 2,\n      name: \"Thai Baht\",\n      narrow_symbol: \"฿\",\n      rounding: 0,\n      symbol: \"THB\",\n      tender: true\n    }","ref":"SoftBank.Cldr.Currency.html#currency_for_code!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_from_locale/1","doc":"Returns the effective currency for a given locale","ref":"SoftBank.Cldr.Currency.html#currency_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_from_locale/1","doc":"* `locale` is a `Cldr.LanguageTag` struct returned by\n  `Cldr.Locale.new!/2`","ref":"SoftBank.Cldr.Currency.html#currency_from_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currency_from_locale/1","doc":"* A ISO 4217 currency code as an upcased atom","ref":"SoftBank.Cldr.Currency.html#currency_from_locale/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.currency_from_locale/1","doc":"iex> {:ok, locale} = SoftBank.Cldr.validate_locale \"en\"\n    iex> SoftBank.Cldr.Currency.currency_from_locale locale\n    :USD\n\n    iex> {:ok, locale} = SoftBank.Cldr.validate_locale \"en-AU\"\n    iex> SoftBank.Cldr.Currency.currency_from_locale locale\n    :AUD\n\n    iex> SoftBank.Cldr.Currency.currency_from_locale \"en-GB\"\n    :GBP","ref":"SoftBank.Cldr.Currency.html#currency_from_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_history_for_locale/1","doc":"Returns a list of historic and the current\ncurrency for a given locale.","ref":"SoftBank.Cldr.Currency.html#currency_history_for_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_history_for_locale/1","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.Currency.html#currency_history_for_locale/1-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.currency_history_for_locale/1","doc":"iex> MyApp.Cldr.Currency.currency_history_for_locale \"en\"\n    {:ok,\n        %{\n        USD: %{from: ~D[1792-01-01], to: nil},\n        USN: %{tender: false},\n        USS: %{from: nil, tender: false, to: ~D[2014-03-01]}\n      }\n    }","ref":"SoftBank.Cldr.Currency.html#currency_history_for_locale/1-example"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_strings/3","doc":"Returns a map that matches a currency string to a\ncurrency code.\n\nA currency string is a localised name or symbol\nrepresenting a currency in a locale-specific manner.","ref":"SoftBank.Cldr.Currency.html#currency_strings/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_strings/3","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`\n\n* `currency_status` is `:all`, `:current`, `:historic`,\n  `unannotated` or `:tender`; or a list of one or more status.\n  The default is `:all`. See `Cldr.Currency.currency_filter/2`.","ref":"SoftBank.Cldr.Currency.html#currency_strings/3-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currency_strings/3","doc":"* `{:ok, currency_string_map}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Currency.html#currency_strings/3-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.currency_strings/3","doc":"MyApp.Cldr.Currency.currency_strings \"en\"\n    => {:ok,\n     %{\n       \"mexican silver pesos\" => :MXP,\n       \"sudanese dinar\" => :SDD,\n       \"bad\" => :BAD,\n       \"rsd\" => :RSD,\n       \"swazi lilangeni\" => :SZL,\n       \"zairean new zaire\" => :ZRN,\n       \"guyanaese dollars\" => :GYD,\n       \"equatorial guinean ekwele\" => :GQE,\n       ...\n      }}","ref":"SoftBank.Cldr.Currency.html#currency_strings/3-example"},{"type":"function","title":"SoftBank.Cldr.Currency.currency_strings!/3","doc":"Returns a map that matches a currency string to a\ncurrency code or raises an exception.\n\nA currency string is a localised name or symbol\nrepresenting a currency in a locale-specific manner.","ref":"SoftBank.Cldr.Currency.html#currency_strings!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.currency_strings!/3","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`\n\n* `currency_status` is `:all`, `:current`, `:historic`,\n  `unannotated` or `:tender`; or a list of one or more status.\n  The default is `:all`. See `Cldr.Currency.currency_filter/2`.","ref":"SoftBank.Cldr.Currency.html#currency_strings!/3-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.currency_strings!/3","doc":"* `{:ok, currency_string_map}` or\n\n* raises an exception","ref":"SoftBank.Cldr.Currency.html#currency_strings!/3-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.currency_strings!/3","doc":"MyApp.Cldr.Currency.currency_strings! \"en\"\n    => %{\n      \"mexican silver pesos\" => :MXP,\n      \"sudanese dinar\" => :SDD,\n      \"bad\" => :BAD,\n      \"rsd\" => :RSD,\n      \"swazi lilangeni\" => :SZL,\n      \"zairean new zaire\" => :ZRN,\n      \"guyanaese dollars\" => :GYD,\n      \"equatorial guinean ekwele\" => :GQE,\n      ...\n     }","ref":"SoftBank.Cldr.Currency.html#currency_strings!/3-example"},{"type":"function","title":"SoftBank.Cldr.Currency.current_currency_from_locale/1","doc":"Returns the current currency for a given locale.\n\nThis function does not consider the `U` extenion\nparameters `cu` or `rg`. It is recommended to us\n`Cldr.Currency.currency_from_locale/1` in most\ncircumstances.","ref":"SoftBank.Cldr.Currency.html#current_currency_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.current_currency_from_locale/1","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.Currency.html#current_currency_from_locale/1-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.current_currency_from_locale/1","doc":"iex> MyApp.Cldr.Currency.current_currency_from_locale \"en\"\n    :USD\n\n    iex> MyApp.Cldr.Currency.current_currency_from_locale \"en-AU\"\n    :AUD","ref":"SoftBank.Cldr.Currency.html#current_currency_from_locale/1-example"},{"type":"function","title":"SoftBank.Cldr.Currency.current_territory_currencies/0","doc":"Returns a mapping from a territory code to its\ncurrent currency code.\n\nIf a territory has no current currency (like\nAntartica, territory code `:AQ`) then no\nmapping is returned for that territory.","ref":"SoftBank.Cldr.Currency.html#current_territory_currencies/0"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.current_territory_currencies/0","doc":"* A map of `{territory_code => Cldr.Currency.t}`","ref":"SoftBank.Cldr.Currency.html#current_territory_currencies/0-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.current_territory_currencies/0","doc":"iex> SoftBank.Cldr.Currency.current_territory_currencies()","ref":"SoftBank.Cldr.Currency.html#current_territory_currencies/0-example"},{"type":"function","title":"SoftBank.Cldr.Currency.known_currencies/0","doc":"","ref":"SoftBank.Cldr.Currency.html#known_currencies/0"},{"type":"function","title":"SoftBank.Cldr.Currency.known_currency?/1","doc":"","ref":"SoftBank.Cldr.Currency.html#known_currency?/1"},{"type":"function","title":"SoftBank.Cldr.Currency.known_currency_code/1","doc":"Returns a 2-tuple indicating if the supplied currency code is known.","ref":"SoftBank.Cldr.Currency.html#known_currency_code/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.known_currency_code/1","doc":"* `currency_code` is a `binary` or `atom` representing an ISO4217\n  currency code","ref":"SoftBank.Cldr.Currency.html#known_currency_code/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.known_currency_code/1","doc":"* `{:ok, currency_code}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Currency.html#known_currency_code/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.known_currency_code/1","doc":"iex> SoftBank.Cldr.Currency.known_currency_code \"AUD\"\n    {:ok, :AUD}\n\n    iex> SoftBank.Cldr.Currency.known_currency_code \"GGG\"\n    {:error, {Cldr.UnknownCurrencyError, \"The currency \\\"GGG\\\" is invalid\"}}","ref":"SoftBank.Cldr.Currency.html#known_currency_code/1-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.known_currency_code?/1","doc":"Returns a boolean indicating if the supplied currency code is known.","ref":"SoftBank.Cldr.Currency.html#known_currency_code?/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.known_currency_code?/1","doc":"* `currency_code` is a `binary` or `atom` representing an ISO4217\n  currency code","ref":"SoftBank.Cldr.Currency.html#known_currency_code?/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.known_currency_code?/1","doc":"* `true` or `false`","ref":"SoftBank.Cldr.Currency.html#known_currency_code?/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.known_currency_code?/1","doc":"iex> SoftBank.Cldr.Currency.known_currency_code? \"AUD\"\n    true\n\n    iex> SoftBank.Cldr.Currency.known_currency_code? \"GGG\"\n    false\n\n    iex> SoftBank.Cldr.Currency.known_currency_code? :XCV\n    false","ref":"SoftBank.Cldr.Currency.html#known_currency_code?/1-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.known_currency_codes/0","doc":"Returns a list of all known currency codes.","ref":"SoftBank.Cldr.Currency.html#known_currency_codes/0"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.known_currency_codes/0","doc":"iex> SoftBank.Cldr.Currency.known_currency_codes","ref":"SoftBank.Cldr.Currency.html#known_currency_codes/0-example"},{"type":"function","title":"SoftBank.Cldr.Currency.new/2","doc":"Returns a `Currency` struct created from the arguments.","ref":"SoftBank.Cldr.Currency.html#new/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.new/2","doc":"* `currency` is a private use currency code in a format defined by\n  [ISO4217](https://en.wikipedia.org/wiki/ISO_4217)\n  which is `X` followed by two alphanumeric characters.\n\n* `options` is a map of options representing the optional elements of\n  the `Cldr.Currency.t` struct.","ref":"SoftBank.Cldr.Currency.html#new/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Currency.new/2","doc":"* `:name` is the name of the currency. Required.\n* `:digits` is the precision of the currency. Required.\n* `:symbol` is the currency symbol. Optional.\n* `:narrow_symbol` is an alternative narrow symbol. Optional.\n* `:round_nearest` is the rounding precision such as `0.05`. Optional.\n* `:alt_code` is an alternative currency code for application use.\n* `:cash_digits` is the precision of the currency when used as cash. Optional.\n* `:cash_rounding_nearest` is the rounding precision when used as cash\n  such as `0.05`. Optional.","ref":"SoftBank.Cldr.Currency.html#new/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.new/2","doc":"* `{:ok, Cldr.Currency.t}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Currency.html#new/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.new/2","doc":"iex> SoftBank.Cldr.Currency.new(:XAE, name: \"Custom Name\", digits: 0)\n    {:ok,\n     %Cldr.Currency{\n       alt_code: :XAE,\n       cash_digits: 0,\n       cash_rounding: nil,\n       code: :XAE,\n       count: %{other: \"Custom Name\"},\n       digits: 0,\n       from: nil,\n       iso_digits: 0,\n       name: \"Custom Name\",\n       narrow_symbol: nil,\n       rounding: 0,\n       symbol: \"XAE\",\n       tender: false,\n       to: nil\n     }}\n    iex> MyApp.Cldr.Currency.new(:XAH, name: \"Custom Name\")\n    {:error, \"Required options are missing. Required options are [:name, :digits]\"}\n    iex> SoftBank.Cldr.Currency.new(:XAE, name: \"XAE\", digits: 0)\n    {:error, {Cldr.CurrencyAlreadyDefined, \"Currency :XAE is already defined.\"}}","ref":"SoftBank.Cldr.Currency.html#new/2-example"},{"type":"function","title":"SoftBank.Cldr.Currency.pluralize/3","doc":"Returns the appropriate currency display name for the `currency`, based\non the plural rules in effect for the `locale`.","ref":"SoftBank.Cldr.Currency.html#pluralize/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.pluralize/3","doc":"* `number` is an integer, float or `Decimal`\n\n* `currency` is any currency returned by `Cldr.Currency.known_currencies/0`\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Currency.html#pluralize/3-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Currency.pluralize/3","doc":"* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`. The\n  default is `SoftBank.Cldr.get_locale/0`","ref":"SoftBank.Cldr.Currency.html#pluralize/3-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.pluralize/3","doc":"* `{:ok, plural_string}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Currency.html#pluralize/3-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Currency.pluralize/3","doc":"iex> SoftBank.Cldr.Currency.pluralize 1, :USD\n    {:ok, \"US dollar\"}\n\n    iex> SoftBank.Cldr.Currency.pluralize 3, :USD\n    {:ok, \"US dollars\"}\n\n    iex> SoftBank.Cldr.Currency.pluralize 12, :USD, locale: \"zh\"\n    {:ok, \"美元\"}\n\n    iex> SoftBank.Cldr.Currency.pluralize 12, :USD, locale: \"fr\"\n    {:ok, \"dollars des États-Unis\"}\n\n    iex> SoftBank.Cldr.Currency.pluralize 1, :USD, locale: \"fr\"\n    {:ok, \"dollar des États-Unis\"}","ref":"SoftBank.Cldr.Currency.html#pluralize/3-examples"},{"type":"function","title":"SoftBank.Cldr.Currency.strings_for_currency/2","doc":"Returns the strings associated with a currency\nin a given locale.","ref":"SoftBank.Cldr.Currency.html#strings_for_currency/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Currency.strings_for_currency/2","doc":"* `currency` is an ISO4217 currency code\n\n* `locale` is any valid locale name returned by `MyApp.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `MyApp.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.Currency.html#strings_for_currency/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Currency.strings_for_currency/2","doc":"* A list of strings or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Currency.html#strings_for_currency/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Currency.strings_for_currency/2","doc":"iex> MyApp.Cldr.Currency.strings_for_currency :AUD, \"en\"\n    [\"a$\", \"australian dollars\", \"aud\", \"australian dollar\"]","ref":"SoftBank.Cldr.Currency.html#strings_for_currency/2-example"},{"type":"module","title":"SoftBank.Cldr.Locale","doc":"Backend module that provides functions\nto define new locales and display human-readable\nlocale names for presentation purposes.","ref":"SoftBank.Cldr.Locale.html"},{"type":"function","title":"SoftBank.Cldr.Locale.fallback_locale_names/1","doc":"Returns the list of fallback locale names, starting\nwith the provided locale name.\n\nFallbacks are a list of locate names which can\nbe used to resolve translation or other localization\ndata if such localised data does not exist for\nthis specific locale..","ref":"SoftBank.Cldr.Locale.html#fallback_locale_names/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.fallback_locale_names/1","doc":"* `locale_name` is any locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.Locale.html#fallback_locale_names/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.fallback_locale_names/1","doc":"* `{:ok, list_of_locale_names}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Locale.html#fallback_locale_names/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.fallback_locale_names/1","doc":"iex> SoftBank.Cldr.Locale.fallback_locale_names(:\"fr-CA\")\n    {:ok, [:\"fr-CA\", :fr, :und]}\n\n    # Fallbacks are typically formed by progressively\n    # stripping variant, territory and script from the\n    # given locale name. But not always - there are\n    # certain fallbacks that take a different path.\n\n    iex> SoftBank.Cldr.Locale.fallback_locale_names(:nb)\n    {:ok, [:nb, :no, :und]}","ref":"SoftBank.Cldr.Locale.html#fallback_locale_names/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.fallback_locales/1","doc":"Returns the list of fallback locales, starting\nwith the provided locale name.\n\nFallbacks are a list of locate names which can\nbe used to resolve translation or other localization\ndata if such localised data does not exist for\nthis specific locale.","ref":"SoftBank.Cldr.Locale.html#fallback_locales/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.fallback_locales/1","doc":"* `locale_name` is any locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.Locale.html#fallback_locales/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.fallback_locales/1","doc":"* `{:ok, list_of_locales}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Locale.html#fallback_locales/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.fallback_locales/1","doc":"SoftBank.Cldr.Locale.fallback_locales(:\"fr-CA\")\n    => {:ok,\n         [#Cldr.LanguageTag , #Cldr.LanguageTag ,\n          #Cldr.LanguageTag ]}\n\n    # Fallbacks are typically formed by progressively\n    # stripping variant, territory and script from the\n    # given locale name. But not always - there are\n    # certain fallbacks that take a different path.\n\n    SoftBank.Cldr.Locale.fallback_locales(:nb))\n    => {:ok,\n         [#Cldr.LanguageTag , #Cldr.LanguageTag ,\n          #Cldr.LanguageTag ]}","ref":"SoftBank.Cldr.Locale.html#fallback_locales/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.locale_for_territory/1","doc":"Returns the \"best fit\" locale for a given territory.\n\nUsing the population percentage data from CLDR, the\nlanguage most commonly spoken in the given territory\nis used to form a locale name which is then validated\nagainst the given backend.\n\nFirst a territory-specific locale is validated and if\nthat fails, the base language only is validate.\n\nFor example, if the territory is `AU` then then the\nlanguage most spoken is \"en\". First, the locale \"en-AU\"\nis validated and if that fails, \"en\" is validated.","ref":"SoftBank.Cldr.Locale.html#locale_for_territory/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.locale_for_territory/1","doc":"* `territory` is any ISO 3166 Alpha-2 territory\n  code that can be validated by `Cldr.validate_territory/1`","ref":"SoftBank.Cldr.Locale.html#locale_for_territory/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.locale_for_territory/1","doc":"* `{:ok, language_tag}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Locale.html#locale_for_territory/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.locale_for_territory/1","doc":"iex> SoftBank.Cldr.Locale.locale_for_territory(:AU)\n  Elixir.SoftBank.Cldr.validate_locale(:\"en-AU\")\n\n  iex> SoftBank.Cldr.Locale.locale_for_territory(:US)\n  Elixir.SoftBank.Cldr.validate_locale(:\"en-US\")\n\n  iex> SoftBank.Cldr.Locale.locale_for_territory(:ZZ)\n  {:error, {Cldr.UnknownTerritoryError, \"The territory :ZZ is unknown\"}}","ref":"SoftBank.Cldr.Locale.html#locale_for_territory/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.locale_from_host/2","doc":"Returns a \"best fit\" locale for a host name.","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.locale_from_host/2","doc":"* `host` is any valid host name\n\n* `options` is a keyword list of options. The default\n  is `[]`.","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Locale.locale_from_host/2","doc":"* `:tlds` is a list of territory codes as upper-cased\n  atoms that are to be considered as top-level domains.\n  See `Cldr.Locale.locale_from_host/2` for the default\n  list.","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.locale_from_host/2","doc":"* `{:ok, langauge_tag}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2-returns"},{"type":"function","title":"Notes - SoftBank.Cldr.Locale.locale_from_host/2","doc":"Certain top-level domains have become associated with content\nunderlated to the territory for who the domain is registered.\nTherefore Google (and perhaps others) do not associate these\nTLDs as belonging to the territory but rather are considered\ngeneric top-level domain names.","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.locale_from_host/2","doc":"iex> SoftBank.Cldr.Locale.locale_from_host \"a.b.com.au\"\n    Elixir.SoftBank.Cldr.validate_locale(:\"en-AU\")\n\n    iex> SoftBank.Cldr.Locale.locale_from_host(\"a.b.com.tv\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"tv\\\"\"}}\n\n    iex> SoftBank.Cldr.Locale.locale_from_host(\"a.b.com\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"com\\\"\"}}","ref":"SoftBank.Cldr.Locale.html#locale_from_host/2-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.new/1","doc":"","ref":"SoftBank.Cldr.Locale.html#new/1"},{"type":"function","title":"SoftBank.Cldr.Locale.new!/1","doc":"","ref":"SoftBank.Cldr.Locale.html#new!/1"},{"type":"function","title":"SoftBank.Cldr.Locale.script_direction_from_locale/1","doc":"Returns the script direction for a locale.","ref":"SoftBank.Cldr.Locale.html#script_direction_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.script_direction_from_locale/1","doc":"* `language_tag` is any language tag returned by `Cldr.Locale.new/2`\n  or any `locale_name` returned by `Cldr.known_locale_names/1`.","ref":"SoftBank.Cldr.Locale.html#script_direction_from_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.script_direction_from_locale/1","doc":"* The script direction which is either `:ltr` (for left-to-right\n  scripts) or `:rtl` (for right-to-left scripts).","ref":"SoftBank.Cldr.Locale.html#script_direction_from_locale/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.script_direction_from_locale/1","doc":"iex> SoftBank.Cldr.Locale.script_direction_from_locale \"en-US\"\n    :ltr\n\n    iex> SoftBank.Cldr.Locale.script_direction_from_locale :ar\n    :rtl","ref":"SoftBank.Cldr.Locale.html#script_direction_from_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.territory_from_host/1","doc":"Returns the last segment of a host that might\nbe a territory.","ref":"SoftBank.Cldr.Locale.html#territory_from_host/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.territory_from_host/1","doc":"* `host` is any valid host name","ref":"SoftBank.Cldr.Locale.html#territory_from_host/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.territory_from_host/1","doc":"* `{:ok, territory}` or\n\n* `{:error, {exception, reason}}`","ref":"SoftBank.Cldr.Locale.html#territory_from_host/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.territory_from_host/1","doc":"iex> Cldr.Locale.territory_from_host(\"a.b.com.au\")\n    {:ok, :AU}\n\n    iex> Cldr.Locale.territory_from_host(\"a.b.com\")\n    {:error,\n     {Cldr.UnknownLocaleError, \"No locale was identified for territory \\\"com\\\"\"}}","ref":"SoftBank.Cldr.Locale.html#territory_from_host/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.territory_from_locale/1","doc":"Returns the territory from a language tag or\nlocale name.","ref":"SoftBank.Cldr.Locale.html#territory_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.territory_from_locale/1","doc":"* `locale` is any language tag returned by\n  `SoftBank.Cldr.Locale.new/1`\n  or a locale name in the list returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.Locale.html#territory_from_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.territory_from_locale/1","doc":"* A territory code as an atom","ref":"SoftBank.Cldr.Locale.html#territory_from_locale/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.territory_from_locale/1","doc":"iex> SoftBank.Cldr.Locale.territory_from_locale \"en-US\"\n    :US\n\n    iex> SoftBank.Cldr.Locale.territory_from_locale \"en-US-u-rg-GBzzzz\"\n    :GB","ref":"SoftBank.Cldr.Locale.html#territory_from_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.Locale.timezone_from_locale/1","doc":"Returns the time zone from a language tag or\nlocale name.","ref":"SoftBank.Cldr.Locale.html#timezone_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Locale.timezone_from_locale/1","doc":"* `locale` is any language tag returned by\n  `SoftBank.Cldr.Locale.new/1`\n  or a locale name in the list returned by\n  `SoftBank.Cldr.known_locale_names/0`","ref":"SoftBank.Cldr.Locale.html#timezone_from_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Locale.timezone_from_locale/1","doc":"* A time zone ID as a string or\n\n* `:error` if no time zone can be determined","ref":"SoftBank.Cldr.Locale.html#timezone_from_locale/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Locale.timezone_from_locale/1","doc":"iex> SoftBank.Cldr.Locale.timezone_from_locale \"en-US-u-tz-ausyd\"\n    \"Australia/Sydney\"","ref":"SoftBank.Cldr.Locale.html#timezone_from_locale/1-examples"},{"type":"module","title":"SoftBank.Cldr.Money","doc":"A backend module for Money.\n\nThis module provides the same api as the Money\nmodule however:\n\n* It matches the standard behaviour of other\n`ex_cldr` based libraries in maintaining the\nmain public API on the backend module\n\n* It does not require the `:backend` option to\nbe provided since that is implied through the\nuse of the backend module.\n\nAll the functions in this module delegate to\nthe functions in `Money`.","ref":"SoftBank.Cldr.Money.html"},{"type":"function","title":"SoftBank.Cldr.Money.abs/1","doc":"The absolute value of a `Money` amount.\nReturns a `Money` type with a positive sign for the amount.","ref":"SoftBank.Cldr.Money.html#abs/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.abs/1","doc":"* `money` is any valid `t:Money.t/0` type returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#abs/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.abs/1","doc":"* a `t:Money.t/0`","ref":"SoftBank.Cldr.Money.html#abs/1-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.abs/1","doc":"iex> m = SoftBank.Cldr.Money.new(\"USD\", -100)\n    iex> SoftBank.Cldr.Money.abs(m)\n    Money.new(:USD, \"100\")","ref":"SoftBank.Cldr.Money.html#abs/1-example"},{"type":"function","title":"SoftBank.Cldr.Money.add/2","doc":"Add two `Money` values.","ref":"SoftBank.Cldr.Money.html#add/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.add/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#add/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.add/2","doc":"* `{:ok, money}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.Money.html#add/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.add/2","doc":"iex> SoftBank.Cldr.Money.add Money.new(:USD, 200), Money.new(:USD, 100)\n    {:ok, Money.new(:USD, 300)}\n\n    iex> SoftBank.Cldr.Money.add Money.new(:USD, 200), Money.new(:AUD, 100)\n    {:error, {ArgumentError, \"Cannot add monies with different currencies. \"  \n      \"Received :USD and :AUD.\"}}","ref":"SoftBank.Cldr.Money.html#add/2-example"},{"type":"function","title":"SoftBank.Cldr.Money.add!/2","doc":"Add two `Money` values and raise on error.","ref":"SoftBank.Cldr.Money.html#add!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.add!/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#add!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.add!/2","doc":"* `{:ok, money}` or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#add!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.add!/2","doc":"iex> SoftBank.Cldr.Money.add! Money.new(:USD, 200), Money.new(:USD, 100)\n    Money.new(:USD, \"300\")\n\n    SoftBank.Cldr.Money.add! Money.new(:USD, 200), Money.new(:CAD, 500)\n    ** (ArgumentError) Cannot add two `t:Money.t/0` with different currencies. Received :USD and :CAD.","ref":"SoftBank.Cldr.Money.html#add!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.cmp/2","doc":"Compares two `Money` values numerically. If the first number is greater\nthan the second #Integer  is returned, if less than Integer  is\nreturned. Otherwise, if both numbers are equal Integer  is returned.","ref":"SoftBank.Cldr.Money.html#cmp/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.cmp/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#cmp/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.cmp/2","doc":"*  `-1` | `0` | `1` or\n\n* `{:error, {module(), String.t}}`","ref":"SoftBank.Cldr.Money.html#cmp/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.cmp/2","doc":"iex> SoftBank.Cldr.Money.cmp Money.new(:USD, 200), Money.new(:USD, 100)\n    1\n\n    iex> SoftBank.Cldr.Money.cmp Money.new(:USD, 200), Money.new(:USD, 200)\n    0\n\n    iex> SoftBank.Cldr.Money.cmp Money.new(:USD, 200), Money.new(:USD, 500)\n    -1\n\n    iex> SoftBank.Cldr.Money.cmp Money.new(:USD, 200), Money.new(:CAD, 500)\n    {:error,\n     {ArgumentError,\n      \"Cannot compare monies with different currencies. Received :USD and :CAD.\"}}","ref":"SoftBank.Cldr.Money.html#cmp/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.cmp!/2","doc":"Compares two `Money` values numerically and raises on error.","ref":"SoftBank.Cldr.Money.html#cmp!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.cmp!/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#cmp!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.cmp!/2","doc":"*  `-1` | `0` | `1` or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#cmp!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.cmp!/2","doc":"SoftBank.Cldr.Money.cmp! Money.new(:USD, 200), Money.new(:CAD, 500)\n    ** (ArgumentError) Cannot compare monies with different currencies. Received :USD and :CAD.","ref":"SoftBank.Cldr.Money.html#cmp!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.compare/2","doc":"Compares two `Money` values numerically. If the first number is greater\nthan the second :gt is returned, if less than :lt is returned, if both\nnumbers are equal :eq is returned.","ref":"SoftBank.Cldr.Money.html#compare/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.compare/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#compare/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.compare/2","doc":"*  `:gt` | `:eq` | `:lt` or\n\n* `{:error, {module(), String.t}}`","ref":"SoftBank.Cldr.Money.html#compare/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.compare/2","doc":"iex> SoftBank.Cldr.Money.compare Money.new(:USD, 200), Money.new(:USD, 100)\n    :gt\n\n    iex> SoftBank.Cldr.Money.compare Money.new(:USD, 200), Money.new(:USD, 200)\n    :eq\n\n    iex> SoftBank.Cldr.Money.compare Money.new(:USD, 200), Money.new(:USD, 500)\n    :lt\n\n    iex> SoftBank.Cldr.Money.compare Money.new(:USD, 200), Money.new(:CAD, 500)\n    {:error,\n     {ArgumentError,\n      \"Cannot compare monies with different currencies. Received :USD and :CAD.\"}}","ref":"SoftBank.Cldr.Money.html#compare/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.compare!/2","doc":"Compares two `Money` values numerically and raises on error.","ref":"SoftBank.Cldr.Money.html#compare!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.compare!/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#compare!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.compare!/2","doc":"*  `:gt` | `:eq` | `:lt` or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#compare!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.compare!/2","doc":"SoftBank.Cldr.Money.compare! Money.new(:USD, 200), Money.new(:CAD, 500)\n    ** (ArgumentError) Cannot compare monies with different currencies. Received :USD and :CAD.","ref":"SoftBank.Cldr.Money.html#compare!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.cross_rate/3","doc":"Returns the effective cross-rate to convert from one currency\nto another.","ref":"SoftBank.Cldr.Money.html#cross_rate/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.cross_rate/3","doc":"* `from` is any `t:Money.t/0` struct returned by `Cldr.Currency.new/2` or a valid\n   currency code\n\n* `to_currency` is a valid currency code into which the `money` is converted\n\n* `rates` is a `Map` of currency rates where the map key is an upcased\n  atom or string and the value is a Decimal conversion factor.  The default is the\n  latest available exchange rates returned from `Money.ExchangeRates.latest_rates()`","ref":"SoftBank.Cldr.Money.html#cross_rate/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.cross_rate/3","doc":"SoftBank.Cldr.Money.cross_rate(Money.new(:USD, 100), :AUD, %{USD: Decimal.new(1), AUD: Decimal.new(\"0.7345\")})\n    {:ok, Decimal.new(\"0.7345\")}\n\n    SoftBank.Cldr.Money.cross_rate Money.new(:USD, 100), :ZZZ, %{USD: Decimal.new(1), AUD: Decimal.new(0.7345)}\n    ** (Cldr.UnknownCurrencyError) Currency :ZZZ is not known","ref":"SoftBank.Cldr.Money.html#cross_rate/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.cross_rate!/3","doc":"Returns the effective cross-rate to convert from one currency\nto another.","ref":"SoftBank.Cldr.Money.html#cross_rate!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.cross_rate!/3","doc":"* `from` is any `t:Money.t/0` struct returned by `Cldr.Currency.new/2` or a valid\n   currency code\n\n* `to_currency` is a valid currency code into which the `money` is converted\n\n* `rates` is a `Map` of currency rates where the map key is an upcased\n  atom or string and the value is a Decimal conversion factor.  The default is the\n  latest available exchange rates returned from `Money.ExchangeRates.latest_rates()`","ref":"SoftBank.Cldr.Money.html#cross_rate!/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.cross_rate!/3","doc":"iex> SoftBank.Cldr.Money.cross_rate!(Money.new(:USD, 100), :AUD, %{USD: Decimal.new(1), AUD: Decimal.new(\"0.7345\")})\n    Decimal.new(\"0.7345\")\n\n    iex> SoftBank.Cldr.Money.cross_rate!(:USD, :AUD, %{USD: Decimal.new(1), AUD: Decimal.new(\"0.7345\")})\n    Decimal.new(\"0.7345\")\n\n    SoftBank.Cldr.Money.cross_rate Money.new(:USD, 100), :ZZZ, %{USD: Decimal.new(1), AUD: Decimal.new(\"0.7345\")}\n    ** (Cldr.UnknownCurrencyError) Currency :ZZZ is not known","ref":"SoftBank.Cldr.Money.html#cross_rate!/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.div/2","doc":"Divide a `Money` value by a number.","ref":"SoftBank.Cldr.Money.html#div/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.div/2","doc":"* `money` is any valid `t:Money.t/0` types returned\n  by `Money.new/2`\n\n* `number` is an integer, float or `t:Decimal.t/0`\n\n> Note that dividing one `t:Money.t/0` by another is not supported.","ref":"SoftBank.Cldr.Money.html#div/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.div/2","doc":"* `{:ok, money}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.Money.html#div/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.div/2","doc":"iex> SoftBank.Cldr.Money.div Money.new(:USD, 200), 2\n    {:ok, Money.new(:USD, 100)}\n\n    iex> SoftBank.Cldr.Money.div(Money.new(:USD, 200), \"xx\")\n    {:error, {ArgumentError, \"Cannot divide money by \\\"xx\\\"\"}}","ref":"SoftBank.Cldr.Money.html#div/2-example"},{"type":"function","title":"SoftBank.Cldr.Money.div!/2","doc":"Divide a `Money` value by a number and raise on error.","ref":"SoftBank.Cldr.Money.html#div!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.div!/2","doc":"* `money` is any valid `t:Money.t/0` types returned\n  by `Money.new/2`\n\n* `number` is an integer, float or `Decimal.t`","ref":"SoftBank.Cldr.Money.html#div!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.div!/2","doc":"* a `t:Money.t/0` struct or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#div!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.div!/2","doc":"iex> SoftBank.Cldr.Money.div Money.new(:USD, 200), 2\n    {:ok, Money.new(:USD, 100)}\n\n    SoftBank.Cldr.Money.div(Money.new(:USD, 200), \"xx\")\n    ** (ArgumentError) \"Cannot divide money by \\\"xx\\\"\"]}}","ref":"SoftBank.Cldr.Money.html#div!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.equal?/2","doc":"Returns a boolean indicating if two `Money` values are equal","ref":"SoftBank.Cldr.Money.html#equal?/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.equal?/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#equal?/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.equal?/2","doc":"* `true` or `false`","ref":"SoftBank.Cldr.Money.html#equal?/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.equal?/2","doc":"iex> SoftBank.Cldr.Money.equal? Money.new(:USD, 200), Money.new(:USD, 200)\n    true\n\n    iex> SoftBank.Cldr.Money.equal? Money.new(:USD, 200), Money.new(:USD, 100)\n    false","ref":"SoftBank.Cldr.Money.html#equal?/2-example"},{"type":"function","title":"SoftBank.Cldr.Money.from_float/3","doc":"Returns a `t:Money.t/0` struct from a currency code and a float amount, or\nan error tuple of the form `{:error, {exception, message}}`.\n\nFloats are fraught with danger in computer arithmetic due to the\nunexpected loss of precision during rounding. The IEEE754 standard\nindicates that a number with a precision of 16 digits should\nround-trip convert without loss of fidelity. This function supports\nnumbers with a precision up to 15 digits and will error if the\nprovided amount is outside that range.\n\n**Note** that `Money` cannot detect lack of precision or rounding errors\nintroduced upstream. This function therefore should be used with\ngreat care and its use should be considered potentially harmful.","ref":"SoftBank.Cldr.Money.html#from_float/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.from_float/3","doc":"* `currency_code` is an [ISO4217](https://en.wikipedia.org/wiki/ISO_4217)\n  binary or atom currency code or an\n  [ISO 24165](https://www.iso.org/standard/80601.html) token identifier or shortname.\n\n* `amount` is a float","ref":"SoftBank.Cldr.Money.html#from_float/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.from_float/3","doc":"iex> SoftBank.Cldr.Money.from_float 1.23456, :USD\n    Money.new(:USD, \"1.23456\")\n\n    iex> SoftBank.Cldr.Money.from_float 1.234567890987656, :USD\n    {:error,\n      {Money.InvalidAmountError,\n        \"The precision of the float 1.234567890987656 is \"  \n        \"greater than 15 which could lead to unexpected results. \"  \n        \"Reduce the precision or call Money.new/2 with a Decimal or String amount\"}}","ref":"SoftBank.Cldr.Money.html#from_float/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.from_float!/3","doc":"Returns a `t:Money.t/0` struct from a currency code and a float amount, or\nraises an exception if the currency code is invalid.\n\nSee `Money.from_float/2` for further information.\n\n**Note** that `Money` cannot detect lack of precision or rounding errors\nintroduced upstream. This function therefore should be used with\ngreat care and its use should be considered potentially harmful.","ref":"SoftBank.Cldr.Money.html#from_float!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.from_float!/3","doc":"* `currency_code` is an ISO4217 three-character upcased binary or atom\n\n* `amount` is a float\n\n* `options` is a keyword list of options passed\n  to `Money.new/3`. The default is `[]`.","ref":"SoftBank.Cldr.Money.html#from_float!/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.from_float!/3","doc":"iex> SoftBank.Cldr.Money.from_float!(:USD, 1.234)\n    Money.new(:USD, \"1.234\")\n\n    Money.from_float!(:USD, 1.234567890987654)\n    #=> ** (Money.InvalidAmountError) The precision of the float 1.234567890987654 is greater than 15 which could lead to unexpected results. Reduce the precision or call Money.new/2 with a Decimal or String amount\n        (ex_money) lib/money.ex:293: Money.from_float!/2","ref":"SoftBank.Cldr.Money.html#from_float!/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.from_integer/3","doc":"Convert an integer representation of money into a `Money` struct.\n\nThis is the inverse operation of `Money.to_integer_exp/1`. Note\nthat the ISO definition of currency digits (subunit) is *always*\nused.  This is, in some cases like the Colombian Peso (COP)\ndifferent to the CLDR definition.","ref":"SoftBank.Cldr.Money.html#from_integer/3"},{"type":"function","title":"Options - SoftBank.Cldr.Money.from_integer/3","doc":"* `integer` is an integer representation of a mooney item including\n  any decimal digits.  ie. 20000 would interpreted to mean $200.00\n\n* `currency` is the currency code for the `integer`.  The assumed\n  decimal places is derived from the currency code.","ref":"SoftBank.Cldr.Money.html#from_integer/3-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.from_integer/3","doc":"* A `Money` struct or\n\n* `{:error, {Cldr.UnknownCurrencyError, message}}`","ref":"SoftBank.Cldr.Money.html#from_integer/3-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.from_integer/3","doc":"iex> SoftBank.Cldr.Money.from_integer(20000, :USD)\n    Money.new(:USD, \"200.00\")\n\n    iex> SoftBank.Cldr.Money.from_integer(200, :JPY)\n    Money.new(:JPY, \"200\")\n\n    iex> SoftBank.Cldr.Money.from_integer(20012, :USD)\n    Money.new(:USD, \"200.12\")\n\n    iex> SoftBank.Cldr.Money.from_integer(20012, :COP)\n    Money.new(:COP, \"200.12\")","ref":"SoftBank.Cldr.Money.html#from_integer/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.known_currencies/0","doc":"","ref":"SoftBank.Cldr.Money.html#known_currencies/0"},{"type":"function","title":"SoftBank.Cldr.Money.known_current_currencies/0","doc":"","ref":"SoftBank.Cldr.Money.html#known_current_currencies/0"},{"type":"function","title":"SoftBank.Cldr.Money.known_historic_currencies/0","doc":"","ref":"SoftBank.Cldr.Money.html#known_historic_currencies/0"},{"type":"function","title":"SoftBank.Cldr.Money.known_tender_currencies/0","doc":"","ref":"SoftBank.Cldr.Money.html#known_tender_currencies/0"},{"type":"function","title":"SoftBank.Cldr.Money.mult/2","doc":"Multiply a `Money` value by a number.","ref":"SoftBank.Cldr.Money.html#mult/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.mult/2","doc":"* `money` is any valid `t:Money.t/0` type returned\n  by `Money.new/2`\n\n* `number` is an integer, float or `t:Decimal.t/0`\n\n> Note that multipling one `t:Money.t/0` by another is not supported.","ref":"SoftBank.Cldr.Money.html#mult/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.mult/2","doc":"* `{:ok, money}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.Money.html#mult/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.mult/2","doc":"iex> SoftBank.Cldr.Money.mult(Money.new(:USD, 200), 2)\n    {:ok, Money.new(:USD, 400)}\n\n    iex> SoftBank.Cldr.Money.mult(Money.new(:USD, 200), \"xx\")\n    {:error, {ArgumentError, \"Cannot multiply money by \\\"xx\\\"\"}}","ref":"SoftBank.Cldr.Money.html#mult/2-example"},{"type":"function","title":"SoftBank.Cldr.Money.mult!/2","doc":"Multiply a `Money` value by a number and raise on error.","ref":"SoftBank.Cldr.Money.html#mult!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.mult!/2","doc":"* `money` is any valid `t:Money.t/0` types returned\n  by `Money.new/2`\n\n* `number` is an integer, float or `Decimal.t`","ref":"SoftBank.Cldr.Money.html#mult!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.mult!/2","doc":"* a `t:Money.t/0` or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#mult!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.mult!/2","doc":"iex> SoftBank.Cldr.Money.mult!(Money.new(:USD, 200), 2)\n    Money.new(:USD, \"400\")\n\n    SoftBank.Cldr.Money.mult!(Money.new(:USD, 200), :invalid)\n    ** (ArgumentError) Cannot multiply money by :invalid","ref":"SoftBank.Cldr.Money.html#mult!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.new/3","doc":"Returns a `t:Money.t/0` struct from a currency code and a currency amount or\nan error tuple of the form `{:error, {exception, message}}`.","ref":"SoftBank.Cldr.Money.html#new/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.new/3","doc":"* `currency_code` is an [ISO4217](https://en.wikipedia.org/wiki/ISO_4217)\n  binary or atom currency code or an\n  [ISO 24165](https://www.iso.org/standard/80601.html) token identifier or shortname.\n\n* `amount` is an integer, string or Decimal","ref":"SoftBank.Cldr.Money.html#new/3-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Money.new/3","doc":"`:locale` is any known locale.  The locale is used to normalize any\nbinary (String) amounts to a form that can be consumed by `Decimal.new/1`.\nThis consists of removing any localised grouping characters and replacing\nthe localised decimal separator with a \".\".\n\nNote that the `currency_code` and `amount` arguments can be supplied in\neither order,","ref":"SoftBank.Cldr.Money.html#new/3-options"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.new/3","doc":"iex> SoftBank.Cldr.Money.new(:USD, 100)\n    Money.new(:USD, \"100\")\n\n    iex> SoftBank.Cldr.Money.new(100, :USD)\n    Money.new(:USD, \"100\")\n\n    iex> SoftBank.Cldr.Money.new(\"USD\", 100)\n    Money.new(:USD, \"100\")\n\n    iex> SoftBank.Cldr.Money.new(\"thb\", 500)\n    Money.new(:THB, \"500\")\n\n    iex> SoftBank.Cldr.Money.new(\"EUR\", Decimal.new(100))\n    Money.new(:EUR, \"100\")\n\n    iex> SoftBank.Cldr.Money.new(:EUR, \"100.30\")\n    Money.new(:EUR, \"100.30\")\n\n    iex> SoftBank.Cldr.Money.new(:XYZZ, 100)\n    {:error, {Money.UnknownCurrencyError, \"The currency :XYZZ is invalid\"}}\n\n    iex> SoftBank.Cldr.Money.new(\"1.000,99\", :EUR, locale: \"de\")\n    Money.new(:EUR, \"1000.99\")\n\n    iex> SoftBank.Cldr.Money.new 123.445, :USD\n    {:error,\n     {Money.InvalidAmountError,\n      \"Float amounts are not supported in new/2 due to potenial \"  \n      \"rounding and precision issues.  If absolutely required, \"  \n      \"use Money.from_float/2\"}}","ref":"SoftBank.Cldr.Money.html#new/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.new!/3","doc":"Returns a `t:Money.t/0` struct from a currency code and a currency amount. Raises an\nexception if the current code is invalid.","ref":"SoftBank.Cldr.Money.html#new!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.new!/3","doc":"* `currency_code` is an ISO4217 three-character upcased binary or atom\n\n* `amount` is an integer, float or Decimal","ref":"SoftBank.Cldr.Money.html#new!/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.new!/3","doc":"Money.new!(:XYZZ, 100)\n    ** (Money.UnknownCurrencyError) Currency :XYZZ is not known\n      (ex_money) lib/money.ex:177: Money.new!/2","ref":"SoftBank.Cldr.Money.html#new!/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.normalize/1","doc":"Normalizes the underlying `Decimal` amount on the\ngiven `t:Money.t/0`.\n\nThis will normalize the coefficient and exponent of the\ndecimal amount in a standard way that may aid in\nnative comparison of `t:Money.t/0` items.","ref":"SoftBank.Cldr.Money.html#normalize/1"},{"type":"function","title":"Example - SoftBank.Cldr.Money.normalize/1","doc":"iex> x = %Money{currency: :USD, amount: %Decimal{sign: 1, coef: 42, exp: 0}}\n    Money.new(:USD, \"42\")\n    iex> y = %Money{currency: :USD, amount: %Decimal{sign: 1, coef: 4200000000, exp: -8}}\n    Money.new(:USD, \"42.00000000\")\n    iex> x == y\n    false\n    iex> y = Money.normalize(x)\n    Money.new(:USD, \"42\")\n    iex> x == y\n    true","ref":"SoftBank.Cldr.Money.html#normalize/1-example"},{"type":"function","title":"SoftBank.Cldr.Money.parse/2","doc":"Parse a string and return a `t:Money.t/0` or an error.\n\nThe string to be parsed is required to have a currency\ncode and an amount.  The currency code may be placed\nbefore the amount or after, but not both.\n\nParsing is strict.  Additional text surrounding the\ncurrency code and amount will cause the parse to\nfail.","ref":"SoftBank.Cldr.Money.html#parse/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.parse/2","doc":"* `string` is a string to be parsed\n\n* `options` is a keyword list of options that is\n  passed to `Money.new/3` with the exception of\n  the options listed below","ref":"SoftBank.Cldr.Money.html#parse/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Money.parse/2","doc":"* `backend` is any module() that includes `use Cldr` and therefore\n  is a `Cldr` backend module(). The default is `Money.default_backend()`\n\n* `locale_name` is any valid locale name returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n  The default is ` .get_locale()`\n\n* `currency_filter` is an `atom` or list of `atoms` representing the\n  currency types to be considered for a match. If a list of\n  atoms is given, the currency must meet all criteria for\n  it to be considered.\n\n  * `:all`, the default, considers all currencies\n\n  * `:current` considers those currencies that have a `:to`\n    date of nil and which also is a known ISO4217 currency\n\n  * `:historic` is the opposite of `:current`\n\n  * `:tender` considers currencies that are legal tender\n\n  * `:unannotated` considers currencies that don't have\n    \"(some string)\" in their names.  These are usually\n    financial instruments.\n\n* `fuzzy` is a float greater than `0.0` and less than or\n  equal to `1.0` which is used as input to the\n  `String.jaro_distance/2` to determine is the provided\n  currency string is *close enough* to a known currency\n  string for it to identify definitively a currency code.\n  It is recommended to use numbers greater than `0.8` in\n  order to reduce false positives.\n\n* `:default_currency` is any valid currency code or `false`\n  that will used if no currency code, symbol or description is\n  indentified in the parsed string. The default is `nil`\n  which means that the default currency associated with\n  the `:locale` option will be used. If `false` then the\n  currency assocated with the `:locale` option will not be\n  used and an error will be returned if there is no currency\n  in the string being parsed.","ref":"SoftBank.Cldr.Money.html#parse/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.parse/2","doc":"* a `t:Money.t/0` if parsing is successful or\n\n* `{:error, {exception, reason}}` if an error is\n  detected.","ref":"SoftBank.Cldr.Money.html#parse/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.parse/2","doc":"iex> SoftBank.Cldr.Money.parse(\"USD 100\")\n    Money.new(:USD, \"100\")\n\n    iex> SoftBank.Cldr.Money.parse \"USD 100,00\", locale: \"de\"\n    Money.new(:USD, \"100.00\")\n\n    iex> SoftBank.Cldr.Money.parse(\"100 USD\")\n    Money.new(:USD, \"100\")\n\n    iex> SoftBank.Cldr.Money.parse(\"100 eurosports\", fuzzy: 0.8)\n    Money.new(:EUR, \"100\")\n\n    iex> SoftBank.Cldr.Money.parse(\"100 eurosports\", fuzzy: 0.9)\n    {:error,\n      {Money.UnknownCurrencyError, \"The currency \\\"eurosports\\\" is unknown or not supported\"}}\n\n    iex> SoftBank.Cldr.Money.parse(\"100 afghan afghanis\")\n    Money.new(:AFN, \"100\")\n\n    iex> SoftBank.Cldr.Money.parse(\"100\", default_currency: false)\n    {:error,\n      {Money.Invalid, \"A currency code, symbol or description must be specified but was not found in \\\"100\\\"\"}}\n\n    iex> SoftBank.Cldr.Money.parse(\"USD 100 with trailing text\")\n    {:error,\n      {Money.ParseError, \"Could not parse \\\"USD 100 with trailing text\\\".\"}}","ref":"SoftBank.Cldr.Money.html#parse/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.put_fraction/2","doc":"Set the fractional part of a `Money`.","ref":"SoftBank.Cldr.Money.html#put_fraction/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.put_fraction/2","doc":"* `money` is a ``t:Money.t/0`` struct\n\n* `fraction` is an integer amount that will be set\n  as the fraction of the `money`","ref":"SoftBank.Cldr.Money.html#put_fraction/2-arguments"},{"type":"function","title":"Notes - SoftBank.Cldr.Money.put_fraction/2","doc":"The fraction can only be set if it matches the number of\ndecimal digits for the currency associated with the `money`.\nTherefore, for a currency with 2 decimal digits, the\nmaximum for `fraction` is `99`.","ref":"SoftBank.Cldr.Money.html#put_fraction/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.put_fraction/2","doc":"iex> SoftBank.Cldr.Money.put_fraction Money.new(:USD, \"2.49\"), 99\n    Money.new(:USD, \"2.99\")\n\n    iex> SoftBank.Cldr.Money.put_fraction Money.new(:USD, \"2.49\"), 0\n    Money.new(:USD, \"2.0\")\n\n    iex> SoftBank.Cldr.Money.put_fraction Money.new(:USD, \"2.49\"), 999\n    {:error,\n     {Money.InvalidAmountError, \"Rounding up to 999 is invalid for currency :USD\"}}","ref":"SoftBank.Cldr.Money.html#put_fraction/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.reduce/1","doc":"","ref":"SoftBank.Cldr.Money.html#reduce/1"},{"type":"function","title":"SoftBank.Cldr.Money.round/2","doc":"Round a `Money` value into the acceptable range for the requested currency.","ref":"SoftBank.Cldr.Money.html#round/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.round/2","doc":"* `money` is a ``t:Money.t/0`` struct\n\n* `opts` is a keyword list of options","ref":"SoftBank.Cldr.Money.html#round/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Money.round/2","doc":"* `:rounding_mode` that defines how the number will be rounded.  See\n    `Decimal.Context`.  The default is `:half_even` which is also known\n    as \"banker's rounding\"\n\n  * `:currency_digits` which determines the rounding increment.\n    The valid options are `:cash`, `:accounting` and `:iso` or\n    an integer value representing the rounding factor.  The\n    default is `:iso`.","ref":"SoftBank.Cldr.Money.html#round/2-options"},{"type":"function","title":"Notes - SoftBank.Cldr.Money.round/2","doc":"There are two kinds of rounding applied:\n\n1. Round to the appropriate number of fractional digits\n\n3. Apply an appropriate rounding increment.  Most currencies\n   round to the same precision as the number of decimal digits, but some\n   such as `:CHF` round to a minimum such as `0.05` when its a cash\n   amount. The rounding increment is applied when the option\n   `:currency_digits` is set to `:cash`","ref":"SoftBank.Cldr.Money.html#round/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.round/2","doc":"iex> SoftBank.Cldr.Money.round Money.new(\"123.73\", :CHF), currency_digits: :cash\n    Money.new(:CHF, \"123.75\")\n\n    iex> SoftBank.Cldr.Money.round Money.new(\"123.73\", :CHF), currency_digits: 0\n    Money.new(:CHF, \"124\")\n\n    iex> SoftBank.Cldr.Money.round Money.new(\"123.7456\", :CHF)\n    Money.new(:CHF, \"123.75\")\n\n    iex> SoftBank.Cldr.Money.round Money.new(\"123.7456\", :JPY)\n    Money.new(:JPY, \"124\")","ref":"SoftBank.Cldr.Money.html#round/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.split/2","doc":"Split a `Money` value into a number of parts maintaining the currency's\nprecision and rounding and ensuring that the parts sum to the original\namount.","ref":"SoftBank.Cldr.Money.html#split/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.split/2","doc":"* `money` is any `t:Money.t/0` struct\n\n* `parts` is an integer number of parts into which the `money` is split\n\nReturns a tuple `{dividend, remainder}` as the function result\nderived as follows:\n\n1. Round the money amount to the required currency precision using\n`Money.round/1`\n\n2. Divide the result of step 1 by the integer divisor\n\n3. Round the result of the division to the precision of the currency\nusing `Money.round/1`\n\n4. Return two numbers: the result of the division and any remainder\nthat could not be applied given the precision of the currency.","ref":"SoftBank.Cldr.Money.html#split/2-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.split/2","doc":"SoftBank.Cldr.Money.split Money.new(123.5, :JPY), 3\n    {¥41, ¥1}\n\n    SoftBank.Cldr.Money.split Money.new(123.4, :JPY), 3\n    {¥41, ¥0}\n\n    SoftBank.Cldr.Money.split Money.new(123.7, :USD), 9\n    {$13.74, $0.04}","ref":"SoftBank.Cldr.Money.html#split/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.sub/2","doc":"Subtract one `Money` value struct from another.","ref":"SoftBank.Cldr.Money.html#sub/2"},{"type":"function","title":"Options - SoftBank.Cldr.Money.sub/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#sub/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.sub/2","doc":"* `{:ok, money}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.Money.html#sub/2-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.sub/2","doc":"iex> SoftBank.Cldr.Money.sub Money.new(:USD, 200), Money.new(:USD, 100)\n    {:ok, Money.new(:USD, 100)}","ref":"SoftBank.Cldr.Money.html#sub/2-example"},{"type":"function","title":"SoftBank.Cldr.Money.sub!/2","doc":"Subtract one `Money` value struct from another and raise on error.\n\nReturns either `{:ok, money}` or `{:error, reason}`.","ref":"SoftBank.Cldr.Money.html#sub!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.sub!/2","doc":"* `money_1` and `money_2` are any valid `t:Money.t/0` types returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#sub!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.sub!/2","doc":"* a `t:Money.t/0` struct or\n\n* raises an exception","ref":"SoftBank.Cldr.Money.html#sub!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.sub!/2","doc":"iex> SoftBank.Cldr.Money.sub! Money.new(:USD, 200), Money.new(:USD, 100)\n    Money.new(:USD, \"100\")\n\n    SoftBank.Cldr.Money.sub! Money.new(:USD, 200), Money.new(:CAD, 500)\n    ** (ArgumentError) Cannot subtract monies with different currencies. Received :USD and :CAD.","ref":"SoftBank.Cldr.Money.html#sub!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.to_currency/3","doc":"Convert `money` from one currency to another.","ref":"SoftBank.Cldr.Money.html#to_currency/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_currency/3","doc":"* `money` is any `t:Money.t/0` struct returned by `Cldr.Currency.new/2`\n\n* `to_currency` is a valid currency code into which the `money` is converted\n\n* `rates` is a `Map` of currency rates where the map key is an upcased\n  atom or string and the value is a Decimal conversion factor.  The default is the\n  latest available exchange rates returned from `Money.ExchangeRates.latest_rates()`","ref":"SoftBank.Cldr.Money.html#to_currency/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.to_currency/3","doc":"SoftBank.Cldr.Money.to_currency(Money.new(:USD, 100), :AUD, %{USD: Decimal.new(1), AUD: Decimal.from_float(0.7345)})\n    {:ok, Money.new(:AUD, \"73.4500\")}\n\n    SoftBank.Cldr.Money.to_currency(Money.new(\"USD\", 100), \"AUD\", %{\"USD\" => Decimal.new(1), \"AUD\" => Decimal.from_float(0.7345)})\n    {:ok, Money.new(:AUD, \"73.4500\")}\n\n    iex> SoftBank.Cldr.Money.to_currency Money.new(:USD, 100), :AUDD, %{USD: Decimal.new(1), AUD: Decimal.from_float(0.7345)}\n    {:error, {Cldr.UnknownCurrencyError, \"The currency :AUDD is invalid\"}}\n\n    iex> SoftBank.Cldr.Money.to_currency Money.new(:USD, 100), :CHF, %{USD: Decimal.new(1), AUD: Decimal.from_float(0.7345)}\n    {:error, {Money.ExchangeRateError, \"No exchange rate is available for currency :CHF\"}}","ref":"SoftBank.Cldr.Money.html#to_currency/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.to_currency!/3","doc":"Convert `money` from one currency to another and raises on error","ref":"SoftBank.Cldr.Money.html#to_currency!/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_currency!/3","doc":"* `money` is any `t:Money.t/0` struct returned by `Cldr.Currency.new/2`\n\n* `to_currency` is a valid currency code into which the `money` is converted\n\n* `rates` is a `Map` of currency rates where the map key is an upcased\n  atom or string and the value is a Decimal conversion factor.  The default is the\n  latest available exchange rates returned from `Money.ExchangeRates.latest_rates()`","ref":"SoftBank.Cldr.Money.html#to_currency!/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.to_currency!/3","doc":"iex> SoftBank.Cldr.Money.to_currency! Money.new(:USD, 100), :AUD, %{USD: Decimal.new(1), AUD: Decimal.from_float(0.7345)}\n    Money.new(:AUD, \"73.4500\")\n\n    iex> SoftBank.Cldr.Money.to_currency! Money.new(\"USD\", 100), \"AUD\", %{\"USD\" => Decimal.new(1), \"AUD\" => Decimal.from_float(0.7345)}\n    Money.new(:AUD, \"73.4500\")\n\n    SoftBank.Cldr.Money.to_currency! Money.new(:USD, 100), :ZZZ, %{USD: Decimal.new(1), AUD: Decimal.from_float(0.7345)}\n    ** (Cldr.UnknownCurrencyError) Currency :ZZZ is not known","ref":"SoftBank.Cldr.Money.html#to_currency!/3-examples"},{"type":"function","title":"SoftBank.Cldr.Money.to_decimal/1","doc":"Returns the amount part of a `Money` type as a `Decimal`","ref":"SoftBank.Cldr.Money.html#to_decimal/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_decimal/1","doc":"* `money` is any valid `t:Money.t/0` type returned\n  by `Money.new/2`","ref":"SoftBank.Cldr.Money.html#to_decimal/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.to_decimal/1","doc":"* a `Decimal.t`","ref":"SoftBank.Cldr.Money.html#to_decimal/1-returns"},{"type":"function","title":"Example - SoftBank.Cldr.Money.to_decimal/1","doc":"iex> m = SoftBank.Cldr.Money.new(\"USD\", 100)\n    iex> SoftBank.Cldr.Money.to_decimal(m)\n    Decimal.new(\"100\")","ref":"SoftBank.Cldr.Money.html#to_decimal/1-example"},{"type":"function","title":"SoftBank.Cldr.Money.to_integer_exp/1","doc":"Returns a tuple comprising the currency code, integer amount,\nexponent and remainder\n\nSome services require submission of money items as an integer\nwith an implied exponent that is appropriate to the currency.\n\nRather than return only the integer, `Money.to_integer_exp`\nreturns the currency code, integer, exponent and remainder.\nThe remainder is included because to return an integer\nmoney with an implied exponent the `Money` has to be rounded\npotentially leaving a remainder.","ref":"SoftBank.Cldr.Money.html#to_integer_exp/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_integer_exp/1","doc":"* `money` is any `t:Money.t/0` struct returned by `Cldr.Currency.new/2`","ref":"SoftBank.Cldr.Money.html#to_integer_exp/1-arguments"},{"type":"function","title":"Notes - SoftBank.Cldr.Money.to_integer_exp/1","doc":"* Since the returned integer is expected to have the implied fractional\ndigits the `Money` needs to be rounded which is what this function does.","ref":"SoftBank.Cldr.Money.html#to_integer_exp/1-notes"},{"type":"function","title":"Example - SoftBank.Cldr.Money.to_integer_exp/1","doc":"iex> m = SoftBank.Cldr.Money.new(:USD, \"200.012356\")\n    Money.new(:USD, \"200.012356\")\n    iex> SoftBank.Cldr.Money.to_integer_exp(m)\n    {:USD, 20001, -2, Money.new(:USD, \"0.002356\")}\n\n    iex> m = SoftBank.Cldr.Money.new(:USD, \"200.00\")\n    Money.new(:USD, \"200.00\")\n    iex> SoftBank.Cldr.Money.to_integer_exp(m)\n    {:USD, 20000, -2, Money.new(:USD, \"0.00\")}","ref":"SoftBank.Cldr.Money.html#to_integer_exp/1-example"},{"type":"function","title":"SoftBank.Cldr.Money.to_string/2","doc":"Returns a formatted string representation of a `Money{}`.\n\nFormatting is performed according to the rules defined by CLDR. See\n`Cldr.Number.to_string/2` for formatting options.  The default is to format\nas a currency which applies the appropriate rounding and fractional digits\nfor the currency.","ref":"SoftBank.Cldr.Money.html#to_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_string/2","doc":"* `money` is any valid `t:Money.t/0` type returned\n  by `Money.new/2`\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Money.html#to_string/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Money.to_string/2","doc":"* `{:ok, string}` or\n\n* `{:error, reason}`","ref":"SoftBank.Cldr.Money.html#to_string/2-returns"},{"type":"function","title":"Options - SoftBank.Cldr.Money.to_string/2","doc":"* `:backend` is any CLDR backend module.  The default is\n  `Money.default_backend()`.\n\n* Any other options are passed to `Cldr.Number.to_string/3`","ref":"SoftBank.Cldr.Money.html#to_string/2-options"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.to_string/2","doc":"iex> SoftBank.Cldr.Money.to_string Money.new(:USD, 1234)\n    {:ok, \"$1,234.00\"}\n\n    iex> SoftBank.Cldr.Money.to_string Money.new(:JPY, 1234)\n    {:ok, \"¥1,234\"}\n\n    iex> SoftBank.Cldr.Money.to_string Money.new(:THB, 1234)\n    {:ok, \"THB 1,234.00\"}\n\n    iex> SoftBank.Cldr.Money.to_string Money.new(:USD, 1234), format: :long\n    {:ok, \"1,234 US dollars\"}","ref":"SoftBank.Cldr.Money.html#to_string/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.to_string!/2","doc":"Returns a formatted string representation of a `t:Money.t/0` or raises if\nthere is an error.\n\nFormatting is performed according to the rules defined by CLDR. See\n`Cldr.Number.to_string!/2` for formatting options.  The default is to format\nas a currency which applies the appropriate rounding and fractional digits\nfor the currency.","ref":"SoftBank.Cldr.Money.html#to_string!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.to_string!/2","doc":"* `money` is any valid `t:Money.t/0` type returned\n  by `Money.new/2`\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Money.html#to_string!/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Money.to_string!/2","doc":"* `:backend` is any CLDR backend module.  The default is\n  `Money.default_backend()`.\n\n* Any other options are passed to `Cldr.Number.to_string/3`","ref":"SoftBank.Cldr.Money.html#to_string!/2-options"},{"type":"function","title":"Examples - SoftBank.Cldr.Money.to_string!/2","doc":"iex> SoftBank.Cldr.Money.to_string! Money.new(:USD, 1234)\n    \"$1,234.00\"\n\n    iex> SoftBank.Cldr.Money.to_string! Money.new(:JPY, 1234)\n    \"¥1,234\"\n\n    iex> SoftBank.Cldr.Money.to_string! Money.new(:THB, 1234)\n    \"THB 1,234.00\"\n\n    iex> SoftBank.Cldr.Money.to_string! Money.new(:USD, 1234), format: :long\n    \"1,234 US dollars\"","ref":"SoftBank.Cldr.Money.html#to_string!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Money.validate_currency/1","doc":"","ref":"SoftBank.Cldr.Money.html#validate_currency/1"},{"type":"function","title":"SoftBank.Cldr.Money.zero/2","doc":"Return a zero amount `t:Money` in the given currency.","ref":"SoftBank.Cldr.Money.html#zero/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Money.zero/2","doc":"* `money_or_currency` is either a `t:Money` or\n  a currency code\n\n* `options` is a keyword list of options passed\n  to `Money.new/3`. The default is `[]`.","ref":"SoftBank.Cldr.Money.html#zero/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Money.zero/2","doc":"iex> SoftBank.Cldr.Money.zero(:USD)\n    Money.new(:USD, \"0\")\n\n    iex> money = Money.new(:USD, 200)\n    iex> SoftBank.Cldr.Money.zero(money)\n    Money.new(:USD, \"0\")\n\n    iex> SoftBank.Cldr.Money.zero :ZZZ\n    {:error, {Cldr.UnknownCurrencyError, \"The currency :ZZZ is invalid\"}}","ref":"SoftBank.Cldr.Money.html#zero/2-example"},{"type":"module","title":"SoftBank.Cldr.Number","doc":"Formats numbers and currencies based upon CLDR's decimal formats specification.\n\nThe format specification is documentated in [Unicode TR35](http://unicode.org/reports/tr35/tr35-numbers.html#Number_Formats).\nThere are several classes of formatting including non-scientific, scientific,\nrules based (for spelling and ordinal formats), compact formats that display `1k`\nrather than `1,000` and so on.  See `Cldr.Number.to_string/2` for specific formatting\noptions.\n\n#","ref":"SoftBank.Cldr.Number.html"},{"type":"module","title":"Non-Scientific Notation Formatting - SoftBank.Cldr.Number","doc":"The following description applies to formats that do not use scientific\nnotation or significant digits:\n\n* If the number of actual integer digits exceeds the maximum integer digits,\n  then only the least significant digits are shown. For example, 1997 is\n  formatted as \"97\" if the maximum integer digits is set to 2.\n\n* If the number of actual integer digits is less than the minimum integer\n  digits, then leading zeros are added. For example, 1997 is formatted as\n  \"01997\" if the minimum integer digits is set to 5.\n\n* If the number of actual fraction digits exceeds the maximum fraction\n  digits, then half-even rounding it performed to the maximum fraction\n  digits. For example, 0.125 is formatted as \"0.12\" if the maximum fraction\n  digits is 2. This behavior can be changed by specifying a rounding\n  increment and a rounding mode.\n\n* If the number of actual fraction digits is less than the minimum fraction\n  digits, then trailing zeros are added. For example, 0.125 is formatted as\n  \"0.1250\" if the minimum fraction digits is set to 4.\n\n* Trailing fractional zeros are not displayed if they occur j positions after\n  the decimal, where j is less than the maximum fraction digits. For example,\n  0.10004 is formatted as \"0.1\" if the maximum fraction digits is four or\n  less.\n\n#","ref":"SoftBank.Cldr.Number.html#module-non-scientific-notation-formatting"},{"type":"module","title":"Scientific Notation Formatting - SoftBank.Cldr.Number","doc":"Numbers in scientific notation are expressed as the product of a mantissa and\na power of ten, for example, 1234 can be expressed as 1.234 x 10^3. The\nmantissa is typically in the half-open interval [1.0, 10.0) or sometimes\n[0.0, 1.0), but it need not be. In a pattern, the exponent character\nimmediately followed by one or more digit characters indicates scientific\nnotation. Example: \"0.###E0\" formats the number 1234 as \"1.234E3\".\n\n* The number of digit characters after the exponent character gives the\n  minimum exponent digit count. There is no maximum. Negative exponents are\n  formatted using the localized minus sign, not the prefix and suffix from\n  the pattern. This allows patterns such as \"0.###E0 m/s\". To prefix positive\n  exponents with a localized plus sign, specify '+' between the exponent and\n  the digits: \"0.###E+0\" will produce formats \"1E+1\", \"1E+0\", \"1E-1\", and so\n  on. (In localized patterns, use the localized plus sign rather than '+'.)\n\n* The minimum number of integer digits is achieved by adjusting the exponent.\n  Example: 0.00123 formatted with \"00.###E0\" yields \"12.3E-4\". This only\n  happens if there is no maximum number of integer digits. If there is a\n  maximum, then the minimum number of integer digits is fixed at one.\n\n* The maximum number of integer digits, if present, specifies the exponent\n  grouping. The most common use of this is to generate engineering notation,\n  in which the exponent is a multiple of three, for example, \"##0.###E0\". The\n  number 12345 is formatted using \"##0.####E0\" as \"12.345E3\".\n\n* When using scientific notation, the formatter controls the digit counts\n  using significant digits logic. The maximum number of significant digits\n  limits the total number of integer and fraction digits that will be shown\n  in the mantissa; it does not affect parsing. For example, 12345 formatted\n  with \"##0.##E0\" is \"12.3E3\". Exponential patterns may not contain grouping\n  separators.\n\n#","ref":"SoftBank.Cldr.Number.html#module-scientific-notation-formatting"},{"type":"module","title":"Significant Digits - SoftBank.Cldr.Number","doc":"There are two ways of controlling how many digits are shows: (a)\nsignificant digits counts, or (b) integer and fraction digit counts. Integer\nand fraction digit counts are described above. When a formatter is using\nsignificant digits counts, it uses however many integer and fraction digits\nare required to display the specified number of significant digits. It may\nignore min/max integer/fraction digits, or it may use them to the extent\npossible.","ref":"SoftBank.Cldr.Number.html#module-significant-digits"},{"type":"function","title":"SoftBank.Cldr.Number.parse/2","doc":"Parse a string locale-aware manner and return\na number.","ref":"SoftBank.Cldr.Number.html#parse/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.parse/2","doc":"* `string` is any `String.t`\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#parse/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.parse/2","doc":"* `:number` is one of `:integer`, `:float`,\n  `:decimal` or `nil`. The default is `nil`\n  meaning that the type auto-detected as either\n  an `integer` or a `float`.\n\n* `:locale` is any locale returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag.t`. The default is\n  `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.html#parse/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.parse/2","doc":"* A number of the requested or default type or\n\n* `{:error, {exception, error}}` if no number could be determined","ref":"SoftBank.Cldr.Number.html#parse/2-returns"},{"type":"function","title":"Notes - SoftBank.Cldr.Number.parse/2","doc":"This function parses a string to return a number but\nin a locale-aware manner. It will normalise grouping\ncharacters and decimal separators, different forms of\nthe `+` and `-` symbols that appear in Unicode and\nstrips any `_` characters that might be used for\nformatting in a string. It then parses the number\nusing the Elixir standard library functions.","ref":"SoftBank.Cldr.Number.html#parse/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.parse/2","doc":"iex> SoftBank.Cldr.Number.parse(\"＋1.000,34\", locale: \"de\")\n    {:ok, 1000.34}\n\n    iex> SoftBank.Cldr.Number.parse(\"-1_000_000.34\")\n    {:ok, -1000000.34}\n\n    iex> SoftBank.Cldr.Number.parse(\"1.000\", locale: \"de\", number: :integer)\n    {:ok, 1000}\n\n    iex> SoftBank.Cldr.Number.parse(\"＋1.000,34\", locale: \"de\", number: :integer)\n    {:error,\n      {Cldr.Number.ParseError,\n       \"The string \\\"＋1.000,34\\\" could not be parsed as a number\"}}","ref":"SoftBank.Cldr.Number.html#parse/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.resolve_currencies/2","doc":"Resolve curencies from strings within\na list.","ref":"SoftBank.Cldr.Number.html#resolve_currencies/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.resolve_currencies/2","doc":"* `list` is any list in which currency\n  names and symbols are expected\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#resolve_currencies/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.resolve_currencies/2","doc":"* `:locale` is any valid locale returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n  The default is `SoftBank.Cldr.get_locale()`\n\n* `:only` is an `atom` or list of `atoms` representing the\n  currencies or currency types to be considered for a match.\n  The equates to a list of acceptable currencies for parsing.\n  See the notes below for currency types.\n\n* `:except` is an `atom` or list of `atoms` representing the\n  currencies or currency types to be not considered for a match.\n  This equates to a list of unacceptable currencies for parsing.\n  See the notes below for currency types.\n\n* `:fuzzy` is a float greater than `0.0` and less than or\n  equal to `1.0` which is used as input to\n  `String.jaro_distance/2` to determine is the provided\n  currency string is *close enough* to a known currency\n  string for it to identify definitively a currency code.\n  It is recommended to use numbers greater than `0.8` in\n  order to reduce false positives.","ref":"SoftBank.Cldr.Number.html#resolve_currencies/2-options"},{"type":"function","title":"Notes - SoftBank.Cldr.Number.resolve_currencies/2","doc":"The `:only` and `:except` options accept a list of\ncurrency codes and/or currency types.  The following\ntypes are recognised.\n\nIf both `:only` and `:except` are specified,\nthe `:except` entries take priority - that means\nany entries in `:except` are removed from the `:only`\nentries.\n\n  * `:all`, the default, considers all currencies\n\n  * `:current` considers those currencies that have a `:to`\n    date of nil and which also is a known ISO4217 currency\n\n  * `:historic` is the opposite of `:current`\n\n  * `:tender` considers currencies that are legal tender\n\n  * `:unannotated` considers currencies that don't have\n    \"(some string)\" in their names.  These are usually\n    financial instruments.","ref":"SoftBank.Cldr.Number.html#resolve_currencies/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.resolve_currencies/2","doc":"iex> SoftBank.Cldr.Number.scan(\"100 US dollars\")\n    ...> |> SoftBank.Cldr.Number.resolve_currencies\n    [100, :USD]\n\n    iex> SoftBank.Cldr.Number.scan(\"100 eurosports\")\n    ...> |> SoftBank.Cldr.Number.resolve_currencies(fuzzy: 0.75)\n    [100, :EUR]\n\n    iex> SoftBank.Cldr.Number.scan(\"100 dollars des États-Unis\")\n    ...> |> SoftBank.Cldr.Number.resolve_currencies(locale: \"fr\")\n    [100, :USD]","ref":"SoftBank.Cldr.Number.html#resolve_currencies/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.resolve_currency/2","doc":"Resolve a currency from a string","ref":"SoftBank.Cldr.Number.html#resolve_currency/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.resolve_currency/2","doc":"* `list` is any list in which currency\n  names and symbols are expected\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#resolve_currency/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.resolve_currency/2","doc":"* `:locale` is any valid locale returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n  The default is `SoftBank.Cldr.get_locale()`\n\n* `:only` is an `atom` or list of `atoms` representing the\n  currencies or currency types to be considered for a match.\n  The equates to a list of acceptable currencies for parsing.\n  See the notes below for currency types.\n\n* `:except` is an `atom` or list of `atoms` representing the\n  currencies or currency types to be not considered for a match.\n  This equates to a list of unacceptable currencies for parsing.\n  See the notes below for currency types.\n\n* `:fuzzy` is a float greater than `0.0` and less than or\n  equal to `1.0` which is used as input to\n  `String.jaro_distance/2` to determine is the provided\n  currency string is *close enough* to a known currency\n  string for it to identify definitively a currency code.\n  It is recommended to use numbers greater than `0.8` in\n  order to reduce false positives.","ref":"SoftBank.Cldr.Number.html#resolve_currency/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.resolve_currency/2","doc":"* An ISO4217 currency code as an atom or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.html#resolve_currency/2-returns"},{"type":"function","title":"Notes - SoftBank.Cldr.Number.resolve_currency/2","doc":"The `:only` and `:except` options accept a list of\ncurrency codes and/or currency types.  The following\ntypes are recognised.\n\nIf both `:only` and `:except` are specified,\nthe `:except` entries take priority - that means\nany entries in `:except` are removed from the `:only`\nentries.\n\n  * `:all`, the default, considers all currencies\n\n  * `:current` considers those currencies that have a `:to`\n    date of nil and which also is a known ISO4217 currency\n\n  * `:historic` is the opposite of `:current`\n\n  * `:tender` considers currencies that are legal tender\n\n  * `:unannotated` considers currencies that don't have\n    \"(some string)\" in their names.  These are usually\n    financial instruments.","ref":"SoftBank.Cldr.Number.html#resolve_currency/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.resolve_currency/2","doc":"iex> SoftBank.Cldr.Number.resolve_currency(\"US dollars\")\n    [:USD]\n\n    iex> SoftBank.Cldr.Number.resolve_currency(\"100 eurosports\", fuzzy: 0.75)\n    [:EUR]\n\n    iex> SoftBank.Cldr.Number.resolve_currency(\"dollars des États-Unis\", locale: \"fr\")\n    [:USD]\n\n    iex> SoftBank.Cldr.Number.resolve_currency(\"not a known currency\", locale: \"fr\")\n    {:error,\n     {Cldr.UnknownCurrencyError,\n      \"The currency \\\"not a known currency\\\" is unknown or not supported\"}}","ref":"SoftBank.Cldr.Number.html#resolve_currency/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.resolve_per/2","doc":"Resolve and tokenize percent or permille\nfrom the beginning and/or the end of a string","ref":"SoftBank.Cldr.Number.html#resolve_per/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.resolve_per/2","doc":"* `list` is any list in which percent\n  and permille symbols are expected\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#resolve_per/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.resolve_per/2","doc":"* `:locale` is any valid locale returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n  The default is `options[:backend].get_locale()`","ref":"SoftBank.Cldr.Number.html#resolve_per/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.resolve_per/2","doc":"* An `:percent` or `permille` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.html#resolve_per/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.resolve_per/2","doc":"iex> SoftBank.Cldr.Number.resolve_per \"11%\"\n    [\"11\", :percent]\n\n    iex> SoftBank.Cldr.Number.resolve_per \"% of linguists\"\n    [:percent, \" of linguists\"]\n\n    iex> SoftBank.Cldr.Number.resolve_per \"% of linguists %\"\n    [:percent, \" of linguists \", :percent]","ref":"SoftBank.Cldr.Number.html#resolve_per/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.resolve_pers/2","doc":"Resolve and tokenize percent and permille\nsybols from strings within a list.\n\nPercent and permille symbols can be identified\nat the beginning and/or the end of a string.","ref":"SoftBank.Cldr.Number.html#resolve_pers/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.resolve_pers/2","doc":"* `list` is any list in which percent and\n  permille symbols are expected\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#resolve_pers/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.resolve_pers/2","doc":"* `:locale` is any valid locale returned by `Cldr.known_locale_names/1`\n  or a `t:Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n  The default is `options[:backend].get_locale()`","ref":"SoftBank.Cldr.Number.html#resolve_pers/2-options"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.resolve_pers/2","doc":"iex> SoftBank.Cldr.Number.scan(\"100%\")\n    ...> |> SoftBank.Cldr.Number.resolve_pers()\n    [100, :percent]","ref":"SoftBank.Cldr.Number.html#resolve_pers/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.scan/2","doc":"Scans a string locale-aware manner and returns\na list of strings and numbers.","ref":"SoftBank.Cldr.Number.html#scan/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.scan/2","doc":"* `string` is any `String.t`\n\n* `options` is a keyword list of options","ref":"SoftBank.Cldr.Number.html#scan/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.scan/2","doc":"* `:number` is one of `:integer`, `:float`,\n  `:decimal` or `nil`. The default is `nil`\n  meaning that the type auto-detected as either\n  an `integer` or a `float`.\n\n* `:locale` is any locale returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag.t`. The default is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.html#scan/2-options"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.scan/2","doc":"* A list of strings and numbers","ref":"SoftBank.Cldr.Number.html#scan/2-returns"},{"type":"function","title":"Notes - SoftBank.Cldr.Number.scan/2","doc":"Number parsing is performed by `Cldr.Number.Parser.parse/2`\nand any options provided are passed to that function.","ref":"SoftBank.Cldr.Number.html#scan/2-notes"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.scan/2","doc":"iex> SoftBank.Cldr.Number.scan(\"£1_000_000.34\")\n    [\"£\", 1000000.34]\n\n    iex> SoftBank.Cldr.Number.scan(\"I want £1_000_000 dollars\")\n    [\"I want £\", 1000000, \" dollars\"]\n\n    iex> SoftBank.Cldr.Number.scan(\"The prize is 23\")\n    [\"The prize is \", 23]\n\n    iex> SoftBank.Cldr.Number.scan(\"The lottery number is 23 for the next draw\")\n    [\"The lottery number is \", 23, \" for the next draw\"]\n\n    iex> SoftBank.Cldr.Number.scan(\"The loss is -1.000 euros\", locale: \"de\", number: :integer)\n    [\"The loss is \", -1000, \" euros\"]","ref":"SoftBank.Cldr.Number.html#scan/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.to_approx_string/2","doc":"Formats a number and applies the `:approximately` format for\na locale and number system.","ref":"SoftBank.Cldr.Number.html#to_approx_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_approx_string/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted.\n  See `Cldr.Number.to_string/3` for a description of the available\n  options.","ref":"SoftBank.Cldr.Number.html#to_approx_string/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.to_approx_string/2","doc":"iex> SoftBank.Cldr.Number.to_approx_string 1234\n    {:ok, \"~1,234\"}","ref":"SoftBank.Cldr.Number.html#to_approx_string/2-example"},{"type":"function","title":"SoftBank.Cldr.Number.to_at_least_string/2","doc":"Formats a number and applies the `:at_least` format for\na locale and number system.","ref":"SoftBank.Cldr.Number.html#to_at_least_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_at_least_string/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted.\n  See `SoftBank.Cldr.Number.to_string/2` for a description of the available\n  options.","ref":"SoftBank.Cldr.Number.html#to_at_least_string/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.to_at_least_string/2","doc":"iex> SoftBank.Cldr.Number.to_at_least_string 1234\n    {:ok, \"1,234+\"}","ref":"SoftBank.Cldr.Number.html#to_at_least_string/2-example"},{"type":"function","title":"SoftBank.Cldr.Number.to_at_most_string/2","doc":"Formats a number and applies the `:at_most` format for\na locale and number system.","ref":"SoftBank.Cldr.Number.html#to_at_most_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_at_most_string/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted.\n  See `Cldr.Number.to_string/3` for a description of the available\n  options.","ref":"SoftBank.Cldr.Number.html#to_at_most_string/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.to_at_most_string/2","doc":"iex> SoftBank.Cldr.Number.to_at_most_string 1234\n    {:ok, \"≤1,234\"}","ref":"SoftBank.Cldr.Number.html#to_at_most_string/2-example"},{"type":"function","title":"SoftBank.Cldr.Number.to_range_string/2","doc":"Formats the first and last numbers of a range and applies\nthe `:range` format for a locale and number system.","ref":"SoftBank.Cldr.Number.html#to_range_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_range_string/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted.\n  See `Cldr.Number.to_string/3` for a description of the available\n  options.","ref":"SoftBank.Cldr.Number.html#to_range_string/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.to_range_string/2","doc":"iex> SoftBank.Cldr.Number.to_range_string 1234..5678\n    {:ok, \"1,234–5,678\"}","ref":"SoftBank.Cldr.Number.html#to_range_string/2-example"},{"type":"function","title":"SoftBank.Cldr.Number.to_string/2","doc":"Returns a number formatted into a string according to a format pattern and options.","ref":"SoftBank.Cldr.Number.html#to_string/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_string/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted.","ref":"SoftBank.Cldr.Number.html#to_string/2-arguments"},{"type":"function","title":"Options - SoftBank.Cldr.Number.to_string/2","doc":"* `format`: the format style or a format string defining how the number is\n  formatted. See `Cldr.Number.Format` for how format strings can be constructed.\n  See `Cldr.Number.Format.format_styles_for/3` to return available format styles\n  for a locale. The default `format` is `:standard`.\n\n* If `:format` is set to `:long` or `:short` then the formatting depends on\n  whether `:currency` is specified. If not specified then the number is\n  formatted as `:decimal_long` or `:decimal_short`. If `:currency` is\n  specified the number is formatted as `:currency_long` or\n  `:currency_short` and `:fractional_digits` is set to 0 as a default.\n\n* `:format` may also be a format defined by CLDR's Rules Based Number\n  Formats (RBNF).  Further information is found in the module `Cldr.Rbnf`.\n  The most commonly used formats in this category are to spell out the\n  number in a the locales language.  The applicable formats are `:spellout`,\n  `:spellout_year`, `:ordinal`.  A number can also be formatted as roman\n  numbers by using the format `:roman` or `:roman_lower`.\n\n* `currency`: is the currency for which the number is formatted. For\n  available currencies see `Cldr.Currency.known_currencies/0`. This option\n  is required if `:format` is set to `:currency`.  If `currency` is set\n  and no `:format` is set, `:format` will be set to `:currency` as well.\n\n* `currency_symbol`: Allows overriding a currency symbol. The alternatives\n  are:\n  * `:iso` the ISO currency code will be used instead of the default\n    currency symbol.\n  * `:narrow` uses the narrow symbol defined for the locale. The same\n    narrow symbol can be defined for more than one currency and therefore this\n    should be used with care. If no narrow symbol is defined, the standard\n    symbol is used.\n  * `:symbol` uses the standard symbol defined in CLDR. A symbol is unique\n    for each currency and can be safely used.\n  * \"string\" uses `string` as the currency symbol\n  * `:standard` (the default and recommended) uses the CLDR-defined symbol\n    based upon the currency format for the locale.\n\n* `:cash`: a boolean which indicates whether a number being formatted as a\n  `:currency` is to be considered a cash value or not. Currencies can be\n  rounded differently depending on whether `:cash` is `true` or `false`.\n  *This option is deprecated in favour of `currency_digits: :cash`.\n\n* `:currency_digits` indicates which of the rounding and digits should be\n  used. The options are `:accounting` which is the default, `:cash` or\n  `:iso`\n\n* `:rounding_mode`: determines how a number is rounded to meet the precision\n  of the format requested. The available rounding modes are `:down`,\n  :half_up, :half_even, :ceiling, :floor, :half_down, :up. The default is\n  `:half_even`.\n\n* `:number_system`: determines which of the number systems for a locale\n  should be used to define the separators and digits for the formatted\n  number. If `number_system` is an `atom` then `number_system` is\n  interpreted as a number system. If the `:number_system` is\n  `binary` then it is interpreted as a number system name. See\n  `Cldr.Number.System.number_system_names_for/2`. The default is `:default`.\n\n* `:locale`: determines the locale in which the number is formatted. See\n  `Cldr.known_locale_names/0`. The default is`Cldr.get_locale/0` which is the\n  locale currently in affect for this `Process` and which is set by\n  `Cldr.put_locale/1`.\n\n* If `:fractional_digits` is set to a positive integer value then the number\n  will be rounded to that number of digits and displayed accordingly - overriding\n  settings that would be applied by default.  For example, currencies have\n  fractional digits defined reflecting each currencies minor unit.  Setting\n  `:fractional_digits` will override that setting.\n\n* If `:maximum_integer_digits` is set to a positive integer value then the\n  number is left truncated before formatting. For example if the number `1234`\n  is formatted with the option `maximum_integer_digits: 2`, the number is\n  truncated to `34` and formatted.\n\n* If `:round_nearest` is set to a positive integer value then the number\n  will be rounded to nearest increment of that value - overriding\n  settings that would be applied by default.\n\n* `:minimum_grouping_digits` overrides the CLDR definition of minimum grouping\n  digits. For example in the locale `es` the number `1234` is formatted by default\n  as `1345` because the locale defines the `minimium_grouping_digits` as `2`. If\n  `minimum_grouping_digits: 1` is set as an option the number is formatting as\n  `1.345`. The `:minimum_grouping_digits` is added to the grouping defined by\n  the number format.  If the sum of these two digits is greater than the number\n  of digits in the integer (or fractional) part of the number then no grouping\n  is performed.\n\n* `:wrapper` is a 2-arity function that will be called for each number component\n  with parameters `string` and `tag` where `tag` is one of `:number`,\n  `:currency_symbol`, `:currency_space`, `:literal`, `:quote`, `:percent`,\n  `:permille`, `:minus` or `:plus`. The function must return a string. The\n  function can be used to wrap format elements in HTML or other tags.","ref":"SoftBank.Cldr.Number.html#to_string/2-options"},{"type":"function","title":"Locale extensions affecting formatting - SoftBank.Cldr.Number.to_string/2","doc":"A locale identifier can specify options that affect number formatting.\nThese options are:\n\n* `nu`: defines the number system to be used if none is specified by the `:number_system`\n  option to `to_string/2`\n\nThis key is part of the [u extension](https://unicode.org/reports/tr35/#u_Extension) and\nthat document should be consulted for details on how to construct a locale identifier with these\nextensions.","ref":"SoftBank.Cldr.Number.html#to_string/2-locale-extensions-affecting-formatting"},{"type":"function","title":"Wrapping format elements - SoftBank.Cldr.Number.to_string/2","doc":"Wrapping elements is particularly useful when formatting a number with a\ncurrency symbol and the requirement is to have different HTML formatting\napplied to the symbol than the number.  For example:\n\n    iex> Cldr.Number.to_string(100, format: :currency, currency: :USD, wrapper: fn\n    ...>   string, :currency_symbol -> \" \"   string   \" \"\n    ...>   string, :number -> \" \"   string   \" \"\n    ...>   string, :currency_space -> \" \"   string   \" \"\n    ...>   string, _other -> string\n    ...> end)\n    {:ok, \" $  100.00 \"}\n\nIt is also possible and recommended to use the `Phoenix.HTML.Tag.content_tag/3`\nfunction if wrapping HTML tags since these will ensure HTML entities are\ncorrectly encoded.  For example:\n\n    iex> Cldr.Number.to_string(100, format: :currency, currency: :USD, wrapper: fn\n    ...>   string, :currency_symbol -> Phoenix.HTML.Tag.content_tag(:span, string, class: \"symbol\")\n    ...>   string, :number -> Phoenix.HTML.Tag.content_tag(:span, string, class: \"number\")\n    ...>   string, :currency_space -> Phoenix.HTML.Tag.content_tag(:span, string)\n    ...>   string, _other -> string\n    ...> end)\n    {:ok, \" $  100.00 \"}\n\nWhen formatting a number the format is parsed into format elements that might include\na currency symbol, a literal string, inserted text between a currency symbol and the\ncurrency amount, a percent sign, the number itself and several other elements.  In\nsome cases it is helpful to be apply specific formatting to each element.\nThis can be achieved by specifying a `:wrapper` option. This option takes a 2-arity\nfunction as an argument. For each element of the format the wrapper function is called\nwith two parameters:  the format element as a string and an atom representing the\nelement type. The wrapper function is required to return a string that is then\ninserted in the final formatted number.","ref":"SoftBank.Cldr.Number.html#to_string/2-wrapping-format-elements"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.to_string/2","doc":"* `{:ok, string}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.html#to_string/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.to_string/2","doc":"iex> SoftBank.Cldr.Number.to_string 12345\n    {:ok, \"12,345\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, locale: \"fr\"\n    {:ok, \"12 345\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1345.32, currency: :EUR, locale: \"es\", minimum_grouping_digits: 1\n    {:ok, \"1.345,32 €\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1345.32, currency: :EUR, locale: \"es\"\n    {:ok, \"1345,32 €\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, locale: \"fr\", currency: \"USD\"\n    {:ok, \"12 345,00 $US\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, format: \"#E0\"\n    {:ok, \"1.2345E4\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, format: :accounting, currency: \"THB\"\n    {:ok, \"THB 12,345.00\"}\n\n    iex> SoftBank.Cldr.Number.to_string -12345, format: :accounting, currency: \"THB\"\n    {:ok, \"(THB 12,345.00)\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, format: :accounting, currency: \"THB\",\n    ...> locale: \"th\"\n    {:ok, \"฿12,345.00\"}\n\n    iex> SoftBank.Cldr.Number.to_string 12345, format: :accounting, currency: \"THB\",\n    ...> locale: \"th\", number_system: :native\n    {:ok, \"฿๑๒,๓๔๕.๐๐\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1244.30, format: :long\n    {:ok, \"1 thousand\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1244.30, format: :long, currency: \"USD\"\n    {:ok, \"1,244 US dollars\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1244.30, format: :short\n    {:ok, \"1K\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1244.30, format: :short, currency: \"EUR\"\n    {:ok, \"€1K\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1234, format: :spellout\n    {:ok, \"one thousand two hundred thirty-four\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1234, format: :spellout_verbose\n    {:ok, \"one thousand two hundred and thirty-four\"}\n\n    iex> SoftBank.Cldr.Number.to_string 1989, format: :spellout_year\n    {:ok, \"nineteen eighty-nine\"}\n\n    iex> SoftBank.Cldr.Number.to_string 123, format: :ordinal\n    {:ok, \"123rd\"}\n\n    iex> SoftBank.Cldr.Number.to_string 123, format: :roman\n    {:ok, \"CXXIII\"}\n\n    iex> SoftBank.Cldr.Number.to_string 123, locale: \"th-u-nu-thai\"\n    {:ok, \"๑๒๓\"}","ref":"SoftBank.Cldr.Number.html#to_string/2-examples"},{"type":"function","title":"Errors - SoftBank.Cldr.Number.to_string/2","doc":"An error tuple `{:error, reason}` will be returned if an error is detected.\nThe two most likely causes of an error return are:\n\n  * A format cannot be compiled. In this case the error tuple will look like:\n\n```\n    iex> SoftBank.Cldr.Number.to_string(12345, format: \"0#\")\n    {:error, {Cldr.FormatCompileError,\n      \"Decimal format compiler: syntax error before: \\\"#\\\"\"}}\n```\n\n  * The format style requested is not defined for the `locale` and\n    `number_system`. This happens typically when the number system is\n    `:algorithmic` rather than the more common `:numeric`. In this case the error\n    return looks like:\n\n```\n    iex> SoftBank.Cldr.Number.to_string(1234, locale: \"he\", number_system: \"hebr\")\n    {:error, {Cldr.UnknownFormatError,\n      \"The locale :he with number system :hebr does not define a format :standard\"}}\n```","ref":"SoftBank.Cldr.Number.html#to_string/2-errors"},{"type":"function","title":"SoftBank.Cldr.Number.to_string!/2","doc":"Same as the execution of `to_string/2` but raises an exception if an error would be\nreturned.","ref":"SoftBank.Cldr.Number.html#to_string!/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.to_string!/2","doc":"* `number` is an integer, float or Decimal to be formatted\n\n* `options` is a keyword list defining how the number is to be formatted. See\n  `SoftBank.Cldr.Number.to_string/2`","ref":"SoftBank.Cldr.Number.html#to_string!/2-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.to_string!/2","doc":"* a formatted number as a string or\n\n* raises an exception","ref":"SoftBank.Cldr.Number.html#to_string!/2-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.to_string!/2","doc":"iex> SoftBank.Cldr.Number.to_string! 12345\n    \"12,345\"\n\n    iex> SoftBank.Cldr.Number.to_string! 12345, locale: \"fr\"\n    \"12 345\"","ref":"SoftBank.Cldr.Number.html#to_string!/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.validate_number_system/2","doc":"Return a valid number system from a provided locale and number\nsystem name or type.\n\nThe number system or number system type must be valid for the\ngiven locale.  If a number system type is provided, the\nunderlying number system is returned.","ref":"SoftBank.Cldr.Number.html#validate_number_system/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.validate_number_system/2","doc":"* `locale` is any valid locale name returned by `Cldr.known_locale_names/1`\n  or a `Cldr.LanguageTag` struct returned by `Cldr.Locale.new!/2`\n\n* `system_name` is any number system name returned by\n  `Cldr.known_number_systems/0` or a number system type\n  returned by `Cldr.known_number_system_types/0`","ref":"SoftBank.Cldr.Number.html#validate_number_system/2-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.validate_number_system/2","doc":"iex> SoftBank.Cldr.Number.validate_number_system \"en\", :latn\n    {:ok, :latn}\n\n    iex> SoftBank.Cldr.Number.validate_number_system \"en\", :default\n    {:ok, :latn}\n\n    iex> SoftBank.Cldr.Number.validate_number_system \"en\", :unknown\n    {:error,\n     {Cldr.UnknownNumberSystemError, \"The number system :unknown is unknown\"}}\n\n    iex> SoftBank.Cldr.Number.validate_number_system \"zz\", :default\n    {:error, {Cldr.InvalidLanguageError, \"The language \\\"zz\\\" is invalid\"}}","ref":"SoftBank.Cldr.Number.html#validate_number_system/2-examples"},{"type":"module","title":"SoftBank.Cldr.Number.Cardinal","doc":"Implements cardinal plural rules for numbers.","ref":"SoftBank.Cldr.Number.Cardinal.html"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.available_locale_names/0","doc":"The locale names for which plural rules are defined.","ref":"SoftBank.Cldr.Number.Cardinal.html#available_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.known_locale_names/0","doc":"The configured locales for which plural rules are defined.\n\nReturns the intersection of `SoftBank.Cldr.known_locale_names/0` and\nthe locales for which Cardinal plural rules are defined.\n\nThere are many `Cldr` locales which don't have their own plural\nrules so this list is the intersection of `Cldr`'s configured\nlocales and those that have rules.","ref":"SoftBank.Cldr.Number.Cardinal.html#known_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.plural_rule/3","doc":"Return the plural key for a given number in a given locale\n\nReturns which plural key (`:zero`, `:one`, `:two`, `:few`,\n`:many` or `:other`) a given number fits into within the\ncontext of a given locale.\n\nNote that these key names should not be interpreted\nliterally.  For example, the key returned from\n`Cldr.Number.Ordinal.plural_rule(0, \"en\")` is actually\n`:other`, not `:zero`.\n\nThis key can then be used to format a number, date, time, unit,\nlist or other content in a plural-sensitive way.","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rule/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Cardinal.plural_rule/3","doc":"* `number` is any `integer`, `float` or `Decimal`\n\n* `locale` is any locale returned by `Cldr.Locale.new!/2` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\n* `rounding` is one of `[:down, :up, :ceiling, :floor, :half_even, :half_up, :half_down]`.  The\n  default is `:half_even`.","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rule/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Cardinal.plural_rule/3","doc":"iex> SoftBank.Cldr.Number.Cardinal.plural_rule 0, \"fr\"\n    :one\n\n    iex> SoftBank.Cldr.Number.Cardinal.plural_rule 0, \"en\"\n    :other","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rule/3-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.plural_rules/0","doc":"Returns all the plural rules defined in CLDR.","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rules/0"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.plural_rules_for/1","doc":"Return the plural rules for a locale.","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rules_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Cardinal.plural_rules_for/1","doc":"* `locale` is any locale returned by `SoftBank.Cldr.Locale.new!/1` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\nThe rules are returned in AST form after parsing.","ref":"SoftBank.Cldr.Number.Cardinal.html#plural_rules_for/1-arguments"},{"type":"function","title":"SoftBank.Cldr.Number.Cardinal.pluralize/3","doc":"Pluralize a number using cardinal plural rules\nand a substitution map.","ref":"SoftBank.Cldr.Number.Cardinal.html#pluralize/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Cardinal.pluralize/3","doc":"* `number` is an integer, float or Decimal\n\n* `locale` is any locale returned by `SoftBank.Cldr.Locale.new!/1` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\n* `substitutions` is a map that maps plural keys to a string.\n  The valid substitution keys are `:zero`, `:one`, `:two`,\n  `:few`, `:many` and `:other`.\n\nSee also `SoftBank.Cldr.Number.Cardinal.Cardinal.plural_rule/3`.","ref":"SoftBank.Cldr.Number.Cardinal.html#pluralize/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Cardinal.pluralize/3","doc":"iex> SoftBank.Cldr.Number.Cardinal.pluralize 1, \"en\", %{one: \"one\"}\n    \"one\"\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize 2, \"en\", %{one: \"one\"}\n    nil\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize 2, \"en\", %{one: \"one\", two: \"two\", other: \"other\"}\n    \"other\"\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize 22, \"en\", %{one: \"one\", two: \"two\", other: \"other\"}\n    \"other\"\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize Decimal.new(1), \"en\", %{one: \"one\"}\n    \"one\"\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize Decimal.new(2), \"en\", %{one: \"one\"}\n    nil\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize Decimal.new(2), \"en\", %{one: \"one\", two: \"two\"}\n    nil\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize 1..10, \"ar\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"few\"\n\n    iex> SoftBank.Cldr.Number.Cardinal.pluralize 1..10, \"en\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"","ref":"SoftBank.Cldr.Number.Cardinal.html#pluralize/3-examples"},{"type":"module","title":"SoftBank.Cldr.Number.Format","doc":"Functions to manage the collection of number patterns defined in Cldr.\n\nNumber patterns affect how numbers are interpreted in a localized context.\nHere are some examples, based on the French locale. The \".\" shows where the\ndecimal point should go. The \",\" shows where the thousands separator should\ngo. A \"0\" indicates zero-padding: if the number is too short, a zero (in the\nlocale's numeric set) will go there. A \"#\" indicates no padding: if the\nnumber is too short, nothing goes there. A \"¤\" shows where the currency sign\nwill go. The following illustrates the effects of different patterns for the\nFrench locale, with the number \"1234.567\". Notice how the pattern characters\n',' and '.' are replaced by the characters appropriate for the locale.","ref":"SoftBank.Cldr.Number.Format.html"},{"type":"module","title":"Number Pattern Examples - SoftBank.Cldr.Number.Format","doc":"| Pattern\t      | Currency\t      | Text        |\n| ------------- | :-------------: | ----------: |\n| #,##0.##\t    | n/a\t            | 1 234,57    |\n| #,##0.###\t    | n/a\t            | 1 234,567   |\n| ###0.#####\t  | n/a\t            | 1234,567    |\n| ###0.0000#\t  | n/a\t            | 1234,5670   |\n| 00000.0000\t  | n/a\t            | 01234,5670  |\n| #,##0.00 ¤\t  | EUR\t            | 1 234,57 €  |\n\nThe number of # placeholder characters before the decimal do not matter,\nsince no limit is placed on the maximum number of digits. There should,\nhowever, be at least one zero some place in the pattern. In currency formats,\nthe number of digits after the decimal also do not matter, since the\ninformation in the supplemental data (see Supplemental Currency Data) is used\nto override the number of decimal places — and the rounding — according to\nthe currency that is being formatted. That can be seen in the above chart,\nwith the difference between Yen and Euro formatting.\n\nDetails of the number formats are described in the\n[Unicode documentation](http://unicode.org/reports/tr35/tr35-numbers.html#Number_Format_Patterns)","ref":"SoftBank.Cldr.Number.Format.html#module-number-pattern-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Format.all_formats_for/1","doc":"Returns the decimal formats defined for a given locale.","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.all_formats_for/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.all_formats_for/1","doc":"* `{:ok, map}` where map is a map of decimal formats\n  keyed by number system or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for/1-returns"},{"type":"function","title":"SoftBank.Cldr.Number.Format.all_formats_for!/1","doc":"Returns the decimal formats defined for a given locale.","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for!/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.all_formats_for!/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for!/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.all_formats_for!/1","doc":"* `{:ok, map}` where map is a map of decimal formats\n  keyed by number system or\n\n* raises an exception\n\nSee `SoftBank.Cldr.Number.Format.Number.Format.all_formats_for/1` for further information.","ref":"SoftBank.Cldr.Number.Format.html#all_formats_for!/1-returns"},{"type":"function","title":"SoftBank.Cldr.Number.Format.currency_spacing/2","doc":"Returns the currency space for a given locale and\nnumber system.","ref":"SoftBank.Cldr.Number.Format.html#currency_spacing/2"},{"type":"function","title":"SoftBank.Cldr.Number.Format.decimal_format_list/0","doc":"Returns the list of decimal formats in the configured locales including\nthe list of locales configured for precompilation in `config.exs`.\n\nThis function exists to allow the decimal formatter\nto precompile all the known formats at compile time.","ref":"SoftBank.Cldr.Number.Format.html#decimal_format_list/0"},{"type":"function","title":"Example - SoftBank.Cldr.Number.Format.decimal_format_list/0","doc":"#=> SoftBank.Cldr.Number.Format.Format.decimal_format_list\n    [\"#\", \"#,##,##0%\",\n    \"#,##,##0.###\", \"#,##,##0.00¤\", \"#,##,##0.00¤;(#,##,##0.00¤)\",\n    \"#,##,##0 %\", \"#,##0%\", \"#,##0.###\", \"#,##0.00 ¤\",\n    \"#,##0.00 ¤;(#,##0.00 ¤)\", \"#,##0.00¤\", \"#,##0.00¤;(#,##0.00¤)\",\n    \"#,##0 %\", \"#0%\", \"#0.######\", \"#0.00 ¤\", \"#E0\", \"%#,##0\", \"% #,##0\",\n    \"0\", \"0.000000E+000\", \"0000 M ¤\", \"0000¤\", \"000G ¤\", \"000K ¤\", \"000M ¤\",\n    \"000T ¤\", \"000mM ¤\", \"000m ¤\", \"000 Bio'.' ¤\", \"000 Bln ¤\", \"000 Bn ¤\",\n    \"000 B ¤\", \"000 E ¤\", \"000 K ¤\", \"000 MRD ¤\", \"000 Md ¤\", \"000 Mio'.' ¤\",\n    \"000 Mio ¤\", \"000 Mld ¤\", \"000 Mln ¤\", \"000 Mn ¤\", \"000 Mrd'.' ¤\",\n    \"000 Mrd ¤\", \"000 Mr ¤\", \"000 M ¤\", \"000 NT ¤\", \"000 N ¤\", \"000 Tn ¤\",\n    \"000 Tr ¤\", ...]","ref":"SoftBank.Cldr.Number.Format.html#decimal_format_list/0-example"},{"type":"function","title":"SoftBank.Cldr.Number.Format.decimal_format_list_for/1","doc":"Returns the list of decimal formats for a configured locale.","ref":"SoftBank.Cldr.Number.Format.html#decimal_format_list_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.decimal_format_list_for/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.\n\nThis function exists to allow the decimal formatter to precompile all\nthe known formats at compile time. Its use is not otherwise recommended.","ref":"SoftBank.Cldr.Number.Format.html#decimal_format_list_for/1-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.Format.decimal_format_list_for/1","doc":"iex> SoftBank.Cldr.Number.Format.decimal_format_list_for(:en)\n    {:ok, [\"#,##0%\", \"#,##0.###\", \"#,##0.00\", \"#,##0.00;(#,##0.00)\",\"#E0\",\n     \"0 billion\", \"0 million\", \"0 thousand\",\n     \"0 trillion\", \"00 billion\", \"00 million\", \"00 thousand\", \"00 trillion\",\n     \"000 billion\", \"000 million\", \"000 thousand\", \"000 trillion\", \"000B\", \"000K\",\n     \"000M\", \"000T\", \"00B\", \"00K\", \"00M\", \"00T\", \"0B\", \"0K\", \"0M\", \"0T\",\n     \"¤#,##0.00\", \"¤#,##0.00;(¤#,##0.00)\", \"¤000B\", \"¤000K\", \"¤000M\",\n     \"¤000T\", \"¤00B\", \"¤00K\", \"¤00M\", \"¤00T\", \"¤0B\", \"¤0K\", \"¤0M\", \"¤0T\",\n     \"¤ #,##0.00\", \"¤ #,##0.00;(¤ #,##0.00)\", \"¤ 000B\", \"¤ 000K\", \"¤ 000M\",\n     \"¤ 000T\", \"¤ 00B\", \"¤ 00K\", \"¤ 00M\", \"¤ 00T\", \"¤ 0B\", \"¤ 0K\", \"¤ 0M\", \"¤ 0T\"]}","ref":"SoftBank.Cldr.Number.Format.html#decimal_format_list_for/1-example"},{"type":"function","title":"SoftBank.Cldr.Number.Format.default_grouping_for/1","doc":"Returns the default grouping for a locale as a map.","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.default_grouping_for/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.default_grouping_for/1","doc":"* `{:ok, grouping}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Format.default_grouping_for/1","doc":"iex> SoftBank.Cldr.Number.Format.default_grouping_for(:en)\n    {:ok, %{fraction: %{first: 0, rest: 0}, integer: %{first: 3, rest: 3}}}","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Format.default_grouping_for!/1","doc":"Returns the default grouping for a locale\nor raises on error.","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for!/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.default_grouping_for!/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for!/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.default_grouping_for!/1","doc":"* `grouping` as a map or\n\n* raises an exception","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for!/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Format.default_grouping_for!/1","doc":"iex> SoftBank.Cldr.Number.Format.default_grouping_for!(:en)\n    %{fraction: %{first: 0, rest: 0}, integer: %{first: 3, rest: 3}}","ref":"SoftBank.Cldr.Number.Format.html#default_grouping_for!/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Format.formats_for/2","doc":"Return the predfined formats for a given `locale` and `number_system`.","ref":"SoftBank.Cldr.Number.Format.html#formats_for/2"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.formats_for/2","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.\n\n* `number_system` is any valid number system or number system type returned\n  by `SoftBank.Cldr.Number.System.number_systems_for/1`.","ref":"SoftBank.Cldr.Number.Format.html#formats_for/2-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.Format.formats_for/2","doc":"SoftBank.Cldr.Number.Format.formats_for :fr, :native\n    #=> %Cldr.Number.Format{\n      accounting: \"#,##0.00 ¤;(#,##0.00 ¤)\",\n      currency: \"#,##0.00 ¤\",\n      percent: \"#,##0 %\",\n      scientific: \"#E0\",\n      standard: \"#,##0.###\"\n      currency_short: [{\"1000\", [one: \"0 k ¤\", other: \"0 k ¤\"]},\n       {\"10000\", [one: \"00 k ¤\", other: \"00 k ¤\"]},\n       {\"100000\", [one: \"000 k ¤\", other: \"000 k ¤\"]},\n       {\"1000000\", [one: \"0 M ¤\", other: \"0 M ¤\"]},\n       {\"10000000\", [one: \"00 M ¤\", other: \"00 M ¤\"]},\n       {\"100000000\", [one: \"000 M ¤\", other: \"000 M ¤\"]},\n       {\"1000000000\", [one: \"0 Md ¤\", other: \"0 Md ¤\"]},\n       {\"10000000000\", [one: \"00 Md ¤\", other: \"00 Md ¤\"]},\n       {\"100000000000\", [one: \"000 Md ¤\", other: \"000 Md ¤\"]},\n       {\"1000000000000\", [one: \"0 Bn ¤\", other: \"0 Bn ¤\"]},\n       {\"10000000000000\", [one: \"00 Bn ¤\", other: \"00 Bn ¤\"]},\n       {\"100000000000000\", [one: \"000 Bn ¤\", other: \"000 Bn ¤\"]}],\n       ...\n      }","ref":"SoftBank.Cldr.Number.Format.html#formats_for/2-example"},{"type":"function","title":"SoftBank.Cldr.Number.Format.formats_for!/2","doc":"","ref":"SoftBank.Cldr.Number.Format.html#formats_for!/2"},{"type":"function","title":"SoftBank.Cldr.Number.Format.minimum_grouping_digits_for/1","doc":"Returns the minimum grouping digits for a locale.","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for/1","doc":"* `{:ok, minumum_digits}` or\n\n* `{:error, {exception, message}}`","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for/1","doc":"iex> SoftBank.Cldr.Number.Format.minimum_grouping_digits_for(\"en\")\n    {:ok, 1}","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Format.minimum_grouping_digits_for!/1","doc":"Returns the minimum grouping digits for a locale\nor raises on error.","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for!/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for!/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for!/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for!/1","doc":"* `minumum_digits` or\n\n* raises an exception","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for!/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Format.minimum_grouping_digits_for!/1","doc":"iex> SoftBank.Cldr.Number.Format.minimum_grouping_digits_for!(\"en\")\n    1","ref":"SoftBank.Cldr.Number.Format.html#minimum_grouping_digits_for!/1-examples"},{"type":"module","title":"SoftBank.Cldr.Number.Formatter.Decimal","doc":"","ref":"SoftBank.Cldr.Number.Formatter.Decimal.html"},{"type":"function","title":"SoftBank.Cldr.Number.Formatter.Decimal.metadata!/1","doc":"","ref":"SoftBank.Cldr.Number.Formatter.Decimal.html#metadata!/1"},{"type":"function","title":"SoftBank.Cldr.Number.Formatter.Decimal.to_string/3","doc":"Formats a number according to a decimal format string.","ref":"SoftBank.Cldr.Number.Formatter.Decimal.html#to_string/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Formatter.Decimal.to_string/3","doc":"* `number` is an integer, float or Decimal\n\n* `format` is a format string.  See `SoftBank.Cldr.Number` for further information.\n\n* `options` is a map of options.  See `SoftBank.Cldr.Number.to_string/2`\n  for further information.","ref":"SoftBank.Cldr.Number.Formatter.Decimal.html#to_string/3-arguments"},{"type":"module","title":"SoftBank.Cldr.Number.Ordinal","doc":"Implements ordinal plural rules for numbers.","ref":"SoftBank.Cldr.Number.Ordinal.html"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.available_locale_names/0","doc":"The locale names for which plural rules are defined.","ref":"SoftBank.Cldr.Number.Ordinal.html#available_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.known_locale_names/0","doc":"The configured locales for which plural rules are defined.\n\nReturns the intersection of `SoftBank.Cldr.known_locale_names/0` and\nthe locales for which Ordinal plural rules are defined.\n\nThere are many `Cldr` locales which don't have their own plural\nrules so this list is the intersection of `Cldr`'s configured\nlocales and those that have rules.","ref":"SoftBank.Cldr.Number.Ordinal.html#known_locale_names/0"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.plural_rule/3","doc":"Return the plural key for a given number in a given locale\n\nReturns which plural key (`:zero`, `:one`, `:two`, `:few`,\n`:many` or `:other`) a given number fits into within the\ncontext of a given locale.\n\nNote that these key names should not be interpreted\nliterally.  For example, the key returned from\n`Cldr.Number.Ordinal.plural_rule(0, \"en\")` is actually\n`:other`, not `:zero`.\n\nThis key can then be used to format a number, date, time, unit,\nlist or other content in a plural-sensitive way.","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rule/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Ordinal.plural_rule/3","doc":"* `number` is any `integer`, `float` or `Decimal`\n\n* `locale` is any locale returned by `Cldr.Locale.new!/2` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\n* `rounding` is one of `[:down, :up, :ceiling, :floor, :half_even, :half_up, :half_down]`.  The\n  default is `:half_even`.","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rule/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Ordinal.plural_rule/3","doc":"iex> SoftBank.Cldr.Number.Ordinal.plural_rule 0, \"fr\"\n    :other\n\n    iex> SoftBank.Cldr.Number.Ordinal.plural_rule 1, \"en\"\n    :one","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rule/3-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.plural_rules/0","doc":"Returns all the plural rules defined in CLDR.","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rules/0"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.plural_rules_for/1","doc":"Return the plural rules for a locale.","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rules_for/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Ordinal.plural_rules_for/1","doc":"* `locale` is any locale returned by `SoftBank.Cldr.Locale.new!/1` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\nThe rules are returned in AST form after parsing.","ref":"SoftBank.Cldr.Number.Ordinal.html#plural_rules_for/1-arguments"},{"type":"function","title":"SoftBank.Cldr.Number.Ordinal.pluralize/3","doc":"Pluralize a number using ordinal plural rules\nand a substitution map.","ref":"SoftBank.Cldr.Number.Ordinal.html#pluralize/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Ordinal.pluralize/3","doc":"* `number` is an integer, float or Decimal or a `Range.t{}`.  When a range, The\n  is that in any usage, the start value is strictly less than the end value,\n  and that no values are negative. Results for any cases that do not meet\n  these criteria are undefined.\n\n* `locale` is any locale returned by `SoftBank.Cldr.Locale.new!/1` or any\n  `locale_name` returned by `SoftBank.Cldr.known_locale_names/0`\n\n* `substitutions` is a map that maps plural keys to a string.\n  The valid substitution keys are `:zero`, `:one`, `:two`,\n  `:few`, `:many` and `:other`.\n\nSee also `SoftBank.Cldr.Number.Ordinal.Ordinal.plural_rule/3`.","ref":"SoftBank.Cldr.Number.Ordinal.html#pluralize/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Ordinal.pluralize/3","doc":"iex> SoftBank.Cldr.Number.Ordinal.pluralize 1, :en, %{one: \"one\"}\n    \"one\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize 2, :en, %{one: \"one\"}\n    nil\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize 2, :en, %{one: \"one\", two: \"two\"}\n    \"two\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize 22, :en, %{one: \"one\", two: \"two\", other: \"other\"}\n    \"two\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize Decimal.new(1), :en, %{one: \"one\"}\n    \"one\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize Decimal.new(2), :en, %{one: \"one\"}\n    nil\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize Decimal.new(2), :en, %{one: \"one\", two: \"two\"}\n    \"two\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize 1..10, \"ar\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"\n\n    iex> SoftBank.Cldr.Number.Ordinal.pluralize 1..10, \"en\", %{one: \"one\", few: \"few\", other: \"other\"}\n    \"other\"","ref":"SoftBank.Cldr.Number.Ordinal.html#pluralize/3-examples"},{"type":"module","title":"SoftBank.Cldr.Number.PluralRule.Range","doc":"Implements plural rules for ranges","ref":"SoftBank.Cldr.Number.PluralRule.Range.html"},{"type":"function","title":"SoftBank.Cldr.Number.PluralRule.Range.plural_rule/3","doc":"Returns a final plural type for a start-of-range plural\ntype, an end-of-range plural type and a locale.","ref":"SoftBank.Cldr.Number.PluralRule.Range.html#plural_rule/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.PluralRule.Range.plural_rule/3","doc":"* `first` is a plural type for the start of a range\n\n* `last` is a plural type for the end of a range\n\n* `locale` is any `Cldr.LanguageTag.t` or a language name\n  (not locale name)","ref":"SoftBank.Cldr.Number.PluralRule.Range.html#plural_rule/3-arguments"},{"type":"function","title":"Example - SoftBank.Cldr.Number.PluralRule.Range.plural_rule/3","doc":"iex> SoftBank.Cldr.Number.PluralRule.Range.plural_rule :other, :few, \"ar\"\n    :few","ref":"SoftBank.Cldr.Number.PluralRule.Range.html#plural_rule/3-example"},{"type":"module","title":"SoftBank.Cldr.Number.Symbol","doc":"","ref":"SoftBank.Cldr.Number.Symbol.html"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.all_decimal_symbols/0","doc":"Returns a list of all decimal symbols defined\nby the locales configured in this backend as\na list.","ref":"SoftBank.Cldr.Number.Symbol.html#all_decimal_symbols/0"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.all_decimal_symbols_class/0","doc":"Returns a list of all decimal symbols defined\nby the locales configured in this backend as\na string.\n\nThis string can be used as a character class\nwhen builing a regular expression.","ref":"SoftBank.Cldr.Number.Symbol.html#all_decimal_symbols_class/0"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.all_grouping_symbols/0","doc":"Returns a list of all grouping symbols defined\nby the locales configured in this backend as\na list.","ref":"SoftBank.Cldr.Number.Symbol.html#all_grouping_symbols/0"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.all_grouping_symbols_class/0","doc":"Returns a list of all grouping symbols defined\nby the locales configured in this backend as\na string.\n\nThis string can be used as a character class\nwhen builing a regular expression.","ref":"SoftBank.Cldr.Number.Symbol.html#all_grouping_symbols_class/0"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.number_symbols_for/1","doc":"Returns a map of `Cldr.Number.Symbol.t` structs of the number symbols for each\nof the number systems of a locale.","ref":"SoftBank.Cldr.Number.Symbol.html#number_symbols_for/1"},{"type":"function","title":"Options - SoftBank.Cldr.Number.Symbol.number_symbols_for/1","doc":"* `locale` is any valid locale name returned by\n  `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by\n  `SoftBank.Cldr.Locale.new!/1`. The default\n  is `SoftBank.Cldr.get_locale/0`.","ref":"SoftBank.Cldr.Number.Symbol.html#number_symbols_for/1-options"},{"type":"function","title":"Example: - SoftBank.Cldr.Number.Symbol.number_symbols_for/1","doc":"iex> SoftBank.Cldr.Number.Symbol.number_symbols_for(:th)\n    {:ok, %{\n       latn: %Cldr.Number.Symbol{\n         decimal: \".\",\n         exponential: \"E\",\n         group: \",\",\n         infinity: \"∞\",\n         list: \";\",\n         minus_sign: \"-\",\n         nan: \"NaN\",\n         per_mille: \"‰\",\n         percent_sign: \"%\",\n         plus_sign: \"+\",\n         superscripting_exponent: \"×\",\n         time_separator: \":\"\n       },\n       thai: %Cldr.Number.Symbol{\n         decimal: \".\",\n         exponential: \"E\",\n         group: \",\",\n         infinity: \"∞\",\n         list: \";\",\n         minus_sign: \"-\",\n         nan: \"NaN\",\n         per_mille: \"‰\",\n         percent_sign: \"%\",\n         plus_sign: \"+\",\n         superscripting_exponent: \"×\",\n         time_separator: \":\"\n       }\n     }}","ref":"SoftBank.Cldr.Number.Symbol.html#number_symbols_for/1-example"},{"type":"function","title":"SoftBank.Cldr.Number.Symbol.number_symbols_for/2","doc":"","ref":"SoftBank.Cldr.Number.Symbol.html#number_symbols_for/2"},{"type":"module","title":"SoftBank.Cldr.Number.System","doc":"","ref":"SoftBank.Cldr.Number.System.html"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_system_for/2","doc":"Returns the actual number system from a number system type.\n\n* `locale` is any valid locale name returned by `Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by ``Cldr.Locale.new!/2``\n\n* `system_name` is any number system name returned by\n  `Cldr.known_number_systems/0` or a number system type\n  returned by `Cldr.known_number_system_types/0`\n\nThis function will decode a number system type into the actual\nnumber system.  If the number system provided can't be decoded\nit is returned as is.","ref":"SoftBank.Cldr.Number.System.html#number_system_for/2"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.number_system_for/2","doc":"iex> SoftBank.Cldr.Number.System.number_system_for \"th\", :latn\n    {:ok, %{digits: \"0123456789\", type: :numeric}}\n\n    iex> SoftBank.Cldr.Number.System.number_system_for \"en\", :default\n    {:ok, %{digits: \"0123456789\", type: :numeric}}\n\n    iex> SoftBank.Cldr.Number.System.number_system_for \"he\", :traditional\n    {:ok, %{rules: \"hebrew\", type: :algorithmic}}\n\n    iex> SoftBank.Cldr.Number.System.number_system_for \"en\", :native\n    {:ok, %{digits: \"0123456789\", type: :numeric}}\n\n    iex> SoftBank.Cldr.Number.System.number_system_for \"en\", :finance\n    {\n      :error,\n      {Cldr.UnknownNumberSystemError,\n        \"The number system :finance is unknown for the locale named :en. Valid number systems are %{default: :latn, native: :latn}\"}\n    }","ref":"SoftBank.Cldr.Number.System.html#number_system_for/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_system_from_locale/1","doc":"Returns the number system from a language tag or\nlocale name.","ref":"SoftBank.Cldr.Number.System.html#number_system_from_locale/1"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.System.number_system_from_locale/1","doc":"* `locale` is any language tag returned be `Cldr.Locale.new/2`\n  or a locale name in the list returned by `Cldr.known_locale_names/1`","ref":"SoftBank.Cldr.Number.System.html#number_system_from_locale/1-arguments"},{"type":"function","title":"Returns - SoftBank.Cldr.Number.System.number_system_from_locale/1","doc":"* A number system name as an atom","ref":"SoftBank.Cldr.Number.System.html#number_system_from_locale/1-returns"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.number_system_from_locale/1","doc":"iex> SoftBank.Cldr.Number.System.number_system_from_locale \"en-US-u-nu-thai\"\n    :thai\n\n    iex> SoftBank.Cldr.Number.System.number_system_from_locale \"en-US\"\n    :latn","ref":"SoftBank.Cldr.Number.System.html#number_system_from_locale/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_system_names_for/1","doc":"Returns the number systems available for a locale\nor `{:error, message}` if the locale is not known.\n\n* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `SoftBank.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.Number.System.html#number_system_names_for/1"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.number_system_names_for/1","doc":"iex> SoftBank.Cldr.Number.System.number_system_names_for \"en\"\n    {:ok, [:latn]}\n\n    iex> SoftBank.Cldr.Number.System.number_system_names_for \"zz\"\n    {:error, {Cldr.InvalidLanguageError, \"The language \\\"zz\\\" is invalid\"}}","ref":"SoftBank.Cldr.Number.System.html#number_system_names_for/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_system_names_for!/1","doc":"","ref":"SoftBank.Cldr.Number.System.html#number_system_names_for!/1"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_system_types_for/1","doc":"","ref":"SoftBank.Cldr.Number.System.html#number_system_types_for/1"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_systems_for/1","doc":"Returns the number systems available for a locale\nor `{:error, message}` if the locale is not known.\n\n* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `SoftBank.Cldr.Locale.new!/1`","ref":"SoftBank.Cldr.Number.System.html#number_systems_for/1"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.number_systems_for/1","doc":"iex> SoftBank.Cldr.Number.System.number_systems_for \"en\"\n    {:ok, %{default: :latn, native: :latn}}\n\n    iex> SoftBank.Cldr.Number.System.number_systems_for \"th\"\n    {:ok, %{default: :latn, native: :thai}}\n\n    iex> SoftBank.Cldr.Number.System.number_systems_for \"zz\"\n    {:error, {Cldr.InvalidLanguageError, \"The language \\\"zz\\\" is invalid\"}}","ref":"SoftBank.Cldr.Number.System.html#number_systems_for/1-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_systems_for!/1","doc":"","ref":"SoftBank.Cldr.Number.System.html#number_systems_for!/1"},{"type":"function","title":"SoftBank.Cldr.Number.System.number_systems_like/2","doc":"","ref":"SoftBank.Cldr.Number.System.html#number_systems_like/2"},{"type":"function","title":"SoftBank.Cldr.Number.System.system_name_from/2","doc":"Returns a number system name for a given locale and number system reference.\n\n* `system_name` is any number system name returned by\n  `SoftBank.Cldr.known_number_systems/0` or a number system type\n  returned by `SoftBank.Cldr.known_number_system_types/0`\n\n* `locale` is any valid locale name returned by `SoftBank.Cldr.known_locale_names/0`\n  or a `Cldr.LanguageTag` struct returned by `SoftBank.Cldr.Locale.new!/1`\n\nNumber systems can be references in one of two ways:\n\n* As a number system type such as :default, :native, :traditional and\n  :finance. This allows references to a number system for a locale in a\n  consistent fashion for a given use\n\n* WIth the number system name directly, such as :latn, :arab or any of the\n  other 70 or so\n\nThis function dereferences the supplied `system_name` and returns the\nactual system name.","ref":"SoftBank.Cldr.Number.System.html#system_name_from/2"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.system_name_from/2","doc":"ex> SoftBank.Cldr.Number.System.system_name_from(:default, \"en\")\n    {:ok, :latn}\n\n    iex> SoftBank.Cldr.Number.System.system_name_from(\"latn\", \"en\")\n    {:ok, :latn}\n\n    iex> SoftBank.Cldr.Number.System.system_name_from(:native, \"en\")\n    {:ok, :latn}\n\n    iex> SoftBank.Cldr.Number.System.system_name_from(:nope, \"en\")\n    {\n      :error,\n      {Cldr.UnknownNumberSystemError, \"The number system :nope is unknown\"}\n    }\n\nNote that return value is not guaranteed to be a valid\nnumber system for the given locale as demonstrated in the third example.","ref":"SoftBank.Cldr.Number.System.html#system_name_from/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.to_system/2","doc":"Converts a number into the representation of\na non-latin number system.\n\nThis function converts numbers to a known\nnumber system only, it does not provide number\nformatting.\n\n* `number` is a `float`, `integer` or `Decimal`\n\n* `system_name` is any number system name returned by\n  `Cldr.known_number_systems/0` or a number system type\n  returned by `Cldr.known_number_system_types/0`\n\nThere are two types of number systems in CLDR:\n\n* `:numeric` in which the number system defines\n  a direct mapping between the latin digits `0..9`\n  into a the number system equivalent.  In this case,\n` to_system/2` invokes `Cldr.Number.Transliterate.transliterate_digits/3`\n  for the given number.\n\n* `:algorithmic` in which the number system\n  does not have the same structure as the `:latn`\n  number system and therefore the conversion is\n  done algorithmically.  For CLDR the algorithm\n  is implemented through `Cldr.Rbnf` rulesets.\n  These rulesets are considered by CLDR to be\n  less rigorous than the `:numeric` number systems\n  and caution and testing for a specific use case\n  is recommended.","ref":"SoftBank.Cldr.Number.System.html#to_system/2"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.to_system/2","doc":"iex> SoftBank.Cldr.Number.System.to_system 123456, :hebr\n    {:ok, \"קכ״ג׳תנ״ו\"}\n\n    iex> SoftBank.Cldr.Number.System.to_system 123, :hans\n    {:ok, \"一百二十三\"}\n\n    iex> SoftBank.Cldr.Number.System.to_system 123, :hant\n    {:ok, \"一百二十三\"}\n\n    iex> SoftBank.Cldr.Number.System.to_system 123, :hansfin\n    {:ok, \"壹佰贰拾叁\"}","ref":"SoftBank.Cldr.Number.System.html#to_system/2-examples"},{"type":"function","title":"SoftBank.Cldr.Number.System.to_system!/2","doc":"Converts a number into the representation of\na non-latin number system. Returns a converted\nstring or raises on error.\n\n* `number` is a `float`, `integer` or `Decimal`\n\n* `system_name` is any number system name returned by\n  `SoftBank.Cldr.known_number_systems/0` or a number system type\n  returned by `SoftBank.Cldr.known_number_system_types/0`\n\nSee `SoftBank.Cldr.Number.System.to_system/2` for further\ninformation.","ref":"SoftBank.Cldr.Number.System.html#to_system!/2"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.System.to_system!/2","doc":"iex> SoftBank.Cldr.Number.System.to_system! 123, :hans\n    \"一百二十三\"\n\n    iex> SoftBank.Cldr.Number.System.to_system! 123, :hant\n    \"一百二十三\"\n\n    iex> SoftBank.Cldr.Number.System.to_system! 123, :hansfin\n    \"壹佰贰拾叁\"","ref":"SoftBank.Cldr.Number.System.html#to_system!/2-examples"},{"type":"module","title":"SoftBank.Cldr.Number.Transliterate","doc":"Transliteration for digits and separators.\n\nTransliterating a string is an expensive business.  First the string has to\nbe exploded into its component graphemes.  Then for each grapheme we have\nto map to the equivalent in the other `{locale, number_system}`.  Then we\nhave to reassemble the string.\n\nEffort is made to short circuit where possible. Transliteration is not\nrequired for any `{locale, number_system}` that is the same as `{\"en\",\n\"latn\"}` since the implementation uses this combination for the placeholders during\nformatting already. When short circuiting is possible (typically the en-*\nlocales with \"latn\" number_system - the total number of short circuited\nlocales is 211 of the 537 in CLDR) the overall number formatting is twice as\nfast than when formal transliteration is required.\n\n#","ref":"SoftBank.Cldr.Number.Transliterate.html"},{"type":"module","title":"Configuring precompilation of digit transliterations - SoftBank.Cldr.Number.Transliterate","doc":"This module includes `Cldr.Number.Transliterate.transliterate_digits/3` which transliterates\ndigits between number systems.  For example from :arabic to :latn.  Since generating a\ntransliteration map is slow, pairs of transliterations can be configured so that the\ntransliteration map is created at compile time and therefore speeding up transliteration at\nrun time.\n\nTo configure these transliteration pairs, add the to the `use Cldr` configuration\nin a backend module:\n\n    defmodule MyApp.Cldr do\n      use Cldr,\n      locale: [\"en\", \"fr\", \"th\"],\n      default_locale: \"en\",\n      precompile_transliterations: [{:latn, :thai}, {:arab, :thai}]\n    end\n\nWhere each tuple in the list configures one transliteration map.  In this example, two maps are\nconfigured: from `:latn` to `:thai` and from `:arab` to `:thai`.\n\nA list of configurable number systems is returned by `Cldr.Number.System.systems_with_digits/0`.\n\nIf a transliteration is requested between two number pairs that have not been configured for\nprecompilation, a warning is logged.","ref":"SoftBank.Cldr.Number.Transliterate.html#module-configuring-precompilation-of-digit-transliterations"},{"type":"function","title":"SoftBank.Cldr.Number.Transliterate.transliterate/3","doc":"Transliterates from latin digits to another number system's digits.\n\nTransliterates the latin digits 0..9 to their equivalents in\nanother number system. Also transliterates the decimal and grouping\nseparators as well as the plus, minus and exponent symbols. Any other character\nin the string will be returned \"as is\".","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate/3"},{"type":"function","title":"Arguments - SoftBank.Cldr.Number.Transliterate.transliterate/3","doc":"* `sequence` is the string to be transliterated.\n\n* `locale` is any known locale, defaulting to `SoftBank.Cldr.get_locale/0`.\n\n* `number_system` is any known number system. If expressed as a `string` it\n  is the actual name of a known number system. If epressed as an `atom` it is\n  used as a key to look up a number system for the locale (the usual keys are\n  `:default` and `:native` but :traditional and :finance are also part of the\n  standard). See `SoftBank.Cldr.Number.System.number_systems_for/1` for a locale to\n  see what number system types are defined. The default is `:default`.\n\nFor available number systems see `Cldr.Number.System.number_systems/0`\nand `SoftBank.Cldr.Number.System.number_systems_for/1`.  Also see\n`SoftBank.Cldr.Number.Symbol.number_symbols_for/1`.","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate/3-arguments"},{"type":"function","title":"Examples - SoftBank.Cldr.Number.Transliterate.transliterate/3","doc":"iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"123556\")\n    \"123556\"\n\n    iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"123,556.000\", \"fr\", :default)\n    \"123 556,000\"\n\n    iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"123556\", \"th\", :default)\n    \"123556\"\n\n    iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"123556\", \"th\", \"thai\")\n    \"๑๒๓๕๕๖\"\n\n    iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"123556\", \"th\", :native)\n    \"๑๒๓๕๕๖\"\n\n    iex> SoftBank.Cldr.Number.Transliterate.transliterate(\"Some number is: 123556\", \"th\", \"thai\")\n    \"Some number is: ๑๒๓๕๕๖\"","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate/3-examples"},{"type":"function","title":"SoftBank.Cldr.Number.Transliterate.transliterate!/3","doc":"","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate!/3"},{"type":"function","title":"SoftBank.Cldr.Number.Transliterate.transliterate_digits/3","doc":"Transliterates digits from one number system to another number system\n\n* `digits` is binary representation of a number\n\n* `from_system` and `to_system` are number system names in atom form.  See\n`Cldr.Number.System.systems_with_digits/0` for available number systems.","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate_digits/3"},{"type":"function","title":"Example - SoftBank.Cldr.Number.Transliterate.transliterate_digits/3","doc":"iex> SoftBank.Cldr.Number.Transliterate.transliterate_digits \"٠١٢٣٤٥٦٧٨٩\", :arab, :latn\n    \"0123456789\"","ref":"SoftBank.Cldr.Number.Transliterate.html#transliterate_digits/3-example"},{"type":"module","title":"SoftBank.Cldr.Rbnf.NumberSystem","doc":"Functions to implement the number system rule-based-number-format rules of CLDR.\n\nThese rules are defined only on the \"und\" locale and represent specialised\nnumber formatting.\n\nThe standard public API for RBNF is via the `Cldr.Number.to_string/2` function.\n\nThe functions on this module are defined at compile time based upon the RBNF rules\ndefined in the Unicode CLDR data repository.  Available rules are identified by:\n\n    iex> SoftBank.Cldr.Rbnf.NumberSystem.rule_sets(:und)\n    ...> |> Enum.sort()\n    [\n      :armenian_lower,\n      :armenian_upper,\n      :cyrillic_lower,\n      :ethiopic,\n      :georgian,\n      :greek_lower,\n      :greek_upper,\n      :hebrew,\n      :hebrew_item,\n      :roman_lower,\n      :roman_upper,\n      :tamil,\n      :zz_default\n    ]\n\nA rule can then be invoked on an available rule_set.  For example\n\n    iex> SoftBank.Cldr.Rbnf.NumberSystem.roman_upper(123, :und)\n    \"CXXIII\"\n\nThis particular call is equivalent to the call through the public API of:\n\n    iex> SoftBank.Cldr.Number.to_string(123, format: :roman)\n    {:ok, \"CXXIII\"}","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.all_rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#all_rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.armenian_lower/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#armenian_lower/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.armenian_lower/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#armenian_lower/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.armenian_upper/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#armenian_upper/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.armenian_upper/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#armenian_upper/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower_1_10/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower_1_10/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower_final/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower_final/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower_post/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower_post/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.cyrillic_lower_thousands/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#cyrillic_lower_thousands/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic_p1/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic_p1/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic_p2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic_p2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic_p3/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic_p3/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.ethiopic_p/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#ethiopic_p/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.georgian/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#georgian/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.georgian/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#georgian/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_lower/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_lower/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_lower/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_lower/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_numeral_majuscules/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_numeral_majuscules/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_numeral_minuscules/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_numeral_minuscules/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_upper/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_upper/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.greek_upper/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#greek_upper/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew_0_99/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew_0_99/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew_item/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew_item/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew_item/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew_item/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew_item_hundreds/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew_item_hundreds/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.hebrew_thousands/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#hebrew_thousands/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.roman_lower/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#roman_lower/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.roman_lower/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#roman_lower/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.roman_upper/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#roman_upper/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.roman_upper/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#roman_upper/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.rule_sets/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#rule_sets/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.tamil/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#tamil/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.tamil/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#tamil/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.tamil_thousands/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#tamil_thousands/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.zz_default/1","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#zz_default/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.NumberSystem.zz_default/2","doc":"","ref":"SoftBank.Cldr.Rbnf.NumberSystem.html#zz_default/2"},{"type":"module","title":"SoftBank.Cldr.Rbnf.Ordinal","doc":"Functions to implement the ordinal rule-based-number-format rules of CLDR.\n\nAs CLDR notes, the data is incomplete or non-existent for many languages.  It\nis considered complete for English however.\n\nThe standard public API for RBNF is via the `Cldr.Number.to_string/2` function.\n\nThe functions on this module are defined at compile time based upon the RBNF rules\ndefined in the Unicode CLDR data repository.  Available rules are identified by:\n\n    iex> SoftBank.Cldr.Rbnf.Ordinal.rule_sets(:en)\n    [:digits_ordinal]\n\n    iex> SoftBank.Cldr.Rbnf.Ordinal.rule_sets(\"fr\")\n    ...> |> Enum.sort()\n    [\n      :digits_ordinal,\n      :digits_ordinal_feminine,\n      :digits_ordinal_feminine_plural,\n      :digits_ordinal_masculine,\n      :digits_ordinal_masculine_plural\n    ]\n\nA rule can then be invoked on an available rule_set.  For example\n\n    iex> SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal(123, :en)\n    \"123rd\"\n\nThis call is equivalent to the call through the public API of:\n\n    iex> SoftBank.Cldr.Number.to_string(123, format: :ordinal)\n    {:ok, \"123rd\"}","ref":"SoftBank.Cldr.Rbnf.Ordinal.html"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.all_rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#all_rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#digits_ordinal/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal_feminine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#digits_ordinal_feminine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal_feminine_plural/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#digits_ordinal_feminine_plural/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal_masculine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#digits_ordinal_masculine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.digits_ordinal_masculine_plural/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#digits_ordinal_masculine_plural/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Ordinal.rule_sets/1","doc":"","ref":"SoftBank.Cldr.Rbnf.Ordinal.html#rule_sets/1"},{"type":"module","title":"SoftBank.Cldr.Rbnf.Spellout","doc":"Functions to implement the spellout rule-based-number-format rules of CLDR.\n\nAs CLDR notes, the data is incomplete or non-existent for many languages.  It\nis considered complete for English however.\n\nThe standard public API for RBNF is via the `Cldr.Number.to_string/2` function.\n\nThe functions on this module are defined at compile time based upon the RBNF rules\ndefined in the Unicode CLDR data repository.  Available rules are identified by:\n\n    iex> SoftBank.Cldr.Rbnf.Spellout.rule_sets(\"en\")\n    ...> |> Enum.sort()\n    [\n      :spellout_cardinal,\n      :spellout_cardinal_verbose,\n      :spellout_numbering,\n      :spellout_numbering_verbose,\n      :spellout_numbering_year,\n      :spellout_ordinal,\n      :spellout_ordinal_verbose\n    ]\n\nA rule can then be invoked on an available rule_set. For example:\n\n    iex> SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal(123, \"en\")\n    \"one hundred twenty-third\"\n\nThis call is equivalent to the call through the public API of:\n\n    iex> SoftBank.Cldr.Number.to_string(123, format: :spellout)\n    {:ok, \"one hundred twenty-three\"}","ref":"SoftBank.Cldr.Rbnf.Spellout.html"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.all_rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#all_rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.and/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#and/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.and_o/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#and_o/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal3/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal3/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal4/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal4/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal5/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal5/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal8/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal8/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal13/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal13/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_3/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_3/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_4/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_4/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_5/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_5/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_8/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_8/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cardinal_alternate2_13/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cardinal_alternate2_13/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cents_f/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cents_f/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cents_m/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cents_m/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.cents_o/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#cents_o/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.commas/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#commas/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.commas_o/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#commas_o/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.et_un/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#et_un/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.et_une/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#et_une/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.et_unieme/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#et_unieme/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber3/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber3/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber4/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber4/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber5/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber5/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber8/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber8/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.financialnumber13/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#financialnumber13/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.lenient_parse/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#lenient_parse/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.mille_o/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#mille_o/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number3/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number3/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number4/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number4/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number5/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number5/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number8/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number8/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.number13/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#number13/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.numbering_days/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#numbering_days/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.r2d_year/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#r2d_year/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.rule_sets/0","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#rule_sets/0"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.rule_sets/1","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#rule_sets/1"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal_alternate2/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal_alternate2/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal_feminine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal_feminine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal_financial/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal_financial/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal_masculine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal_masculine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_cardinal_verbose/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_cardinal_verbose/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_leading/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_leading/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_numbering/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_numbering/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_numbering_days/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_numbering_days/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_numbering_verbose/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_numbering_verbose/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_numbering_year/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_numbering_year/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_numbering_year_digits/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_numbering_year_digits/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal_feminine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal_feminine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal_feminine_plural/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal_feminine_plural/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal_masculine/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal_masculine/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal_masculine_plural/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal_masculine_plural/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.spellout_ordinal_verbose/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#spellout_ordinal_verbose/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.subcents_f/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#subcents_f/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.subcents_m/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#subcents_m/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.subcents_o/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#subcents_o/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.th/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#th/2"},{"type":"function","title":"SoftBank.Cldr.Rbnf.Spellout.tieth/2","doc":"","ref":"SoftBank.Cldr.Rbnf.Spellout.html#tieth/2"},{"type":"module","title":"SoftBank.Config","doc":"","ref":"SoftBank.Config.html"},{"type":"function","title":"SoftBank.Config.config/0","doc":"","ref":"SoftBank.Config.html#config/0"},{"type":"function","title":"SoftBank.Config.get/2","doc":"Return value by key from config.exs file.","ref":"SoftBank.Config.html#get/2"},{"type":"function","title":"SoftBank.Config.key_type/0","doc":"","ref":"SoftBank.Config.html#key_type/0"},{"type":"function","title":"SoftBank.Config.key_type/1","doc":"","ref":"SoftBank.Config.html#key_type/1"},{"type":"function","title":"SoftBank.Config.repo/0","doc":"","ref":"SoftBank.Config.html#repo/0"},{"type":"function","title":"SoftBank.Config.repos/0","doc":"","ref":"SoftBank.Config.html#repos/0"},{"type":"module","title":"SoftBank.Currencies","doc":"","ref":"SoftBank.Currencies.html"},{"type":"function","title":"SoftBank.Currencies.init/2","doc":"","ref":"SoftBank.Currencies.html#init/2"},{"type":"function","title":"SoftBank.Currencies.new/1","doc":"","ref":"SoftBank.Currencies.html#new/1"},{"type":"function","title":"SoftBank.Currencies.reload/0","doc":"","ref":"SoftBank.Currencies.html#reload/0"},{"type":"module","title":"SoftBank.Entry","doc":"Entries are the recording of account debits and credits and can be considered\nas consituting a traditional accounting Journal.","ref":"SoftBank.Entry.html"},{"type":"function","title":"SoftBank.Entry.balanced?/3","doc":"Accepts an `SoftBank.Entry` and `Ecto.Repo` and returns true/false based on whether\nthe associated amounts for that entry sum to zero.","ref":"SoftBank.Entry.html#balanced?/3"},{"type":"function","title":"SoftBank.Entry.changeset/3","doc":"Creates a changeset for `SoftBank.Entry`, validating a required `:description` and `:date`,\ncasting an provided \"debit\" and \"credit\" `SoftBank.Amount`s, and validating that\nthose amounts balance.","ref":"SoftBank.Entry.html#changeset/3"},{"type":"function","title":"SoftBank.Entry.validate_debits_and_credits_balance/2","doc":"Accepts and returns a changeset, appending an error if \"credit\" and \"debit\" amounts\nare not equivalent","ref":"SoftBank.Entry.html#validate_debits_and_credits_balance/2"},{"type":"type","title":"SoftBank.Entry.t/0","doc":"","ref":"SoftBank.Entry.html#t:t/0"},{"type":"module","title":"SoftBank.ExchangeRates.CoinMarketCap","doc":"Implements the `Money.ExchangeRates` for CoinMarketCap\nRates service.","ref":"SoftBank.ExchangeRates.CoinMarketCap.html"},{"type":"module","title":"Required configuration: - SoftBank.ExchangeRates.CoinMarketCap","doc":"The configuration key `:coin_market_cap_key` should be\nset to your `app_id`.  for example:\n\n    config :soft_bank,\n      coin_market_cap_key: \"your_key\"\n\nor configure it via environment variable:\n\n    config :soft_bank,\n      coin_market_cap_key: {:system, \"coin_market_cap_key\"}\n\nIt is also possible to configure an alternative base url for this\nservice in case it changes in the future. For example:\n\n    config :soft_bank,\n      coin_market_cap_key: \"your_key\"\n      coin_market_cap_url: \"https://pro-api.coinmarketcap.com\"","ref":"SoftBank.ExchangeRates.CoinMarketCap.html#module-required-configuration"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.decode_rates/1","doc":"","ref":"SoftBank.ExchangeRates.CoinMarketCap.html#decode_rates/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.get_historic_rates/2","doc":"Retrieves the historic exchange rates from CoinMarketCap.\n\n* `date` is a date returned by `Date.new/3` or any struct with the\n  elements `:year`, `:month` and `:day`.\n\n* `config` is the retrieval configuration. When invoked from the\n  exchange rates services this will be the config returned from\n  `Money.ExchangeRates.config/0`\n\nReturns:\n\n* `{:ok, rates}` if the rates can be retrieved\n\n* `{:error, reason}` if rates cannot be retrieved\n\nTypically this function is called by the exchange rates retrieval\nservice although it can be called outside that context as\nrequired.","ref":"SoftBank.ExchangeRates.CoinMarketCap.html#get_historic_rates/2"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.get_latest_rates/1","doc":"Retrieves the latest exchange rates from CoinMarketCap site.\n\n* `config` is the retrieval configuration. When invoked from the\nexchange rates services this will be the config returned from\n`Money.ExchangeRates.config/0`\n\nReturns:\n\n* `{:ok, rates}` if the rates can be retrieved\n\n* `{:error, reason}` if rates cannot be retrieved\n\nTypically this function is called by the exchange rates retrieval\nservice although it can be called outside that context as\nrequired.","ref":"SoftBank.ExchangeRates.CoinMarketCap.html#get_latest_rates/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.init/1","doc":"Update the retriever configuration to include the requirements\nfor  CoinMarketCap Rates.  This function is invoked when the\nexchange rate service starts up, just after the ets table\n:exchange_rates is created.\n\n* `default_config` is the configuration returned by `Money.ExchangeRates.default_config/0`\n\nReturns the configuration either unchanged or updated with\nadditional configuration specific to this exchange\nrates retrieval module.","ref":"SoftBank.ExchangeRates.CoinMarketCap.html#init/1"},{"type":"behaviour","title":"SoftBank.ExchangeRates.CoinMarketCap.Callback","doc":"Default exchange rates retrieval callback module.\n\nWhen exchange rates are successfully retrieved, the function\n`latest_rates_retrieved/2` or `historic_rates_retrieved/2` is\ncalled to perform any desired serialization or proocessing.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Callback.html"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Callback.historic_rates_retrieved/2","doc":"Callback function invoked when historic exchange rates are retrieved.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Callback.html#historic_rates_retrieved/2"},{"type":"callback","title":"SoftBank.ExchangeRates.CoinMarketCap.Callback.historic_rates_retrieved/2","doc":"Defines the behaviour to retrieve historic exchange rates from an external\ndata source.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Callback.html#c:historic_rates_retrieved/2"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Callback.latest_rates_retrieved/2","doc":"Callback function invoked when the latest exchange rates are retrieved.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Callback.html#latest_rates_retrieved/2"},{"type":"callback","title":"SoftBank.ExchangeRates.CoinMarketCap.Callback.latest_rates_retrieved/2","doc":"Defines the behaviour to retrieve the latest exchange rates from an external\ndata source.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Callback.html#c:latest_rates_retrieved/2"},{"type":"module","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever","doc":"Implements a `GenServer` to retrieve exchange rates from\na configured retrieveal module on a periodic or on demand basis.\n\nBy default exchange rates are retrieved from [COIN MARKET CAP](http://https://coinmarketcap.com).\n\nThe default period of execution is 5 minutes (300_000 milliseconds). The\nperiod of retrieval is configured in `config.exs` or the appropriate\nenvironment configuration.  For example:\n\n    config :ex_money,\n      retrieve_every: 300_000","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.certificate_store/0","doc":"","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#certificate_store/0"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#child_spec/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.config/0","doc":"Return the current configuration of the Exchange Rates\nRetrieval service","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#config/0"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.delete/0","doc":"Delete the exchange rates retrieval service\n\nThe service can be started again with `start/1`","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#delete/0"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.historic_rates/1","doc":"Forces retrieval of historic exchange rates for a single date\n\n* `date` is a date returned by `Date.new/3` or any struct with the\n  elements `:year`, `:month` and `:day` or\n\n* a `Date.Range.t` created by `Date.range/2` that specifies a\n  range of dates to retrieve\n\nReturns:\n\n* `{:ok, rates}` if exchange rates request is successfully sent.\n\n* `{:error, reason}` if the request cannot be send.\n\nSends a message ot the exchange rate retrieval worker to request\nhistoric rates for a specified date or range be retrieved and\nstored.\n\nThis function does not return exchange rates, for that see\n`Money.ExchangeRates.latest_rates/0` or\n`Money.ExchangeRates.historic_rates/1`.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#historic_rates/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.historic_rates/2","doc":"Forces retrieval of historic exchange rates for a range of dates\n\n* `from` is a date returned by `Date.new/3` or any struct with the\n  elements `:year`, `:month` and `:day`.\n\n* `to` is a date returned by `Date.new/3` or any struct with the\n  elements `:year`, `:month` and `:day`.\n\nReturns:\n\n* `{:ok, rates}` if exchange rates request is successfully sent.\n\n* `{:error, reason}` if the request cannot be send.\n\nSends a message to the exchange rate retrieval process for each\ndate in the range `from`..`to` to request historic rates be\nretrieved.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#historic_rates/2"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.latest_rates/0","doc":"Forces retrieval of the latest exchange rates\n\nSends a message ot the exchange rate retrieval worker to request\ncurrent rates be retrieved and stored.\n\nReturns:\n\n* `{:ok, rates}` if exchange rates request is successfully sent.\n\n* `{:error, reason}` if the request cannot be send.\n\nThis function does not return exchange rates, for that see\n`Money.ExchangeRates.latest_rates/0` or\n`Money.ExchangeRates.historic_rates/1`.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#latest_rates/0"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.reconfigure/1","doc":"Updated the configuration for the Exchange Rate\nService","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#reconfigure/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.restart/0","doc":"Restart the exchange rates retrieval service","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#restart/0"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.retrieve_rates/2","doc":"Retrieve exchange rates from an external HTTP\nservice.\n\nThis function is primarily intended for use by\nan exchange rates api module.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#retrieve_rates/2"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.start/1","doc":"Starts the exchange rates retrieval service","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#start/1"},{"type":"function","title":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.stop/0","doc":"Stop the exchange rates retrieval service.\n\nThe service can be restarted with `restart/0`.","ref":"SoftBank.ExchangeRates.CoinMarketCap.Retriever.html#stop/0"},{"type":"module","title":"SoftBank.ExchangeRates.Supervisor","doc":"","ref":"SoftBank.ExchangeRates.Supervisor.html"},{"type":"function","title":"SoftBank.ExchangeRates.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"SoftBank.ExchangeRates.Supervisor.html#child_spec/1"},{"type":"function","title":"SoftBank.ExchangeRates.Supervisor.init/1","doc":"","ref":"SoftBank.ExchangeRates.Supervisor.html#init/1"},{"type":"module","title":"SoftBank.Note","doc":"Defines a `SoftBank.Note` struct along with convenience methods for working with currencies.","ref":"SoftBank.Note.html"},{"type":"function","title":"SoftBank.Note.new/2","doc":"Create a new `SoftBank.Note` struct using a default currency.\nThe default currency can be set in the system Mix config.","ref":"SoftBank.Note.html#new/2"},{"type":"function","title":"Example Config: - SoftBank.Note.new/2","doc":"config :note,\n      default_currency: :USD","ref":"SoftBank.Note.html#new/2-example-config"},{"type":"function","title":"Example: - SoftBank.Note.new/2","doc":"SoftBank.Note.new(123)\n    %SoftBank.Note{amount: 123, currency: :USD}","ref":"SoftBank.Note.html#new/2-example"},{"type":"module","title":"SoftBank.Note.Sigils","doc":"","ref":"SoftBank.Note.Sigils.html"},{"type":"macro","title":"SoftBank.Note.Sigils.sigil_N/2","doc":"","ref":"SoftBank.Note.Sigils.html#sigil_N/2"},{"type":"module","title":"SoftBank.Owner","doc":"","ref":"SoftBank.Owner.html"},{"type":"function","title":"SoftBank.Owner.changeset/2","doc":"Builds a changeset based on the `struct` and `params`.","ref":"SoftBank.Owner.html#changeset/2"},{"type":"function","title":"SoftBank.Owner.fetch/2","doc":"Fetch the Account from the Repo.","ref":"SoftBank.Owner.html#fetch/2"},{"type":"function","title":"SoftBank.Owner.new/1","doc":"Create new account with default ledgers","ref":"SoftBank.Owner.html#new/1"},{"type":"type","title":"SoftBank.Owner.t/0","doc":"An Owner type.","ref":"SoftBank.Owner.html#t:t/0"},{"type":"module","title":"SoftBank.Repo","doc":"","ref":"SoftBank.Repo.html"},{"type":"function","title":"SoftBank.Repo.aggregate/3","doc":"","ref":"SoftBank.Repo.html#aggregate/3"},{"type":"function","title":"SoftBank.Repo.aggregate/4","doc":"","ref":"SoftBank.Repo.html#aggregate/4"},{"type":"function","title":"SoftBank.Repo.all/2","doc":"","ref":"SoftBank.Repo.html#all/2"},{"type":"function","title":"SoftBank.Repo.checked_out?/0","doc":"","ref":"SoftBank.Repo.html#checked_out?/0"},{"type":"function","title":"SoftBank.Repo.checkout/2","doc":"","ref":"SoftBank.Repo.html#checkout/2"},{"type":"function","title":"SoftBank.Repo.child_spec/1","doc":"","ref":"SoftBank.Repo.html#child_spec/1"},{"type":"function","title":"SoftBank.Repo.config/0","doc":"","ref":"SoftBank.Repo.html#config/0"},{"type":"function","title":"SoftBank.Repo.default_options/1","doc":"","ref":"SoftBank.Repo.html#default_options/1"},{"type":"function","title":"SoftBank.Repo.delete/2","doc":"","ref":"SoftBank.Repo.html#delete/2"},{"type":"function","title":"SoftBank.Repo.delete!/2","doc":"","ref":"SoftBank.Repo.html#delete!/2"},{"type":"function","title":"SoftBank.Repo.delete_all/2","doc":"","ref":"SoftBank.Repo.html#delete_all/2"},{"type":"function","title":"SoftBank.Repo.disconnect_all/2","doc":"A convenience function for SQL-based repositories that forces all connections in the\npool to disconnect within the given interval.\n\nSee `Ecto.Adapters.SQL.disconnect_all/3` for more information.","ref":"SoftBank.Repo.html#disconnect_all/2"},{"type":"function","title":"SoftBank.Repo.exists?/2","doc":"","ref":"SoftBank.Repo.html#exists?/2"},{"type":"function","title":"SoftBank.Repo.explain/3","doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar\ndepending on the adapter to obtain statistics for the given query.\n\nSee `Ecto.Adapters.SQL.explain/4` for more information.","ref":"SoftBank.Repo.html#explain/3"},{"type":"function","title":"SoftBank.Repo.get/3","doc":"","ref":"SoftBank.Repo.html#get/3"},{"type":"function","title":"SoftBank.Repo.get!/3","doc":"","ref":"SoftBank.Repo.html#get!/3"},{"type":"function","title":"SoftBank.Repo.get_by/3","doc":"","ref":"SoftBank.Repo.html#get_by/3"},{"type":"function","title":"SoftBank.Repo.get_by!/3","doc":"","ref":"SoftBank.Repo.html#get_by!/3"},{"type":"function","title":"SoftBank.Repo.get_dynamic_repo/0","doc":"","ref":"SoftBank.Repo.html#get_dynamic_repo/0"},{"type":"function","title":"SoftBank.Repo.in_transaction?/0","doc":"","ref":"SoftBank.Repo.html#in_transaction?/0"},{"type":"function","title":"SoftBank.Repo.init/2","doc":"Dynamically loads the repository url from the\nDATABASE_URL environment variable.","ref":"SoftBank.Repo.html#init/2"},{"type":"function","title":"SoftBank.Repo.insert/2","doc":"","ref":"SoftBank.Repo.html#insert/2"},{"type":"function","title":"SoftBank.Repo.insert!/2","doc":"","ref":"SoftBank.Repo.html#insert!/2"},{"type":"function","title":"SoftBank.Repo.insert_all/3","doc":"","ref":"SoftBank.Repo.html#insert_all/3"},{"type":"function","title":"SoftBank.Repo.insert_or_update/2","doc":"","ref":"SoftBank.Repo.html#insert_or_update/2"},{"type":"function","title":"SoftBank.Repo.insert_or_update!/2","doc":"","ref":"SoftBank.Repo.html#insert_or_update!/2"},{"type":"function","title":"SoftBank.Repo.load/2","doc":"","ref":"SoftBank.Repo.html#load/2"},{"type":"function","title":"SoftBank.Repo.one/2","doc":"","ref":"SoftBank.Repo.html#one/2"},{"type":"function","title":"SoftBank.Repo.one!/2","doc":"","ref":"SoftBank.Repo.html#one!/2"},{"type":"function","title":"SoftBank.Repo.preload/3","doc":"","ref":"SoftBank.Repo.html#preload/3"},{"type":"function","title":"SoftBank.Repo.prepare_query/3","doc":"","ref":"SoftBank.Repo.html#prepare_query/3"},{"type":"function","title":"SoftBank.Repo.put_dynamic_repo/1","doc":"","ref":"SoftBank.Repo.html#put_dynamic_repo/1"},{"type":"function","title":"SoftBank.Repo.query/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query/4` for more information.","ref":"SoftBank.Repo.html#query/3"},{"type":"function","title":"SoftBank.Repo.query!/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query!/4` for more information.","ref":"SoftBank.Repo.html#query!/3"},{"type":"function","title":"SoftBank.Repo.query_many/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many/4` for more information.","ref":"SoftBank.Repo.html#query_many/3"},{"type":"function","title":"SoftBank.Repo.query_many!/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many!/4` for more information.","ref":"SoftBank.Repo.html#query_many!/3"},{"type":"function","title":"SoftBank.Repo.reload/2","doc":"","ref":"SoftBank.Repo.html#reload/2"},{"type":"function","title":"SoftBank.Repo.reload!/2","doc":"","ref":"SoftBank.Repo.html#reload!/2"},{"type":"function","title":"SoftBank.Repo.rollback/1","doc":"","ref":"SoftBank.Repo.html#rollback/1"},{"type":"function","title":"SoftBank.Repo.start_link/1","doc":"","ref":"SoftBank.Repo.html#start_link/1"},{"type":"function","title":"SoftBank.Repo.stop/1","doc":"","ref":"SoftBank.Repo.html#stop/1"},{"type":"function","title":"SoftBank.Repo.stream/2","doc":"","ref":"SoftBank.Repo.html#stream/2"},{"type":"function","title":"SoftBank.Repo.to_sql/2","doc":"A convenience function for SQL-based repositories that translates the given query to SQL.\n\nSee `Ecto.Adapters.SQL.to_sql/3` for more information.","ref":"SoftBank.Repo.html#to_sql/2"},{"type":"function","title":"SoftBank.Repo.transaction/2","doc":"","ref":"SoftBank.Repo.html#transaction/2"},{"type":"function","title":"SoftBank.Repo.truncate/1","doc":"Empty the Database Table","ref":"SoftBank.Repo.html#truncate/1"},{"type":"function","title":"SoftBank.Repo.update/2","doc":"","ref":"SoftBank.Repo.html#update/2"},{"type":"function","title":"SoftBank.Repo.update!/2","doc":"","ref":"SoftBank.Repo.html#update!/2"},{"type":"function","title":"SoftBank.Repo.update_all/3","doc":"","ref":"SoftBank.Repo.html#update_all/3"},{"type":"module","title":"SoftBank.Transfer","doc":"Transfer from one account to another.","ref":"SoftBank.Transfer.html"},{"type":"function","title":"SoftBank.Transfer.changeset/4","doc":"","ref":"SoftBank.Transfer.html#changeset/4"},{"type":"function","title":"SoftBank.Transfer.send/3","doc":"","ref":"SoftBank.Transfer.html#send/3"},{"type":"extras","title":"Softbank","doc":"# Softbank\n\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/soft_bank/)\n[![Hex.pm](https://img.shields.io/hexpm/dt/soft_bank.svg)](https://hex.pm/packages/soft_bank)\n[![License](https://img.shields.io/hexpm/l/soft_bank.svg)](https://github.com/mithereal/ex_softbank/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/mithereal/ex_softbank.svg)](https://github.com/mithereal/ex_softbank/commits/master)\n[![Build Status](https://circleci.com/gh/mithereal/ex_softbank.svg?style=svg)](https://github.com/mithereal/ex_softbank)\n\n**A Soft Bank To Handle your Financial Accounts**\n\n***This Module has the following banking functions available***\n\nAccount Management ( a genserver that acts as the gateway between you and your accounts backed by a double entry accounting system )\n\nCurrency Conversion ( with auto update on conversion rates )\n\nCustom Currencies ( added to the accounting system automatically)\n\nTransfers(the producers send amount will be converted to match the recievers account currency type)","ref":"readme.html"},{"type":"extras","title":"Installation - Softbank","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `soft_bank` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:soft_bank, \">= 0.0.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Creating the Database Tables - Softbank","doc":"The Database Tables can be created by running the mix alias.\n\n```elixir\nmix install\n```","ref":"readme.html#creating-the-database-tables"},{"type":"extras","title":"Config - Softbank","doc":"Add the following to your config.exs\n```elixir\nconfig :soft_bank, :ecto_repos, [SoftBank.Repo]\n\nconfig :ex_money,\n  exchange_rates_retrieve_every: 300_000,\n  api_module: Money.ExchangeRates.OpenExchangeRates,\n  callback_module: Money.ExchangeRates.Callback,\n  exchange_rates_cache_module: Money.ExchangeRates.Cache.Ets,\n  preload_historic_rates: nil,\n  retriever_options: nil,\n  log_failure: :warn,\n  log_info: :info,\n  log_success: nil,\n  json_library: Jason,\n  default_cldr_backend: SoftBank.Cldr\n\nconfig :ex_cldr,\n  json_library: Jason\n```\n\nAdd the following to your dev and/or prod config\n```elixir\nconfig :soft_bank, :ecto_repos, [SoftBank.Repo]\n\nconfig :soft_bank, SoftBank.Repo,\n  adapter: Ecto.Adapters.Postgres,\n  username: \"postgres\",\n  password: \"postgres\",\n  database: \"softbank_dev\",\n  hostname: \"localhost\",\n  pool_size: 10\n  #primary_key_type: :id\n```\n\n## (Optional) Generate a `setup_softbank_tables` migration\n```elixir\nmix SoftBank.install\n```","ref":"readme.html#config"},{"type":"extras","title":"Usage - Softbank","doc":"```elixir\n# login to your account and return the balance\nmy_account_hash = \"account_hash\"\nmy_account_number = \"from-acct-number\"\nto_account_number = \"to-acct-number\"\nSoftBank.login(my_account_hash)\n\namount = Money.new :USD, 10\nSoftBank.deposit(amount,my_account_number)\nSoftBank.withdrawl(amount,my_account_number)\nSoftBank.transfer(amount,my_account_number,to_account_number)\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/soft_bank](https://hexdocs.pm/soft_bank).","ref":"readme.html#usage"},{"type":"extras","title":"Credits - Softbank","doc":"* Fuentes by davidkuhta https://github.com/davidkuhta/fuentes","ref":"readme.html#credits"},{"type":"extras","title":"Reason For Package - Softbank","doc":"thx to the owner of the excellent fuentes package upon which this was based i needed the ability to handle multiple accounts currencys and cldr, this is what it morphed into.\nfuentes had some build problems when i used it but it was long ago, and i was living outdoors at the time it served as good refresher for the elixir language.","ref":"readme.html#reason-for-package"}],"content_type":"text/markdown"}